Jmol.___JmolDate="$Date: 2025-08-08 04:46:51 -0500 (Fri, 08 Aug 2025) $"
Jmol.___fullJmolProperties="src/org/jmol/viewer/Jmol.properties"

# THIS IS THE TRUNK - for development and release


# Developers: to add a description of changes you have made,
#  add it on a line below the "Jmol.___JmolVersion=..." line.
#  Don't use Jmol.___ in your text, as that is the key for stripping out
#  the information saved in the JAR version of this file.
#  The quotes above	 look odd for a parameter file, but they are 
#  important for the JavaScript version of Jmol.
#
# A full Jmol/JSpecView/JSmol release requires the following:
#
# 1. Generate a new version number. This should be done as in the following examples, 
#    listed in order of appearance:
#
#    previous     new
#
#    14.8.10  14.8.11-beta-2016-12-20 a beta release of 14.8.11 with a timestamp for Dec 20, 2016
#    14.8.10  14.8.11                 bug fixes only - patch level
#    14.8.10  14.9.1                  new features - minor version level (tag for Maven, create branch)
#    14.8.10  15.1.1                  new features - major version level (tag for Maven, create branch)
#
#  The distinction between major and minor is arbitrary.
#
#  Note that -beta releases will be to https://sourceforge.net/projects/jmol/files/Jmol-beta
#  while full releases will be to https://sourceforge.net/projects/jmol/files/Jmol.
#
# 2. Create a new Jmol.___... line and remove "Jmol.___" from the line for the
#    previous release; failure to do remove this line will use the original release number, 
#    not the new one, since this is a property file.
#
# 3. If this is legacy Jmol (SourceForge) run the Ant task build-1-unzip-jsmol-to-site.xml
#     and then do a clean build of the project (Eclipse Project...clean...Jmol)
#
# 4. You should be able to test the JavaScript in JSmol.htm in the /site directory. 
#
# 5. Now run build-2-jsmol.zip.xml to create the full jsmol.zip file in the appletweb/ folder.
#    This creates the compressed files; you can test now the HTML in the site/jsmol directory.
# 
# 6. Run jmol build.xml (including dist, which also initiates a release now)
#
# 7. For legacy Jmol, you will have to go to SourceForge and manually create 
#    a new release directory and drop the three zip files and this jmol.propertiese file into it. 
#    They will be in the build/release/version... subfolder 
#    (or figure out how to do that with a private key, because I couldn't)
#
# TODO: fix UNDO
# TODO: check RN=X=NR stereo# TODO: should suppress painting during adding of hydrogens
# TODO: SMILES adding a stereocenter if the preceding chain matches a future chain.
# FEATURE REQUEST: dock/undock consoles to main window.
# TODO: allow FIXED to work with MODELKIT MINIMIZE

Jmol.___JmolVersion="16.3.33" // (legacy) also 16.3.34 (swingJS) 

bug fix (legacy only): PyMOL putty rendering broken in 16.3.15 (2025.04.10)

bug fix (JSpecView, for IUPAC FAIRSpec only): JDX header delivery incomplete

new feature: format("STRING", ";base64,MSwyLWJpcygzLWNobG9yby00LDUtZGltZXRob3h5cGhlbnlsKWV0aGFuZS56aXA=")
  -- decodes base64 string 
  -- in this case, giving "1,2-bis(3-chloro-4,5-dimethoxyphenyl)ethane.zip"

JmolVersion="16.3.31" // (legacy) also 16.3.32 (swingJS) 

bug fix: incommensurately modulated magnetic CIF file reading issues

bug fix: COMPARE failing
 -- for example:
        load "=3HG5";
        compare {*:A or :C} {*:B or :D} SUBSET{*.CA} ATOMS ROTATE TRANSLATE 2.0;

bug fix: {a}.distance.min({b}) not working
 -- for example:
        load "=3HG5"
        compare {*:A or :C} {*:B or :D} SUBSET{*.CA} ATOMS ROTATE TRANSLATE 2.0
        x= {:A.CA}.distance.min({:B.CA})
        {:A.CA}.property_d = x
        {:B.CA}.property_d = x
        color property_d
        backbone -0.3
    
new feature: set defaultDrawArrowScale -x.x
 -- negative value scales the arrow head width instead of length
 
 -- for example:
      draw width 0.2 vector {0 0 0} {1 1 1};
      set defaultDrawArrowScale -0.67;
 

JmolVersion="16.3.29" // (legacy) also 16.3.30 (swingJS) 

bug fix: removing ",z" from plane and frieze group operations listing and drawing

bug fix: minor issues with FINDSPACEGROUP JSON->spinCIF conversion and reading spinCIF files


JmolVersion="16.3.27" // (legacy) also 16.3.28 (swingJS) 

bug fix: jsmol.js (legacy only) problem with incomplete initialization of applet gives 0-size image error
 
bug fix: CIF reading and processing of operations can fail with 2/3+x rather than the usual x+2/3

new feature: spinCIF and FINDSPINGROUP output readers
 -- 
note: use of variables starting with $ is not documented. 
    These are object references
        draw ID d... : 
          $d the center of this drawing
          $d[1] the first point
        for example:
            $ draw id p plane {0 0 0} {1 1 1} {1 0 0}
            $ print $p
              {0.75 0.25 0.25}
            $ print $p[1]
              {0.0 0.0 0.0}
            $ print $p[2]
              {1.0 1.0 1.0}
            $ print $p[3]
              {1.5 0.5 0.5} 
            $ draw id p symop 3
              print $p
            
new feature: symop(@2, "basis") or symop(@@2, "basis") {1.1}.symop(@2)
 -- returns the single-atom bitset of the basis atom for this atom
    (the first atom that is symmetry-equivalent with this atom, as part
    of the asymmetric unit)
 -- optional choice of specific model (@@2 for current)
 -- essentially the same as {this && site=@{@@2.site}}[1] but simpler
 -- the {1.1}.symop(@2) form is useful if checking a model that is not the current one
     
new feature: symop(@@2, "cif2")
 -- returns a simple CIF-2 format descriptor of all operations that 
    transform the basis atom for the site to this atom's position
    with the specific translation needed, in the form:
    
     <id> [tx ty tz] 
    
    For example, 
    
    $ load =ams/quartz 1 packed
    $ print symop(@@3, "cif2")

        2 [0 0 0]
        3 [0 0 0]
        
new feature: atom.spin
 -- for spin space groups only
 -- reports the index (1-based) of the spin operation for this atom

new feature: _M.spinList
 -- list of spin operations (such as "u,-v,w") 
 -- _M.spinList[atom.spin] gets the operation string. 
 -- This list is collected during processing of the spinCIF file.
 
bug fix: SMARTS searching not distinguishing /open/ from /openstrict/ properly
 -- /open/ should not check aromatic ring planarity, while /openstrict/ should.
 -- SMARTS options include:
 
    Jmol 0D: (not settable)  just check bonding; no planarity issue in 0D (that is, SMARTS against SMILES)
    Jmol default 3D: /strict/ check bonding and planarity, using "chemist's" Hueckel rules
    OpenSMILES 0D or 3D: /open/, just check bonding using OpenSMILES Hueckel rules; 
    OpenSMILES 3D: /openstrict/ check bonding and planarity, using OpenSMILES Hueckel rules
    turn off aromaticity checks: /noaromatic/ -- just disregard aromatic aspects entirely


JmolVersion="16.3.25" // (legacy) also 16.3.26 (swingJS) 

bug fix: symop(3,"array") should return .draw script with id "sym_", not "array"
 
bug fix: spin space group loading updated for too many atoms
 
new feature: PNG, JPG and JPG64 image encoders allow for specified DPI (dots per inch)
 -- indicated quality > 90 is interpreted as DPI
 -- PNG values from 1-9 are still (rarely used?) compression options (2 is default for 9 < quality < 90)
 -- JPG values from 1-90 are still JPG image quality 
       (default 100 - "highest quality" for JPG; 75 for JPG64)
 -- quality as DPI sets the quality to its default value
 -- default DPI is now 300 dpi
 -- quality comes after any image size indication
 -- for example:
 
  write PNGJ 600 "xxxx.png" 
  
        OK PNGJ 126817 xxxx.png; quality=2; DPI=600; width=797; height=558
        
  write IMAGE 300 400 600 "t.jpg"

        OK JPG 65864 t.jpg; quality=100; DPI=600; width=300; height=400

new feature: spinop(3,"uvw")
 -- generates spin-operator u,v,w string format
 
new feature: x = matrix(stringMatrix) 
 -- allows stringMatrix to contain functions and math expressions
 -- used in spinCIF reader: 
 
   mh2c = matrix("[[1,1/sqrt(3),0],[0,2/sqrt(3),0],[0,0,1]]");
  
new feature: delay (seconds or milliseconds) scriptToRun
 -- adds optional script to run after this time
 -- halts  currently running script
 
new feature: x = matrix(axis,angle)
 -- generates the transformation matrix associated with an axis-angle (angle in degrees)
 
new feature: VASP POSCAR reader reads # MAGMOM line for magnetic moments
 -- feature of files created by FINDSYMGROUP

JmolVersion="16.3.23" // (legacy) also 16.3.24 (swingJS) 

bug fix: load *xxxx should use lower case for retrieving mmCIF files from PDBe.

bug fix: struts do not connect directly to rockets or trace

bug fix: write OBJ does not create rockets or vectors

new feature: BCIF, mmCIF, and MMTF file readers auto-detect carbohydrate residues
 -- uses _chem_comp.type containing "saccharide" 
 -- for example:
  
      load *3kle
      select carbohydrate
      print {selected}.group.pivot.keys.join(",")

        GLC,Z9N
 
new feature: getProperty("cifInfo", fname+ ";keys=tag1,tag2,tag3...")
 -- retrieve CIF file structure for only specific tags
 -- now exits parsing once all loop data for the given tags are found
 -- avoids memory overflow in very large mmcif files
 -- must be complete tags (partial tags can also be found, but won't close reading) 
 -- for example:

        cifinfo = getProperty("cifInfo", "*3kle;keys=_chem_comp.id,_chem_comp.type,_chem_comp.name" ).models[1];

new feature: array.find(regex, "index")
 -- carries out a REGEX pattern search within an array of strings
 -- returns an array of indexes (1-based) of elements found with this string
 -- for example:
 
        cifinfo = getProperty("cifInfo", "*3kle;keys=_chem_comp.id,_chem_comp.type,_chem_comp.name" ).models[1];
        ccids = cifinfo._chem_comp_id; // NAG
        cctypes = cifinfo._chem_comp_type; // saccharide
        ccnames = cifinfo._chem_comp_name; // N-Acetyl...
        list = cctypes.find("saccharide", "index");
        for (var j in list) {
           print ccids[j] + " " + ccnames[j]
        }
        
            GLC alpha-D-glucopyranose
            Z9N alpha-D-fructofuranose
        
new feature array.find(regex,"i|m|v", "index")
 -- carries out a REGEX pattern search
 -- using "i" (case-insenstive) or "m" (match) or "v" (not-present) or some combination of these
 -- adding "index" returns the index of element
 -- for example:  

        $ a = ["Alpha", "Beta", "gamma"]
        $ print a.find("A").join(",")
        
          Alpha
        
        $ print a.find("A","i").join(",")
        
          Alpha,Beta,gamma
        
        $ print a.find("A","i", "index").join(",")
        
          1,2,3


JmolVersion="16.3.21" // (legacy) also 16.3.22 (swingJS) 

bug fix: PDBe *xxxx should not require lower case entry

bug fix: (Legacy JavaScript only) array sorting may fail in script saving.

new feature: more spin space group support
 - adds     _space_group_spin.rotation_axis_xyz
   same as  _space_group_spin.rotation_axis
 - adds support for spin frame with reciprocal lattice a*, b*, c*
   limitation: any x* in expression turns all x into x*
   
new feature: CIF loader for magnetic structures adds filter "spinonly"
 - only atoms that have spin are read
 
new feature: matrix.array() same as matrix.array

new feature: point(arrayOfArrays) produces array of points

bug fix: OBJ/MTL exporter has inverted Tr (translucency) setting x; should be 1-x

bug fix: Cartesian exporters (IDTF, Maya, OBJ, VRML) not rendering vector cylinders


JmolVersion="16.3.19" // (legacy) also 16.3.20 (swingJS) 

bug fix: (JavaScript legacy only) array sorting fails for arrays of arrays and sort(columnNumber);

bug fix: !(atomset) fails to recognize that some atoms 
         may have been deleted.

new feature: CIF loader for magnetic structures adds filter "spinonly"
 - only atoms that have spin are read
 
new feature: more spin space group support
 - adds     _space_group_spin.rotation_axis_xyz
   same as  _space_group_spin.rotation_axis
 - adds support for spin frame with reciprocal lattice a*, b*, c*
   limitation: any x* in expression turns all x into x*
   
new feature: matrix.array() same as matrix.array

new feature: point(arrayOfArrays) produces array of points

new feature: spinCIF reading of formulas sqrt, cos, sin, tan in spin descriptions


JmolVersion="16.3.17" // (legacy) also 16.3.18 (swingJS) 

new feature: load filter "biomolecule 1;bmchains=_"
 -- underscore indicates to generate new chain IDs by appending a number prefixed with '_'
 -- prevents ambiguity of C becoming "C1" and C1 already being present (1o0u, though in this case
   there are no added chains)
   
 $ load *1auy filter "biomolecule 1;bmchains=_"
 $ print this.chains.pivot.keys.join(" ")

   A A_1 A_10 A_11 A_12 ... C_7 C_8 C_9

bug fix:  select bonds @x doesn't accept an array variable
 -- where x is an array, perhaps from 
 
        x = getProperty("bondinfo").select("(_bpt) where color='[xffff00]'")

 -- really the only way to select bonds programmatically efficiently
 -- previously, this could only be a literal array, with brackets:
 
        select bonds [2,3,4]
        
new feature: CIF reader updates support for magnetic spin space groups (SSGs) "spinCIF" format
 -- reads the following (provisional) spinCIF tags:
 
    _atom_site_spin_moment.axis_u
    _atom_site_spin_moment.axis_v
    _atom_site_spin_moment.axis_w
    _atom_site_spin_moment.label
    _atom_site_spin_moment.magnitude
    _atom_site_spin_moment.symmform_uvw
    _space_group_spin.collinear_direction_xyz
    _space_group_spin.coplanar_perp_uvw
    _space_group_spin.coplanar_perp_xyz
    _space_group_spin.coplanar_plane_rotation_angle
    _space_group_spin.name_SpSG_Chen
    _space_group_spin.number_SpSG_Chen
    _space_group_spin.rotation_angle
    _space_group_spin.rotation_axis_xyz
    _space_group_spin.transform_spinframe_P_abc
    _space_group_symop_spin_lattice.id
    _space_group_symop_spin_lattice.uvw
    _space_group_symop_spin_lattice.xyz
    _space_group_symop_spin_operation.id
    _space_group_symop_spin_operation.uvw
    _space_group_symop_spin_operation.xyz
  
new feature: ROTATE VECTORS axis degrees
 -- rotates magnetic structure magnet moments about the given axis (just a single point) the specified number of degrees
 -- optional axis, rotates using the axis specified in the CIF file
    or {0 0 1} if no axis from:
    
    _space_group_spin.coplanar_perp_uvw
    _space_group_spin.rotation_axis_xyz

 -- also works with magCIF files
 
new feature: SPIN VECTORS axis degrees
 -- same as ROTATE VECTORS, but starts the vectors spinning
 -- canceled with any ROTATE VECTOR command or RESET VECTORS or SPIN OFF
    
new feature: RESET VECTORS
 -- resets magnetic structure magnetic moment rotation to the original in a CIF file
 -- operates on the current model only
 -- same as rotate VECTORS (with on additional parameters)


JmolVersion="16.3.15" // (legacy) also 16.3.16 (swingJS) 
[this version was re-posted to SourceForge to remove the pickle file logging to c:/temp/pse/pickle.log]

bug fix: PyMOL reader upgrade to handle many more features.
 - sphere/stick logic conforms to PyMOL 3.0
 - may not be perfect, but it is very close to perfect
 - better multiple bonds, supporting valence, stick_valence_scale, stick_h_scale, 
 - better spheres, supporting stick_ball, stick_ball_ratio, stick_radius
 - better support for multiple molecules in multiples states (Jmol frames)
 - better support for PyMOL Compiled Graphic Object (CGO) meshes 
 - many thanks to Joel Sussman and Jaime Prilusky for test PSE files

JmolVersion="16.3.13" // (legacy) also 16.3.14 (swingJS) 

bug fix: MODELKIT command does not work in JmolData.jar or JmolDataD.jar

bug fix: JSmol broken in 16.3.12

JmolVersion="16.3.11" // (legacy) also 16.3.12 (swingJS) 

bug fix: CIF reader broken for older _symmetry_equiv_pos_as_xyz key in 16.3.9/10

bug fix: abs(x) where x is an integer just returns x.

bug fix: load from PubChem fails for inchi
 - for example: 
	$ load :inchi:InChI=1S/CH3NO/c2-1-3/h1H,(H2,2,3)    

bug fix: CLEG should allow reference Hall symbol with setting change:
 - for example:
 
    modelkit zap spacegroup "[-C 2c 2]:a,-c,b"
    print spacegroup().spaceGroupInfo.hm == "B m m b"

bug fix: assigning formal charge to an aromatic atom fails after atom deletion

new feature: (Java and JavaScript) inchiString.inchi("smiles") converts InChI to SMILES. 
 -- utilizes JNA-Inchi structure created from an InChI to generate SMILES strings. 
 -- net effect is that InChI strings can be converted to structures via SMILES. 
 -- passes tetrahedral, cumulene, and alkene stereochemistry tests
 -- InChI does not implement atropisomer stereochemistry
 -- InChI created using {*}.inchi("FixedH") will differentiate tautomers

new feature: {*}.inchi("standard").smiles() will correct for amides
 - returns amide, NC(=O)R, not imidol, N=C(O)R from InChI

new feature: {*}.inchi("standard").smiles("fixedh")
 - returns inchi-priority tautomer (imidol, N=C(O)R, not amide, NC(=O)R, for example)

new feature: Java inchi upgraded to 1.07.2
 - incorporates jna-inchi-1.4-SNAPSHOT.jar
 - Thank you, David Lowe, John Mayfield, et al.!
 
new feature: this.inchi("version")
 - reports internal inchi version from WASM/JavaScript or JNA/Java
 - finds the C string for inchi C mode_h definition APP_DESCRIPTION 
   in the native inchi library currently in use
 - at this time, Java reports:
     InChI version 1, Software 1.07.2 (API Library)
 - at this time, JavaSript reports:
     InChI version 1, Software 1.07.2 (inchi-1 executable)
 
new feature: this.color = "green" and all.color = "green"
 - use of "this" and "all" extended to same context as general 
   context of user-defined variables.   

JmolVersion="16.3.9" // (legacy) also 16.3.10 (SwingJS)

bug fix: lcaocartoon @4 LONEPAIR "lp" not displaying dots
bug fix: lcaocartoon @4 RADICAL "lp" not displaying dots
bug fix: lcaocartoon DELETE does not delete radical or lone pair, only lobes

bug fix: early demo pages are back on line, by demand

	https://chemapps.stolaf.edu/jmol/docs/examples-10.2/new.htm
	https://chemapps.stolaf.edu/jmol/docs/examples-10.3/new.htm
	https://chemapps.stolaf.edu/jmol/docs/examples-11/new.htm
	https://chemapps.stolaf.edu/jmol/docs/examples-12/new.htm

bug fix: anisotropic bonding should not be able to be set for double bonds

bug fix: unit cell with set picking dragMolecule should not allow SHIFT-DRAG (z-shift)
bug fix: unit cell with set picking dragMolecule Should allow ALT-DRAG (rotate)
bug fix: {atoms}.within("unitcell") should relate to their own model's unit cell, 
         not just the currently visible one.

bug fix: Hall description of 252:_2 (Jmol mirror of nonstandard 254:_2 found as =ams/quartz 1)
 -- was 152:a,b,c;0,0,-1/3 and p 31 2" (0 0 -4) 
 -- now 152:a,b,c;0,0,-1/3 and p 31 2" (0 0 4); 
 -- now a mirror image of quartz:
 
  load =ams/quartz 1 packed
  draw spacegroup all
  a = {*}.fx.all
  b = {*}.fy.all
  {*}.fx = b
  {*}.fy = a
  calculate spacegroup

bug fix: SpaceGroupFinder not always finding group
 -- idea of removing groups that when a   

bug fix: matrix("20>>3") fails
 -- logic bug in recursive subgroup search truncates the search early
 -- should give:
 
   $ print matrix("20>>3","map").indexPath
  20>[2]>5>[2]>3
  
  $ print matrix("230>>3","map").indexPath
  230>[3]>142>[2]>70>[2]>15>[2]>5>[2]>3
  
bug fix: show CHEMICAL INCHIKEY should not include "inchikey="

bug fix/feature change: NCI/CADD resolver inchi call
 -- switched to /file?format=stdinchi from /stdinchi
 -- problem was noticed with conversion of SMILES to InChI.

bug fix: SHOW SYMOP 3 should show same as SHOW SYMOP 4 "label"
 -- for =ams/quartz 1, should be "3(+) (0 0 -1/3) screw axis", not "null null 3(+) (0 0 -1/3) screw axis"

new feature: adds support for magnetic spin space groups (SSGs)
 - alternative to magCIF
 - reads preliminary scif ("spin CIF") files. 

new feature: load xxx.scif FILTER "spinframe=-a+b,-a-2b,c"
 - replaces value in CIF:
 _space_group_spin.transform_spinframe_Pp_abc  'a+b,-a,c' 

new feature: load filename fill SPIN
 - fills the spin frame rather than the real frame
 - just for showing spins in their frame
 - experimental
 
new feature: unitcell("spin")
 - returns the spin frame unit cell if an sCIF file was read
 
new feature: UNITCELL spin
 - returns the spin frame unit cell in [center,a,b,c] format

new feature: (JavaScript only) InChI WASM upgraded to InChI 1.07
 - switched to inchi-web.wasm, from the InChI-SwingJS project
 - allows InChI to stereochemically correct structure
 
new feature: (Java only) JNI-InChI replaced with JNA-InChI
 - maintained by Daniel Lowe and John Mayfield
 - slower than JNI, but a much simpler interface
 
new feature: {*}.smiles()
 - calculates SMILES for the selected atoms

new feature: <b>this</b> or <b>this.x</b>
 - similar to <b>all</b>, but limited to only atoms in frames currently visible
 - same as {thisModel}.x (which still may be more than one model)
 
new feature: (JmolSwingJS only, not legacy) smilesString.inchi("ocl")
 - uses the OpenChemLibrary to directly convert smiles strings to InChI. 
 - legacy still uses NCI/CADD CIR

new feature: {*}.inchi("model") or smiles.inchi("model") or inchi.inchi("model")
 - returns a map of the internal InChI ouput model, include keys "atoms", "bonds", and "stereo"
 - If {*} or SMILES is used, this model will have 3D coordinates
 - If a SMILES string is used, a MOL file equivalent will be created from 

new feature: {*}.inchi("ocl model") or smiles.inchi("model") or inchi.inchi("model")
 - returns a map of the internal InChI ouput model, include keys "atoms", "bonds", and "stereo"
 
new feature: matrix4.rxyz
 -- 3x4 (rotation|translation) representation of 4x4 rotation-translation matrices
 -- generates rational fractions only for exact 48ths; other values are left as decimals
 -- works with symop() when result is a 4x4 matrix or a list of 4x4 matrices   

$ print matrix("x,y,z;1/2,1/3,1/4")
[
  [1.0  0.0  0.0  0.5]
  [0.0  1.0  0.0  0.3333333333333333]
  [0.0  0.0  1.0  0.25]
  [0.0  0.0  0.0  1.0] ]
$ print matrix("x,y,z;1/2,1/3,1/4").rxyz
(
  1    0    0  |   1/2
  0    1    0  |   1/3
  0    0    1  |   1/4
)

$ load =ams/quartz 1 packed
$ print symop(3, "xyz")
-y,x-y,z-1/3
$ print symop(3).rxyz
(
  0   -1    0  |    0
  1   -1    0  |    0
  0    0    1  |  -1/3
)


new feature: matrix(...,"rxyz")
  -- same as matrix(...).rxyz 

$ print matrix("x,x-y,z;1/2,1/3,1/4", "rxyz")
(
  1    0    0  |   1/2
  1   -1    0  |   1/3
  0    0    1  |   1/4
)

new feature: symop(...,"rxyz")
  -- same as symop(...).rxyz
  
$ load =ams/quartz 1 packed
$ print symop(3, "xyz")
-y,x-y,z-1/3
$ print symop(3, "rxyz")
(
  0   -1    0  |    0
  1   -1    0  |    0
  0    0    1  |  -1/3
)

JmolVersion="16.3.7" // (legacy) also 16.3.8 (SwingJS)

new feature: PLY surface exporter
 -- both ascii and binary (little-endian)
 -- example:
 
	load $caffeine
	isosurface molecular map mep
	write isosurface "c:/temp/t.ply"
	write isosurface "c:/temp/t-bin.ply" as PLB
	isosurface slab none slab within 3 @4
	write isosurface "c:/temp/tslab.ply"
	write isosurface "c:/temp/tslab.ply" as PLB

new feature: {*}.find("SMILES/ALL")   
 -- default for Jmol is to provide SMILES for just the first 
    covalently bonded component in the atom set. 
    the ALL option includes all molecular entities.

bug fix: OBJ surface exporter fails to write .mtl file

bug fix: SELECT search(...) broken in 16.3.6

bug fix: script console should allow [UP-ARROW] return to DATA command
   
bug fix: CDX/CDXML reader should read "bold" bond as single, not 0

bug fix: CDX/CDXML reader does not read square-bracketed repeat counts

bug fix: MOL writer should ouput "either" stereochemistry

bug fix: MOL writer output for "FAR" bond should be "6" not "3"

bug fix: ZIP file reader in Java may fail on some (improperly formed) ZIP files

bug fix: Bond type "either" can also be of use in 3D, not just 2D
 -- for example, when reading a CDX or CDXML file with "EITHER" indicated, 
    we can still track that origin after conversion to 3D and not show 
    stereochemistry at that atom in SMILES or InChI.

new feature: load DATA with base64-encoded data starting with ";base64,"
 -- loads model data that is base64 encoded
 -- can be binary data such as CDX or ASCII such as MOL
 -- for example (loads quartz model as encoded CIF file):

load data "model"
;base64,ZGF0YV9nbG9iYWwKX2NlbGxfbGVuZ3RoX2EgNC45MTYKX2NlbGxfbGVuZ3RoX2IgNC45MTYKX2NlbGxfbGVuZ3RoX2MgNS40MDU0
Cl9jZWxsX2FuZ2xlX2FscGhhIDkwCl9jZWxsX2FuZ2xlX2JldGEgOTAKX2NlbGxfYW5nbGVfZ2FtbWEgMTIwCl9zeW1tZXRyeV9z
cGFjZV9ncm91cF9uYW1lX0gtTSAnUCAzMiAyIDEnCmxvb3BfCl9zcGFjZV9ncm91cF9zeW1vcF9vcGVyYXRpb25feHl6CiAgJ3gs
eSx6JwogICd5LHgsMi8zLXonCiAgJy15LHgteSwyLzMreicKICAnLXgsLXgreSwxLzMteicKICAnLXgreSwteCwxLzMreicKICAn
eC15LC15LC16Jwpsb29wXwpfYXRvbV9zaXRlX2xhYmVsCl9hdG9tX3NpdGVfZnJhY3RfeApfYXRvbV9zaXRlX2ZyYWN0X3kKX2F0
b21fc2l0ZV9mcmFjdF96ClNpICAgMC40Njk3MCAgIDAuMDAwMDAgICAwLjAwMDAwCk8gICAwLjQxMzUwICAgMC4yNjY5MCAgIDAu
MTE5MTAK
end "model" packed
   
new feature: DATA "model";base64,...end "model"
 -- same as LOAD DATA, but does not allow for 
    load parameters
 -- loads model data that is base64 encoded
 -- can be binary data such as CDX or ASCII such as MOL
 -- for example (loads cyclohexanol as encoded CDX file):
 
data "model"
;base64,VmpDRDAxMDAEAwIBAAAAAAAAAAAAAACAAAAAAAMAFgAAAENoZW1EcmF3IDIyLjIuMC4zMzAwCAAHAAAAdC5jZHgEAhAAIuJYAGlC
jQCzFpoAhtLmAAEJCAAAAAAAAAAAAAIJCAAAAOsBAACUAwAJAAANCAEAAQgHAQABOgQBAAE7BAEAAEUEAQABPAQBAABKBAEAAAwG
AQABDwYBAAENBgEAAEIEAQAAQwQBAABEBAEAAAoICAADAGAAyAADAAsICAAUAAAA8AADAAkIBAAzswIACAgEAAAAAgAHCAQAAAAB
AAYIBAAAAAQABQgEAAAAHgAECAIAeAADCAQAAAB4ACMIAQAFDAgBAAAoCAEAASkIAQABKggBAAEyCAEAACsIAQAoLAgBAAoCCBAA
AAAkAAAAJAAAACQAAAAkAAEDAgAAAAIDAgABAAADMgAIAP///////wAAAAAAAP//AAAAAP////8AAAAA//8AAAAA/////wAAAAD/
////AAD//wABJAAAAAIAAwDkBAUAQXJpYWwUAOQEDwBUaW1lcyBOZXcgUm9tYW4ACHgAAAMAAAJYAlgAAAAAGPwTIP+a/5oZYhOG
A2cFKAP8AAIAAAJYAlgAAAAAGPwTIAABAAAAZAAAAAEAAQEBAAAAAScPAAEAAQAAAAAAAAAAAAAAAAACABkBkAAAAAAAYAAAAAAA
AAAAAAEAAAAAAAAAAAAAAAAAAAAAtAsCAAAAtQsUAAAAQ2hlbWljYWwgRm9ybXVsYTogtgsOAAAARXhhY3QgTWFzczogtwsUAAAA
TW9sZWN1bGFyIFdlaWdodDoguAsHAAAAbS96OiC5CxYAAABFbGVtZW50YWwgQW5hbHlzaXM6ILoLEQAAAEJvaWxpbmcgUG9pbnQ6
ILsLEQAAAE1lbHRpbmcgUG9pbnQ6ILwLEQAAAENyaXRpY2FsIFRlbXA6IL0LEQAAAENyaXRpY2FsIFByZXM6IL4LEAAAAENyaXRp
Y2FsIFZvbDogvwsQAAAAR2liYnMgRW5lcmd5OiDACwkAAABMb2cgUDogwQsGAAAATVI6IMILDwAAAEhlbnJ5J3MgTGF3OiDDCxAA
AABIZWF0IG9mIEZvcm06IMQLCAAAAHRQU0E6IMcLCAAAAExvZ1M6IMgLBwAAAHBLYTogyQsCAAAAygsCAAAACwwCAAEACgwBAAAJ
DAEAAAwMBQAAACgjKQGAFwAAAAQCEAAAAAAAAAAAAAAA0AIAABwCFggEAAAAJAAYCAQAAAAkABkIAAAQCAIAAQAPCAIAAQADgAUA
AAAEAhAAIuJYAGlCjQCzFpoAhtLmAAoAAgAEAASAAgAAAAACCAAAgGwA7MSNAAoAAgABADcEAQABAAAEgAQAAAAAAggAAICKAOzE
jQAKAAIAAwA3BAEAAQAABIAGAAAAAAIIAACAmQAAwKcACgACAAUANwQBAAEAAASACAAAAAACCAAAgIoAE7vBAAoAAgAHADcEAQAB
AAAEgAoAAAAAAggAAIBsABO7wQAKAAIACQA3BAEAAQAABIAMAAAAAAIIAACAXQAAwKcACgACAAsANwQBAAEAAASAFAAAAAACCAD/
f10AJrbbAAoAAgATAAIEAgAIACsEAgABAEgEAAA3BAEAAQaAAAAAAAACCABmZmEAhtLXAAQCEAAi4lgAhtLXAP9/YQCG0uYAIwgB
AAACBwIAAAAFBwEAAQAHDgABAAAAAwBgAMgAAABPSAkHDgABAAAAAwBgAMgAAABPSAAAAAAFgA4AAAAKAAIADQAEBgQAAgAAAAUG
BAAEAAAACgYBAAEAAAWADwAAAAoAAgAOAAQGBAAEAAAABQYEAAYAAAAKBgEAAQAABYAQAAAACgACAA8ABAYEAAYAAAAFBgQACAAA
AAoGAQABAAAFgBEAAAAKAAIAEAAEBgQACAAAAAUGBAAKAAAACgYBAAEAAAWAEgAAAAoAAgARAAQGBAAKAAAABQYEAAwAAAAKBgEA
AQAABYATAAAACgACABIABAYEAAwAAAAFBgQAAgAAAAoGAQABAAAFgBUAAAAKAAIAFAAEBgQACgAAAAUGBAAUAAAACgYBAAEAAAAA
AAAAAAAA 
end "model"

JmolVersion="16.3.5" // (legacy) also 16.3.6 (SwingJS)

bug fix: Jmol doesn't recognize WSL (Windows Subsystem for Linux) protocols
  -- this protocol allows access from Windows to 
     a linux subsystem file, both for reading and writing
  -- load "//wsl$/Ubuntu/home/user1/test.mol"
  -- write "file://wsl$/Ubuntu/home/user1/test2.mol"
  
bug fix: write Jmol doesn't accept proper Windows file:// descriptions
  -- vertical bar in place of colon -- "file:///C|/temp/t3.mol"

bug fix: SHOW SPACEGROUP <n> does not work
  -- just noting that this function reports Jmol's 
     space group operations as calculated from Hall 
     symbols. These may be in a different order than
     those found at the BCS. For the BCS listing, use 
     
     print spacegroup(n)
     
	 where n is 1-230 or a Hermann-Mauguin name or 
	 "hall:xxx	" where xxx is Hall symbol, as in
	 
	 print spacegroup("hall:P 2 -2bc")
	 
	 or a list of operations, such as 
	 
	 print spacegroup("x,y,z;x,y,-z")
	 
	 

new feature: SHOW SPACEGROUP NAMES
 -- displays the list of 230 space group names
 -- opens https://www.cryst.ehu.es/cgi-bin/cryst/programs/nph-getgen
 -- see also SHOW SPACEGROUP LIST


JmolVersion="16.3.3" // (legacy) also 16.3.4 (SwingJS)

new feature: x = matrix("")
 -- returns matrix for current model
 
new feature: modelkit ... spacegroup ""
 -- uses current space group for the command

bug fix: JmolData.jar and Jmol.jar -x or -nx or -n do not allow CAPTURE
 -- this fix enables CAPTURE even with nodisplay (-n) or with autoexit (-x)
 -- recommend also adding -o so you can follow what is happening
 -- note that JmolData.jar is MUCH MUCH faster than Jmol.jar -nx
 -- no GUI necessary
 -- for example
		java -jar JmolData.jar -J "load t.mol;capture 'ts.gif' spin;"
      
bug fix: Jmol starting up with Java 11 can fail to start
 -- removing dependency on sun.awt.image.TookKitImage
  
bug fix: MODELKIT SPACEGROUP p/3 should work without quotes

bug fix: DRAW SPACEGROUP   for planar group should shorten "c" axis to just 1 angstrom

bug fix: unitcell info for plane group should not indicate c, alpha, or beta.   

bug fix: reading incommensurate CIF with subsystem broken
 
bug fix: UNITCELL @n switch for subsystem CIF broken

bug fix: MODELKIT ADD WYCKOFF ALL PACKED can add extra atoms

bug fix: SET PICKING DRAGATOM doesn't always works smoothly
         and reports "cannot move atom" while still moving it (sometimes)
 -- cases where a glide or screw translation can result in invariance
 -- specifically SG 224 Wyckoff i and plane group p/12 Wyckoff c
   

JmolVersion="16.3.1" // (legacy) also 16.3.2 (SwingJS)

note: Jmol 16.3 significantly increases Jmol's coverage in relation to 
      space groups and their related plane, layer, rod, and frieze groups.
      In particular, it represents a relatively full incorporation of the
      results at the Bilbao Crystallographic Server in relation to the
      programs GENPOS, WYCKPOS, MAXSUB, and SUBBROUPGRAPH for all of these
      group types. 
      
      Jmol 16.3 incorporates from the BCS 746 space group, 17 plane, 156 layer, 
      190 rod, and 14 frieze settings (through index 9) as well as 9947 space, 
      245 plane, 2722 layer, 1607 rod, and 125 frieze maximal group-subgroup relationships.

      Jmol 16.3 completes the development of novel 3D interactive visualizations 
      of space, plane, layer, rod, and frieze group models. 
      
      Jmol 16.3 extends the CLEG (Concise Linear Encoding of crystallographic 
      space Group settings group-subgroup relationships) to all of these group types.

      Jmol 16.3 greatly expands the matrix() method and MODELKIT SPACEGROUP
      command to allow easy calculation and visualizion of group setting and 
      group-subgroup relationships for all of these types of groups in preparation 
      for further development in the area of space group sections and projections.  

	  Jmol 16.3 provides the capability to easily calculate group-subgroup
      transformation matrices for any group setting to any other group setting, 
      not just reference settings and not just maximal subgroups. This is made 
      possible by the addition of an algorithm that systematically navigates the 
      full listing of maximal subgroups found at the BCS (for space, plane, 
      layer, rod, and frieze groups), selecting the subset of these relationships 
      specific to the request.


feature change: x = matrix("16>>3") or x = matrix("16>sub>3")
 -- finds a subgroup path from space group 16 to space group 3
 -- DOES NOT HAVE TO BE A MAXIMAL SUBGROUP
 -- unlike BCS SUBSEARCH, has the limitation that it does not include 
    iterative loops of space groups such as (16>>4>>4>>2)
 -- matrix("16>sub(depth=1)>3") returns only maximal subgroup transformations

new feature: x = matrix("16>>3", "map")
 -- return a map containing information about this transformation:
 
 	print matrix("23>>3","map")
	{
	  "cleg"  :  "23>-b-c,a,c>5>a,b,c>3"
	  "depth"  :  2
	  "index"  :  4
	  "indexPath"  :  "23>[2]>5>[2]>3"
	  "trm"  :  "-b-c,a,c"
	  "trmat"  :
	  [
	  [0.0	1.0	0.0	0.0]
	  [-1.0	0.0	0.0	0.0]
	  [-1.0	0.0	1.0	0.0]
	  [0.0	0.0	0.0	1.0] ]
	}

new feature: x = matrix("16>>3", "list")
 -- return a full listing of map information covering all possible 
    chains of subgroups leading from one group to another.
    For example, for layer group 16 to 1:
    
    print matrix("l/16>>l/1","list").select("(indexPath)")
   	
   		16>[8]>2>[2]>1
		16>[16]>12>[12]>1

new feature: x = matrix("16>>3", mapItem)
 -- convenience access to items in a listing, currently including
	  "cleg" "depth" "index" "indexPath" "trm" and "trmat"
 -- same as matrix("16>>3","list").select("(xxxx)")
 -- for example:
 
		 print matrix("l/32>>l/1","trm")

		a+b,-a,c
 
   	
new feature: x = matrix("23>sub(params)>3")
 -- (params) any combination of:
    (index=i,depth=d)
    or 
    (indexMin=i1,indexMax=i2,depthMin=d1,depthMax=d2)
 -- searches for group-subgroup relationship have having 
    the specified or specified range of index and/or 
    the specified or specified range of depth
 -- index can be mixed with depth or depthMin/Max
 -- depth can be mixed with index or indexMin/Max      
 -- depthMin/Max can be mixed with indexMin/Max   
 -- for example:
 
 
new feature: similar to matrix("23>(params)>3" for MODELKIT SPACEGROUP
 -- modelkit spacegroup "23>>3" no longer has to be maximal subgroup
 -- for example:
 
	modelkit zap spacegroup 23
	draw u1 unitcell
	draw s1 spacegroup all
	modelkit spacegroup ">>3"
	draw s2 spacegroup all
	draw u2 unitcell
	draw u2 unitcell color red
 -- modelkit spacegroup "23>sub>3" still refers to maximal subgroup only

new feature: x = matrix("23>sub(1,2)>3")
 -- selects for the 2nd conjugation entry for the 1st occurrence of subgroup 3
    in the ITA listing 
 
JmolVersion="16.2.37" // (legacy) also 16.2.38 (SwingJS)

bug fix: various issues with subgroups path description for expanded cell routes

bug fix: switching SHOW SPACEGROUP DIAGRAM to University College London hypertextbook site 
 -- now making calls to http://img.chem.ucl.ac.uk/sgp/large/sgp.htm 
 -- ITA wiley site has been placed behind a paywall

bug fix: various fixes relating to new subperiodic group features

bug fix: unitcell and DRAW UNITCELL for subperiodic and plane groups 
 -- modification to more clearly indicate nonperiodic axes
     
test: test/script/16.2 passing 72 tests

JmolVersion="16.2.35" // (legacy) also 16.2.36 (SwingJS)

buf fix: various fixes relating to new subperiodic groups feature

bug fix: SPIN and CAPTURE SPIN and CAPTURE ROCK broken in 16.2.33. 

bug fix: set labelKey doesn't allow for two keys only differing in case
 -- such as Wyckoff positions "a" and "A" for Space Group 47. 
 
feature change: load =mp/..... removed; 
 -- this Materials Project service is no longer available


JmolVersion="16.2.33" // (legacy) also 16.2.34 (SwingJS)

NOTE: LACA2024 refers to ideas generated from the 
      Latin American Crystallographic Association meeting, Sept 23-26, 2024 

new feature: (LACA2024) MOVETO timeSeconds DIRECTION [1 0 0]
 -- reorients a crystal structure along the given crystallographic direction
 -- DIRECTION here means "viewing down the axis {1 0 0/1}"
 -- uses a quaternion difference to calculate the most direct rotation

new feature: (LACA2024) set labelKey TRUE/FALSE
  -- when set TRUE, adds a key on the right
  -- removes any key created with set elementKey
  -- removed if set elementkey is issued
  -- key indicates atom color correspondence with atom labels (alphabetically)
  -- key is disabled when:
       -- a color corresponds to more than one label
       -- a given label corresponds to more than one atom color
  -- note that LABEL HIDE can still be used
  -- particularly useful for showing wyckoff positions 
  -- example:
  
  	modelkit spacegroup 62
	modelkit add wyckoff all packed
	label %[wyckoffm]
	set labelkey
    label hide
    set picking dragatom

    modelkit draw spacegroup 47
    modelkit add wyckoff all packed
    label %[wyckoff]
    label hide
    set labelkey
 
         
new feature: (LACA2024) set mode2d (experimental)
  -- when set TRUE, disables mouse rotation

new feature: (LACA2024) using set dragAtom with symmetry, a "collision" with a 
    symmetry element results in a red warning halo around all equivalent atoms.  

new feature: (LACA2024) modelkit unitcell {0 1 0}
  -- retains space group as long as this is a unit lattice shift

new feature: (LACA2024) modelkit unitcell {0 1 0} packed
  -- retains space group as long as this is a unit lattice shift
  -- packs the new unit cell
  -- CONNECT is not executed; if bonding is required, follow by the CONNECT command

new feature: (LACA2024) MODELKIT ADD <element> <position> Wyckoff ALL PACKED
  -- adds a full set of atoms for each Wyckoff position
  -- uses the list "Al B C D Fe F Ga He I Ge K Li Mg N Os P Ca Rh S T U V W Xe Yb Zn Am"
     to provide 27 different colors and sizes (Space Group 47 uses all of these)
  -- Aluminum for "a", Boron for "b", etc. 
  -- <element> is an element symbol to be used to specify the general position
  -- default is "O" (which is not on this list already)
  -- <position> is an optional fractional position and defaults to {0.53, 0.20, 0.16}
  -- PACKED is optional
  -- for examp	le:
 
 	   modelkit draw spacegroup 47
       modelkit add wyckoff all packed
 	   label %[wyckoffm]; labels hide
 	   set labelKey
  
  	   modelkit zap spacegroup 148
       modelkit add O {0.1 0.11 0.15} wyckoff all packed
       spacefill 0.3
       
new feature: (LACA2024) x = plane([u v w])
  -- u v w are fractional coordinates, generally integers -- do not use "1/2" here
  -- generates the plane perpendicular to the given direct space fractional vector {u v w/1}  

new feature: (LACA2024) x = {*}.plane([u v w])
  -- u v w are fractional coordinates, generally integers -- do not use "1/2" here
  -- generates an array of coordinates that are the projection onto the 
     plane perpendicular to the given direct space fractional vector {u v w/1}  

new feature: (LACA2024) compare <atoms> <coordinates> MORPH
  -- smoothly and linearlly converts atom coordinates to the specified list of coordinates.  
  -- example projecting all atoms onto a plane in a crystal structure
  
    compare {*} @{{*).plane([1 1 1])} MORPH

new feature: (LACA2024) SHOW WYCKOFF
  -- lists Wyckoff positions without multiplicities

new feature: (LACA2024) SHOW WYCKOFFM
  -- lists Wyckoff positions with multiplicities

new feature: (LACA2024) DRAW VECTOR NOHEAD pt1 v1
  -- uses point and vector, but displays just the cylinder without an arrow head
  -- introduced in Jmol 11.5.40 (June 2008!) but undocumented and broken

new feature: (LACA2024) adds support for plane, layer, rod, and frieze groups.
 -- CLEG designations add prefixes p/ l/ r/ f/ 
 -- full support for adding atoms, designating Wyckoff positioning, and moving atoms around
 -- introduces a new way to show nonperiodic dimensions using "open-ended" unit cells
 -- prefixes also work with Hermann-Mauguin names. 
    (this was necessary because there is cross-over between names among the group types)
 -- subgroups are not supported yet
 -- for example:
 
 	modelkit draw spacegroup p/15;
 	modelkit add wyckoff all packed;

 	modelkit draw spacegroup l/p6/mmm;
 	modelkit add wyckoff all packed;
 
bug fix: RESET should restore crystal structure to "center unitcell"
    
test: updated test/scripts/16.2.spt (72 tests)

JmolVersion="16.2.31" // (legacy) also 16.2.32 (SwingJS)


new feature: spacegroup(10, "settings")
 -- gets a list of all ITA setting info for the specified space group
new feature: spacegroup("settings")
 -- gets a list of all ITA settings for the current space group

new feature: spacegroup(10, "setting")
 -- gets the default setting for the specified space group
new feature: spacegroup(10.1, "setting")
 -- gets the ITA setting information for the specified space group
new feature: spacegroup("setting")
 -- gets the setting information for the current space group setting
 -- for example:
     
		modelkit zap spacegroup 23
		print spacegroup("setting").hm;

			I 2 2 2
			
bug fix: draw symop "y,x,-z-1/3" { atomIndex = 2 }  broken in 16.2.28


JmolVersion="16.2.29" // (legacy) also 16.2.30 (SwingJS)

development note: {workspace}/test/scripts/16.2.spt cumulative for 16.2 (starting with 16.2.27!)

bug fix: MOLDEN reader not counting coefficients in some cases

bug fix: set picking rotateBond, assignBond not working

bug fix: modelkit zap spacegroup "P 2/m 1 1" does not create compatible unit cell 
 -- nonstandard Hermann-Mauguin name
 -- 10.3 OK, but P 2/m 1 1 fails

bug fix: modelkit spacegroup not returning error message
 -- should report errors in syntax or space group names
  	
bug fix: modelkit spacegroup "R...:r" fails
 -- :r here is not an abbreviation, just Hermann-Mauguin name part

bug fix: modelkit draw spacegroup may miss some symmetry elements
 -- particularly for rhombohedral settings of cubic groups
 -- for example:
    
      modelkit draw spacegroup 225:1/2b+1/2c,1/2a+1/2c,1/2a+1/2b
      draw * off; draw *bar_4* on 
    
    should show eleven complete rosettes
     

new feature: modelkit spacegroup "225:p"
  -- ":p" specially for Jmol "primitive"
  -- many settings not found in the International Tables
  -- example:
    
	modelkit zap spacegroup "225:p"
	print spacegroup().operations.count

	  48

new feature: CASTEP reader adds filer "NOSYM" to skip symmetry generation

new feature: spacegroup("list")
 -- displays a multiline string listing of all Jmol space group settings
 -- form:
 
 	    10.1	P 1 2/m 1	10:a,b,c
  
new feature: spacegroup(n, "list")
 -- displays a multiline string listing of name info for the specified space group number
 -- for example:
 
     print spacegroup(10)
     
	    10.1	P 1 2/m 1	10:a,b,c
		10.2	P 1 1 2/m	10:c,a,b
		10.3	P 2/m 1 1	10:b,c,a

new feature: modelkit spacegroup xxx:p
 -- special ":p" extension for IT numbers (10 or 10.3) or HM names
 -- "primitive"
 -- attaches the matrix to the primive for centered cells (A,B,C,F,I).
 
# all 58 16.2 tests passing
     
JmolVersion="16.2.27" // (legacy) also 16.2.28 (SwingJS)

new feature: spacegroup() method accepts Hermann-Mauguin names for subgroups:
   print spacegroup("P2/m", "subgroups")
   print spacegroup("P2/m", "subgroups").subgroups.select("(subgroupHM)").format("JSON")
		[ "P-1","P2","Pm","P2/m","P2/m","P21/m","C2/m","P2/c" ]
   print spacegroup("P2/m", "P2/c")[1].trms.select("(trm)")
		a-c,b,2c;0,0,1/2
		a-c,b,2c
		-2a-c,b,2a;1/2,0,0
		-2a-c,b,2a
		a,b,2c;0,0,1/2
		a,b,2c     

new feature: point("(1/2,1/3,1/4)")
  -- expressions evaluated
  -- opposite of {x,y,z}.rxyz
  -- for example:
	$ print point("(1/2,1/4,1/8)")
		{0.5 0.25 0.125}
   	$ print point("(cos(60),sin(60),sqrt(2))")
		{0.5 0.8660254 1.4142135}

new feature: CASTEP reader accepts mathematical expressions for lattices, symmetry matices and atom positions

new feature: CASTEP reader processes SYMMETRY_GENERATE keyword
  -- follows load with MODELKIT SPACEGROUP
  
new feature: symop([ops],type)
  -- generates an array of [ symop(ops[1],type), symop(ops[2],type),...]
  -- useful for various symop() calls
 
new feature: matrix("A2/m") or matrix("10.4")
  -- returns setting transform for space group setting idenfifier

new feature: spacegroup(10.2).hm or spacegroup("10:b,c,a").hm 
  -- returns Hermann-Mauguin name

new feature: spacegroup(10).n
  -- returns number of settings
  -- useful with spacegroup(10).its[2].hm (returns Hermann-Mauguin name of second ITA setting)
  
new feature: matrix("13>>15>>14>>2")
  -- calculates the transform matrix (P,p) for this subgroup chain
  -- names can be Hermann-Mauguin names

new feature: matrix("h"), matrix("r")
  -- short-cut to matrices for rhombohedral-to-hexagon and hexagonal-to-rhombohedral transforms

new feature: matrix.format("xyz"), matrix.format("abc")
  -- same as matrix(matrix,"xyz"), matrix(matrix,"abc")
  -- more natural, as formatting is what we are doing here
  
bug fix: CASTEP reader not reading unit cells for phonon trajectories

bug fix: draw SPACEGROUP ALL may report g-glide when actual is n-glide
  -- case was modelkit spacegroup "12:b,-a-c,c";draw spacegroup all

bug fix: print symop("wyckoff") underecounts multiplicity for centering I->F

bug fix: LOAD ..... CENTROID 0.5 does not work
  -- should expand the range where the molecular center is.
  
buf fix: (JavaScript only) symop(@3,@3,"array") can report incorrect rotationAngle due to missed Infinity/NaN in JavaScript

bug fix: ECHO/SCALE DEPTH not compatible with SCALE @34

bug fix: enabling MODELKIT ZAP SPACEGROUP 146:r; MODELKIT SPACEGROUP >h>146

bug fix: space group name "C m m b" not recognized

buf fix: arrayOfMaps.array(k)
 -- should create an array if all values of arrayOfMaps[i].k are integers, and there
    is a single sequence of values starting from 0 or 1, and all values are <= 10000
    with no gaps 
 
bug fix: creating OpenSmiles with atom class as property_atomclass should not list [C:0]
 -- for example:
 
  	$ load $2-butanol
	$ @2.property_atomclass=2
	$ @3.property_atomclass=3
	$ @5.property_atomclass=5
	$ print {*}.find("smiles/open")

    should report 
    
		C[C@H:2]([OH:5])[CH2:3]C

    not
    
    	[CH3:0][C@H:2]([OH:5])[CH2:3][CH3:0]

	$ print {*}.find("smiles", "C[C@H:2]([OH:5])[CH2:3]C")
	
	then reports 
	
		({0:14})
	
	but
		
	$ print {*}.find("smiles", "C[C@H:2]([OH:5])[CH2:6]C")
	
	reports ({})
	  
new feature: script-based CAPTURE with delays extended to non-looping GIF. 
 -- for example, a once-through rocking motion with a 2-second delay at both ends:
 
 CAPTURE "t.gif" SCRIPT "rotate y 20 20;delay 2;rotate y -40 -40;delay 2;rotate y 20 20"
 
 -- LOOP before the SCRIPT parameter results in GIF looping
     
new feature: AUDIO command
 -- replaces mostly undocumented LOAD AUDIO
 
 	AUDIO ID id "filename" <action>
    -- provides an identifier for referencing
    -- default id "audio1"
    -- opens and starts an audio clip from a file
    -- first stops any running audio clip with this id
    -- does not stop other running audio clips (i.e. they can overlap)
    -- optional action (most likely START, LOOP, or PAUSE)
    -- default actions are START and, at end of playing, CLOSE
    -- explicit action directs Jmol to NOT close the clip, allowing it to be started again
       in which case the user is responsible for running AUDIO OFF or AUDIO ID ... CLOSE
    
    AUDIO ID id <action>
    -- default id "audio1"
    -- presumes an audio clip with this id has been opened
    -- executes the action on this the audio clip
    -- <action> is one of START|LOOP|PAUSE|PLAY|STOP|CLOSE
       START: starts an audio clip from the beginning
       LOOP: starts an	audio clip and restarts the clip when it is done playing
       PAUSE: pauses an audio clip
       PLAY: plays an audio clip wherever it was last stopped
       STOP: stops an audio clip and resets it to the starting point
       CLOSE: stops an audio clip and releases its resources, including its ID
       
    AUDIO OFF
    -- closes all audio clips and releases their resources
     
new feature: audioCallback
    -- reports a map containing details about the audio clip and its status (2nd parameter)
       and the status as a string (3rd parameter)
    -- status firing depends upon various factors and may be unpredictable in indicating completion
       (Java may report "pause" for both an actual pause and a termination, possibly not releasing resources)       
     
new feature: MODELKIT SPACEGROUP >r> PACKED
  -- trailing ">" means "no change of space group
  -- allows conversion r to h or h to r just after standard load.
   
new feature: MODLEKIT SPACEGROUP "<<13"  
  -- super rather than sub
  -- substituted as ">super>13"
     
example code:

/*
 * show subgroup chain using BCS format
 * 
 * for example:
 *
 *  showsubs("C2/c > P21/c > P21")
 *
 *  showsubs([13 15 14 2])
 */
function showsubs(chain) {
  save orientation o;
  draw * delete;
  // chain = "C2/c > P21/c > P21"
  var colors = ["red", "orange", "yellow", "green", "blue", "violet" ];
  if (chain.type == "array")
	chain = chain.join(">");
  var groups = chain.replace(" ","").replace(">>",">").split(">");
  
  var drawIDs = [];
  for (var i = 1; i<= groups.length; i++) {
    var sg = groups[i];
    if (i == 1) {
      print sg;
      modelkit zap spacegroup @sg;
    } else {
      print ">>" + sg;
      modelkit spacegroup @{">>" + sg};
    }
    restore orientation o
    var dsg = "sg"+sg + "_";
    drawIDs.push(dsg);
    draw ID @{"uc"+sg + "_"} unitcell color @{colors[((i-1)%6)+1]} @sg;
    draw ID @dsg spacegroup all;
    draw ID @{dsg + "*"} off;
    delay 2
  }
  set echo bottom left;
  for (var i = drawIDS.length; i > 0; --i) {
    draw sg* off;
    draw ID @{drawIDs[i] + "*"} on;
    echo @{groups[i]}
    delay 2;
  }
  draw ID * on;
  echo @chain;
  restore orientation o;
 }

 //showsubs([13 15 14 2])
 showsubs("C2/c > P21/c > P21")


JmolVersion="16.2.25" // (legacy) also 16.2.26 (SwingJS)

new feature: AUDIO command
 -- replaces mostly undocumented and preliminary LOAD AUDIO
 
 	AUDIO ID id "filename" <action>
    -- provides an identifier for referencing
    -- default id "audio1"
    -- opens and starts an audio clip from a file
    -- first stops any running audio clip with this id
    -- does not stop other running audio clips (i.e. they can overlap)
    -- optional action (default START; most likely START, LOOP, or PAUSE)
    -- default actions are START and, at end of playing, CLOSE
    -- explicit action directs Jmol to NOT close the clip, allowing it to be started again
       in which case the user is responsible for running AUDIO OFF or AUDIO ID ... CLOSE
    -- example: 
    
         audio ID a1 "https://chemapps.stolaf.edu/jmol/jsmol/iucrdemo/tada.wav"   
    
    AUDIO ID id <action>
    -- default id "audio1"
    -- presumes an audio clip with this id has been opened
    -- executes the action on this the audio clip
    -- <action> is one of START|LOOP|PAUSE|PLAY|STOP|CLOSE
       START: starts an audio clip from the beginning
       LOOP: starts an audio clip and restarts the clip when it is done playing
       PAUSE: pauses an audio clip
       PLAY: plays an audio clip wherever it was last stopped
       STOP: stops an audio clip and resets it to the starting point
       CLOSE: stops an audio clip and releases its resources, including its ID
       
    AUDIO OFF
    -- closes all audio clips and releases their resources
     
new feature: audioCallback
    -- reports a map containing details about the audio clip and its status (2nd parameter)
       and the status as a string (3rd parameter)
    -- status firing depends upon various factors and may be unpredictable in indicating completion
       (Java may report "pause" for both an actual pause and a termination, possibly not releasing resources)       
     
JmolVersion="16.2.25" // (legacy) also 16.2.26 (SwingJS)

bug fix: (JavaScript only) script processing broken in 16.2.23 for JavaScript only 

JmolVersion="16.2.23" // (legacy) also 16.2.24 (SwingJS) [abandoned]

feature change: scripts embedded within PNGJ, JMOL, and ZIP formats have tighter security.
 -- necessary for new ability to hand-modify scripts within these file types
 -- in general, these scripts are expected to be state scripts generated by Jmol,
    however, it is possible (now) to modify these scripts using jmol 
 -- this fix makes no change to files created by Jmol; rather, it
    ensures that replaced scripts will only access files within their containing files
 -- they may not load local files external to their own contents
 -- they may not use the file() or load() method
 -- they may not use the write command or the write() method
 -- they may not use the javascript command or the eval() method

bug fix: (Java only) write hand-modified PNGJ file fails in Java

bug fix: isosurface EDS fails
 -- updating to continuing EBI BCIF file format changes
 -- includes multiple encoder compatibility, including mol*, CoordinateServer, ModelServer, DensityServer, and Volume-Server
 
bug fix: bond/wireframe changes prior to atom deletion may not be saved correctly in state
 -- problem is with select BONDS only in association with atom deletion
 -- PNGJ files saved with this and future version of Jmol should read property with previous versions of Jmol 

bug fix: MO and ISOSURFACE generation after atom deletion not saved properly in the state
 -- after atom deletion, components of MO or ISOSURFACE may be different,
    but the state generates the deletion AFTER the MO and ISOSURGACE commands are processed
 -- this fix introduces the deletion at the time of the MO or ISOSURFACE generation into
    the MO or ISOSURFACE command. 
 -- scripts created with future versions will generate correct isosurfaces when executed in previous versions
 -- script screated with future versions will run but still not generate correct MOs when executed in previous versions
    
bug fix: CALCULATE STRUTS fails for $LOAD =4mwb
 -- singleton MET amino acid as ligand was not handled 

bug fix: CIFReader should read atomName from _jmol_atom_name block
 -- _jmol_atom_name is created by WRITE CIF
 
bug fix: SHELXReader support for space-starting comment lines

new feature: atom property translucent
 -- 0.0 to 1.0, with 0 being opaque and 1 being transparent 
 -- for example, select translucent = 0.5; select translucent > 0

new feature: atom.property_part
 -- the SHELX PART or CIF atom_site_disorder_group as a float value
 -- note that for negative part, the fragments are given unique
    altloc values that range from 1-9A-Za-z. 'A' and 'a' can be 
    distinguished using LIKE, as in SELECT ALTLOC LIKE 'a'
 -- for space groups with m symmetry operatiosn and n parts, 
    if m*n > 53 then altloc values will restart at "A" after reaching 'z'. 
    This may result in undesired bonding between parts. 
 -- atom.property_part is not produced for mmCIF or binaryCIF files
 -- property_part overrides altloc value for WRITE CIF

new feature: CONFIG -n and SELECT CONFIG=-n for SHELX and non-PDB CIF
 -- negative configuration number
 -- selects property_part=0 or property_part=n or property_part=-n


JmolVersion="16.2.21" // (legacy) also 16.2.22 (SwingJS)

bug fix: PyMOLReader handling of measurement and atom labels refined
bug fix: PyMOLReader skipping display of nonbonded atoms (water as red stars)
bug fix: PyMOLReader mishandling unique settings for valence

new feature: PyMOLReader FILTER "SHOWVALENCE"
 -- may be needed for PyMOL files that have not been saved with valence setting ON
    in order to show multiple bonds in Jmol
 -- note that PyMOL valence_mode setting is NOT implemented in Jmol
 
 
JmolVersion="16.2.19" // (legacy) also 16.2.20 (SwingJS)

bug fix: SHELX reader LATT 1 does not add "x,y,z" so does not also add "-x,-y,-z"

bug fix: DRAW ARROW can produce very long head
 -- now limited to 1.5 * width of arrowhead (4.5 * width of arrow shaft)

bug fix: PyMOLReader does not recognize default label position (skips labels and measurements)
bug fix: PyMOLReader assigns wrong background color
bug fix: PyMOLReader fails to read file when it includes a default (null) measurement dash setting
bug fix: PyMOLReader creates measurement dots that are too large

bug fix: CIFReader fails to read multiple structures if _shelx_hkl_file is found

bug fix: MODELKIT SPACEGROUP 10:bca not reversion any prior nonstandard setting  

bug fix: MODELKIT SPACEGROUP 145:a-b,a+2b,c fails
 -- had not completed implementation of expanded unit cells for settings

# new features from the Denver 2024 ACA meeting:
# see https://github.com/BobHanson/CLEG/tree/main/presentations
# for the presentation "A Concise Linear Encoding of Crystallographic Space Group Settings
# and Group-Subgroup Relationships"
#
# also see https://crystals.symotter.org/ for 
# the new Jmol Space Group Visualizer. https://spacegroups.symotter.org
# presented by Dean Johnston at the ACA meeting

new feature: CIFReader filter "StopOnSHELXHKL"
 -- stops reading file when _shelx_hkl_file is found
 -- should not be used with multiple structures
 -- default FALSE; prior version this was (effectively) default TRUE
    but that causes problems for multiple-stucture CIF files

new feature: SHELX reader and CIFReader by default assign translucent 0.5 to symmetry-related disorder
 -- PART -n
 -- for example, when a solvent is alternatively on one side or another of a C2 rotation

new feature: matrix("!b,c,a>a-c,b,2c;0,0,1/2>a,-a-c,b")
 -- calculates the transformation from a CLEG chain
 -- same as matrix("!b,c,a")*matrix(">a-c,b,2c;0,0,1/2")*matrix("a,-a-c,b")
 -- also works for operations expressed in x,y,z

feature change: DRAW SPACEGROUP ALL glide arrows thicker and colored green
 -- the thin yellow lines were hard to see on slides in Denver

scripting note: algorithm for generating operations from generators:

	// start with the array of "x,y,z" generators
	function getGeneralPositions(gen) {
	 var a = [];
	 var b = [matrix("x,y,z")];
	 var s= ""
	 for (var i = 1; i <= gen.length; i++) {
		for (var j = 1; j <= b.length; j++) {
			var m = matrix(gen[i])*matrix(b[j]);
			// normalize to positive ("unitary") translations only
			// by pulling the translation out, turning it into cartesians, and then unifying it,
			// then adding it back into the 3x3 to regenerate a 4x4 operation
			m = m%1 + (m%2).xyz.uxyz
			var xyz = matrix(m,"xyz");
			var key = ";"+xyz+";";
			if (s.find(key) == 0) {
				// only add already-unfound operations
				s += key;
				b.push(m);
				a.push(xyz);
			}
		}
	 }
	 return a;
	}
 
 scripting note: Using CLEG notation; showing the 3D model of Figure 1.5.1.8 based on
   matrices in Table 1.5.1.1, p. 79
   Primitive hexagonal cell P with a, b, c and the three triple hexagonal 
   cells H with a1; b1; c; a2; b2; c; a3; b3; c. The origin for all cells is the same.
   International Tables for Crystallography (2016). Vol. A, Section 1.5.1.2, p. 82.
   https://onlinelibrary.wiley.com/iucr/itc/Ac/ch1o5v0001/sec1o5o1o2.pdf

	modelkit zap spacegroup 145
	draw u0 unitcell color white
	draw s0 spacegroup all
	
	modelkit spacegroup 145:a-b,a+2b,c
	draw u1 unitcell color pink
	draw s1 spacegroup all
	
	modelkit spacegroup 145:2a+b,-a+b,c
	draw u2 unitcell color red
	draw s2 spacegroup all
	
	modelkit spacegroup 145:a+2b,-2a-b,c
	draw u3 unitcell color purple
	draw s3 spacegroup all

	modelkit spacegroup 145
	 

JmolVersion="16.2.17" // (legacy) also 16.2.18 (SwingJS)

new feature: SHELX reader adds support for PART
 -- *.altloc set by PART number
 -- use display config=1 to show PARTS 0+1, config=2 to show PARTS 0+2
 -- noting that OpenBabel 3.1.1 does not write disorder to CIF when reading PART and writes invalid CIF when CIF->CIF
 
new feature: WRITE CIF adds altloc
 -- _atom_site_disorder_assembly A
 -- _atom_site_disorder_group [altLoc value]
 
bug fix: SHELX reader does not apply LATT > 0 (centrosymmetric) operation

bug fix: SHELX reader not reading occupancy
 
bug fix: CIF writer may gernerate P1 when space group is from file loading rather than structure creation

bug fix: CIF reader fails to bond molecules properly when the structure has an _atom_site_aniso block

bug fix: STL exporter makes isosurface meshes too thick

bug fix: DRAW SYMOP should not draw "wings" on screw axes, since it draws curved angle arrow already

bug fix: {"y": z.x}.format("JSON") fails when z is a map

bug fix: Wyckoff position b not found for CSD XAZTAW and BROFRM05
         The problem is what to do with xx.yyyyy(zz) for precision. 
         I had given that 5 places, but more consideration suggests that
         the presence of error value should limit the precision to 4. 
         This worked in both of these cases. 
         (All this is somewhat of an approximation.)
         Precision can also be set using a load filter:
         
            load xxxx.cif ... filter "precision=3"
         

JmolVersion="16.2.15" // (legacy) also 16.2.16 (SwingJS)

bug fix: x = symop(n) broken for n a symmetry operator number

bug fix: draw symop [4x4 matrix] not working

bug fix: MODELKIT DRAW SPACEGROUP should use prefix "sg" not "sym"

bug fix: various minor aspects of DRAW SPACEGROUP ALL and MODELKIT DRAW SPACEGROUP
 -- new color coding for n-axes
 -- new color coding and larger icons for n-bar axes
 -- missing split planes (mirror+glide and glide+glide)
 -- missing additional 2-fold rotations tangent to corners in hexagonal groups
 

JmolVersion="16.2.13" // (legacy) also 16.2.14 (SwingJS)

bug fix: select UNITCELL should be inclusive, [0,1] (broken in 14.32.18)
 -- not the same as within(unitcell), which is [0,1) exclusive

bug fix: polyhedra COLLAPSED EDGES  does not just act on current polyhedra

bug fix: polyhedra POINTS miscolors isotopes

bug fix: atom color change using color <element name>  not reflected in element key

bug fix: MODELKIT SET KEY not working correctly (broken in 16.2.1)
 -- had been changed to "ELEMENTKEY" without documentation
 -- now just an alias for MODELKIT SET ELEMENTKEY
 -- not supposed to persist through ZAP
 
new feature: SET ELEMENTKEY ON/OFF (actually introduced in 16.2.1)
 -- adds or removes an element key in the upper right for ALL models
 -- key is a list of a colored DRAW point and a b/w ECHO with ids "_!_elkey_<modelIndex>_*"
 -- overrides current settings from MODELKIT SET ELEMENTKEY 
 -- only visible when just a single model is visible
 -- recognizes different isotope colors
 -- does not appear if atoms of the same element or isotope have different colors
 -- setting itself is not explicitly saved in the state
 -- presence of DRAW objects in a state sets MODELKIT SET ELEMENTKEY ON 
    for associated models when restored, preserving the key for those 
    models that had them when saved
 -- persistent through ZAP

new feature: MODELKIT SET ELEMENTKEY ON/OFF (actually introduced in 16.2.1)
 -- adds or removes an element key as per SET ELEMENTKEY ON/OFF, but only for the CURRENT model only
 -- indirectly saved in state as the presence of the associated DRAW objects
 -- key does NOT persist through ZAP
 
new feature: frank (bottom right corner "Jmol") displays "JmolD" for JmolD.jar and JmolDataD.jar


JmolVersion="16.2.11" // (legacy) also 16.2.12 (SwingJS)

bug fix: various minor issues with DRAW SPACEGROUP ALL

NOTE: Introducing here the idea of a "3D interactive space group symmetry model".
      Something like a space group diagram or a general position 
      diagram, but in 3D. Symmetry elements can be filtered out 
      to reveal patterns in the remaining subset; aspects of
      group-subgroup relationships can be depicted, either from a
      purely symmetry-related perspective or in the context of an
      actual structure or a set of related structures. Specific atom-atom
      symmetry relationships can be explored.

new feature: MODELKIT DRAW SPACEGROUP [name or number] [packed]
 -- clears the model with ZAP, then creates the space group symmetry model
 -- draws the full set of symmetry elements
 -- optionally (if PACKED), adds a nitrogen atom in the default general position
 -- shortcut for 
 
    zap;
    modelkit spacegroup ... ;
    draw spacegroup ALL;
    modelkit add N;
    
 -- coding example:

     function showAllSpaceGroups() {
       for (var i = 1; i <= 230; i++) {
       	  modelkit draw spacegroup @i packed;
       	  set echo top right;
       	  echo @i;
       	  refresh;
       }
     } 

	 showAllSpaceGroups; // note that some cubics take quite a bit of time

	function makeSpaceGroupMovie() {
	    zap;
	    background white;
	    capture "spaceGroupMovie.gif";
	    for (var i = 1; i <= 230; i++) {
	       	  modelkit draw spacegroup @i packed;
	       	  set echo top right;
	       	  echo @i;
	       	  refresh;
	    }
	    capture end;
	}
	
	makeSpaceGroupMovie()
	
	 
new feature: SHOW SPACEGROUP TABLE <group>
 -- displays space group tables from Bilbao Crystallographic Server the user's browser
 -- https://www.cryst.ehu.es/cgi-bin/cryst/programs/nph-getgen?gnum=110&what=gp&list=Standard%2FDefault+Setting
 -- adds to SHOW SPACEGROUP DIAGRAM (see 16.2.9 release, below)
 -- optional <group> may be a space group name or number
 -- default is to use the current space group
 -- example:
   
    	show spacegroup table
     	show spacegroup table 13
    	show spacegroup table P2/c
 
new feature: syncCallback for mouse-following
 -- allows actions to take place 
	set syncmouse
	sync on
	set synccallback "jmolscript:color atoms property sz"

JmolVersion="16.2.9" // (legacy) also 16.2.10 (SwingJS)

bug fix:  fixes a miscalculation of glide 'g' vs. 'n' in SHOW SYMOP and in colors for DRAW SPACEGROUP

bug fix: DRAW SPACEGROUP failing after SHOW SYMOP

feature change: DRAW SPACEGROUP  display adds triangles, squares, and hexagons at tail of rotation arrows

feature change: new colors and styles for axes
 -- axes with order > 2 now show their order and screw-pitch using pictograms similar to ITA:
   
    2-fold   no pictogram; red for 2, grey for 21
    3-fold   triangle      red for 3, orange for 3{+) < 1/2, blue for 3{+) > 1/2
			               spinner cw for 3{+) < 1/2, ccw for 3{+) > 1/2               
	4-fold   square        red for 4, orange for 4{+) < 1/2, blue for 4{+) >= 1/2
             			   spinner cw for 4{+) < 1/2, ccw for 4{+) > 1/2               
	6-fold   hexagon       red for 6, orange for 6(+) < 1/2, blue for 6(+) >= 1/2
             			   spinner cw for 6{+) < 1/2, ccw for 6{+) > 1/2               
	
 -- good examples are space groups 76-80, 151-180
 
feature change: new color scheme for planes
 -- note how name first letter correlates with type:

	mirror   magenta
    a-glide  azure
   	b-glide  blue
   	c-glide  cyan
   	d-glide  gray (colorless, like a diamond)
   	e-glide  (split color for a+b, b+c, a+c  (still working on getting all of these -- see SG 64)
   	g-glide  green
   	n-glide	 orange (esp: naranja)

 -- nice examples:
	-- m+n (SG 65, 69)
	-- a, b, and c (SG 72, 73)
	-- a, b, n, and mirror (SG 74)
    -- d (SG 43, 70, 122)
    -- m, n, d (SG 109)
    -- a, b, c, d (SG 110)
    
new feature: SHOW SPACEGROUP DIAGRAM xxx
 -- displays International Tables space group diagram for specified
    space group by number or Hermann-Mauguin name in user's browser. 
 -- specified origin might be lower on the page.
 -- for example:
 
 	show spacegroup diagram P4/mmm
 	
	opens  https://onlinelibrary.wiley.com/iucr/itc/Ac/ch2o3v0001/sgtable2o3o123
 
new feature: DRAW *xxx* ONLY
 -- shortcut for DRAW * OFF; DRAW *xxx* ON
 -- very convenient for turning on and off aspects of complicated DRAW SPACEGROUP ALL:
  
      DRAW *X_g* ONLY     // X = a, b, c, d, g, n (e is a combination of a/b, a/c, b/c; see Group 68)
 	  DRAW *bar_N* ONLY   // N = 3, 4, 6
 	  DRAW *rot_N* ONLY   // N = 2, 3, 4, 6
 	  DRAW *screw_N* ONLY // N = 2, 3, 4
 	  DRAW *inv* ONLY     // inversion centers
 	  DRAW *mirror* ONLY  // mirror planes only
  
 -- note that a six-fold axis will contain three arrows: 2-fold, 3-fold, and 6-fold
 -- likewise for 6-bar/3-fold and 4-fold-2-fold, 4-bar/2-fold
 	 
 	  	 
new feature: MODELKIT ZAP...
 -- same as   ZAP; MODELKIT ...

 	 
JmolVersion="16.2.7" // (legacy) also 16.2.8 (SwingJS)

bug fix: three nonstandard settings not showing correct JmolID. 

bug fix: Wyckoff positions for nonstandard space group settings not available
 -- Jmol now calculates Wyckoff positions for any nonstandard setting 
 -- 134 additional nondefault settings (from BCS wp-list) added

bug fix: ++x; and --x; never fully implemented;
 -- specifically the stand-alone statements
 
bug fix: using map1["x"] = ++map["y"] does not properly make a copy
 -- later incrementing of one value was also changing the other
 
bug fix: zap; modelkit spacegroup 5:a,-b,-a-c should work

bug fix: Starting with Jmol 16.1.32, Jmol should accept CIF files with duplicate atom_site_label entries, but it doesn't
  - it will add numbers if two identical atom_site_label values are found
  - an warning message is reported in the Java console only.
  
feature change: AFLOWLIB database updated
 -- now "https://www.aflowlib.org/p/%AFLOWID%.cif" 
 -- still no AJAX CORS access
 -- should be no effect on usability
  
new feature: dropping requirement for double quotes in MODELKIT SPACEGROUP ...
 -- just isn't necessary generally
 -- if spaces are present, then quotes are required
 -- semicolon will be incorporated provide there is no space after it
 -- for example:
 
   zap; modelkit spacegroup 5:a,-b,-a-c;0,0,0 packed
   zap; modelkit spacegroup "P 2/m"
 
new feature: MODELKIT SPACEGROUP <CLEG expression>
 -- full CLEG implementation for subgroups.
 -- for example:
 
    modelkit spacegroup "C 2 2 21 >> P 21 21 2 >> P1 21 1"
    
    same as 
    
    modelkit spacegroup "20>b,c,a;1/4,0,0>18>c,a,b;1/4,0,0>4" 

    or, in this case, because they are default settings and the first-listed subgroups: 
    
    modelkit spacegroup 20>>18>>4 

 -- reports overall transformation, in this case:
 
	 a,b,c;1/4,0,1/4
	 20>b,c,a;1/4,0,0>18>c,a,b;1/4,0,0>4
	 basis=({0:3})
 
 -- sample script function:
 
	function showSubgroup(i1, i2, p1,p2) {
	  var tr = "";
	  if (!i2) {
		if (i1.type == "integer") {
			print spacegroup(i1,0,"subgroups")
			return;
		}
		tr = i1;
		i1 = tr.split(">")[1];
	  }
	  if (!tr) {
	  	var sub = "sub";
	  	if (p2) {
	  	  sub = spacegroup(i1,i2,p1,p2);
	  	} else if (p1.type == "string" && p1.length > 0) {
	  	  sub = p1;
	  	} else {
	    	  sub = spacegroup(i1,i2,1,1);
	  	}
		if (sub[0] == "!") {
		  print "can't do that " + sub;
		  return;
	  	}
	  	tr = "" + i1 + ">" + sub + ">" + i2;
	  }
	  save orientation o1
	  zap
	  set echo bottom left
	  echo @tr
	  set scriptreportinglevel = 3;
	  modelkit spacegroup @i1
	  restore orientation o1
	  draw uc1 unitcell color red
	  draw sg1 spacegroup all  
	  modelkit add P wyckoff "G"
	  modelkit spacegroup @tr packed
	  set scriptreportinglevel = 0;
	  color property site 
	  draw uc2 unitcell color yellow
	  draw sg2 spacegroup all
	  flash = false;
	  if (flash) {
	    delay 2
	    for (var i = 0; i < 3; i++) {
		delay 1
		draw sg1* on
		draw sg2* off
		delay 1
		draw sg1* off
		draw sg2* on
	    }
	  } else {
	    draw sg1* translucent 0.8
	  }
	}
	 
	showsubgroup "20>>18>>4"
	     
    
JmolVersion="16.2.5" // (legacy) also 16.2.6 (SwingJS)

bug fix: Some SHELX files not reading
 -- not clear why some and not others. But it is fixed.

bug fix: "standard" PNG and JPG files created by Jmol not readable back into Jmol
 -- embedded state scripts were not being checked
 -- note: Jmol automatically saves its state within standard JPG and PNG files
          unlike PNGJ files, where the state and all necessary files are saved 
	      Generally not recommended, since any loaded files still must be retrieved again.
	      But with MODELKIT SPACEGROUP, there is no model file to read; 
	      so these standard PNG and JPG files should be readable.

bug fix: JPG file drop improperly resolved as MMTF
 -- JPG should be read for its embedded script file, not as MMTF
 
bug fix: load =aflowlib/62.3 spacegroup "x,y,z;x,-y,z" does not set display name correctly in upper left information

bug fix: unit cell not read from state after use of MODELKIT SPACEGROUP specifcally when atoms are present

bug fix: x = spacegroup("Pnma") failing
 -- specifically for Hermann-Mauguin names, Hall names, and AFLOWLIB/n.m

bug fix: AFLOWLIB database changed
 -- now "https://www.aflowlib.org/prototype-encyclopedia/%AFLOWID%/findsym.cif" 
 -- no problem for saved PNGJ files
 -- load =AFLOWLIB/n.m requires this fix
 
new feature: load =aflowlib/<AFLOWID>
 -- allows reading of specific AFLOW Encyclopedia of Crystallographic Prototypes by ID
 -- for example:
 
  load =aflowlib/A3BC_tP5_99_ac_b_a-002 packed
  
new feature: x = spacegroup("AFLOWLIB/A3B14C2D3*")
 -- note that the ID starts with the empirical cell formula ending with "_"     
 -- returns an array of "=aflowlib/n.m<tab>AFLOWID" entries
    which can be split to give either the load string or the AFLOW iD
 -- for example:
 
	$ print spacegroup("AFLOWLIB/A7B2_*")
	=aflowlib/63.34 	A7B2_oC36_63_cgh_f-001
	=aflowlib/164.13	A7B2_hP9_164_ac2d_d-001
	=aflowlib/164.14	A7B2_hP9_164_ai_d-001
	=aflowlib/166.44	A7B2_hR18_166_a2cdh_2c-001
	=aflowlib/227.18	A7B2_cF144_227_2ef_e-001
	
	$ print spacegroup("AFLOWLIB/A7B2_*").split("\t",true).col(1)
	=aflowlib/63.34
	=aflowlib/164.13
	=aflowlib/164.14
	=aflowlib/166.44
	=aflowlib/227.18
	
	$ print spacegroup("AFLOWLIB/A7B2_*").split("\t",true).col(2)
	A7B2_oC36_63_cgh_f-001
	A7B2_hP9_164_ac2d_d-001
	A7B2_hP9_164_ai_d-001
	A7B2_hR18_166_a2cdh_2c-001
	A7B2_cF144_227_2ef_e-001

  -- check of empirical cell formula:
  
	$ load =aflowlib/63.34 packed
	$ print {cell=555}.find("CELLFORMULA", true)
	Ca 2 Ag 7
	$ print {cell=555}.find("CELLFORMULA")
	Ca 8 Ag 28
	
new feature: x = spacegroup("AFLOWLIB/all")
 -- returns array of arrays of information maintained in org/jmol/symmetry/sg/json/aflow_structures.json
 -- note that whenever there is an AFLOW Encyclopedia update, this information could go stale
    and "=AFLOWLIB/3.10" might change. However, it is unlikely that the AFLOW ID will change. 

new feature: load ... centroid 0.5
 -- expands the centroid limit in fractions of a unit direction
 -- same as load ... packed 0.5 centroid, but more intuitive

  
JmolVersion="16.2.3" // (legacy) also 16.2.4 (SwingJS)

demo page: https://chemapps.stolaf.edu/jmol/jsmol/iucrdemo
  -- supplement to a forthcoming publication
  -- lots of examples of using the MODELKIT SPACEGROUP command

note: completion of the MODELKIT SPACEGROUP implementation initiated in 15.2.30/14.2.30

bug fix: (JavaScript) no spinner showing at startup. 
                      Jmol_spinner.gif was missing in site/jsmol/j2s/img

bug fix: (JavaScript chemapps) the php/jsmol.php AJAX relay was failing due to 
                               the presence of both header('Access-Control-Allow-Origin: *') in jsmol.php
                               and .htaccess file in site/, causing a "multiple header" error.
                               The .htaccess file was kept, and the php header was removed. 
                               
bug fix: (legacy JavaScript only) right-click on pop-up menu throws background error 
                                  and fails to place submenu correctly
                                  (traced to minor jMenu incompatibility with jQuery 3.7.1)  

bug fix: (JavaScript) Jmol javascript command containing call back to Jmol.script() 
                           fails to execute callback script

bug fix: (JavaScript) JSpecView and other pages fail to open due to Enum and 
                           ArrayList coding bugs recently introduced that are only used in JSpecView

bug fix: animation range not responsive to load append

bug fix: PDB reader needs to allow PDB files with BIOMT but no CRYST1/SCALE headers

bug fix: SHELX reader fails due to LATT processing failure

bug fix: display of symmetry elements in SHOW and DRAW minor issues

bug fix: DRAW UNITCELL with {555 666 1} notation should show all interior edges of 
         block of cells

bug fix: more work on subgroup-group relations
 - still finalizing code for using transformations such as "a+b,a-b,c;1/2,1/2,0"
 - for example, to create a group, add atoms, and display a packed subgroup, coloring by site:
 
		zap
		modelkit spacegroup 18
		draw unitcell color red
		modelkit add P wyckoff "G"
		modelkit spacegroup "18 >c,a,b;0,1/4,0>4" packed
		color property site
		draw spacegroup all


feature change: DRAW UNITCELL default changed to MESH NOFILL
 - was normal default of FILL NOMESH, but this is much better
 - overridden by explicit NOMESH or FILL
 - does not affect states, as they are explicit, not default

feature change: x = spacegroup("153") or x = spacegroup(153)
 - one parameter, just a number from 1 to 230
 - was Jmol's idiocyncratic Hall-notation-derived operator list
 - now ITA standard list
 - same list; just a different order
 - spacegroup() by itself shows current, possibly file-derived, operators. 

new feature: x = spacegroup("153:")
 - with colon
 - returns Jmol's internal setting and original listing

new feature:  DRAW UNITCELL AXES
 - draws axes red/green/blue (no labels) with unit cell.
   
new feature: spacegroup(g1,g2,i1,i2)
 - same as spacegroup(g1,g2,i1,i2,"subgroups")
 - "subgroups" is unnecessary
  
new feature: x = spacegroup("Hall:p 32 2\" (0 0 2)")
 - translates Hall notation to XYZ list 
 - outputs a map similar to x = spacegroup(154) with at least 
   keys HallSymbol, operationCount, and operationsXYZ; 
   possibly, if known, also:
   
	    HermannMauguinSymbol
		clegId
		crystalClass
		ita
		itaIndex
		jmolId
   
 
new feature: x = {*}.rxyz
 - returns rational fraction if within +/- 0.001 of n/2,3,4,6,8,12,24,48
 - returns rounded to 0.001 if not
 - string value with parentheses: "(1/2 1/2 1/2)"

new feature: fpt.rxyz
 - returns rational of fractional.
 - {1/2 1/2 1/2}.rxyz == "(1/2 1/2 1/2)" 

new feature: x = matrix(...)
  - creates a 3x3 or 4x4 matrix
  - options include (by example):
	  matrix("x-y+1/2,x+y,z")     // row-based
	  matrix("a+b+1/2,b-a,c")     // column-based
	  matrix("a+b,b-a,c;1/2,0,0") // ITA transform notation, col-based
	  matrix([1,2,3,4,5,6,7,8,9]) // 3x3 from array[9]
	  matrix([1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6]) // 4x4 from array[16]
	  matrix([1,2,3] [4,5,6] [7,8,9]) // 3x3 from array[3][3]
	  matrix([1,2,3,4] [5,6,7,8] [9,0,1,2] [3,4,5,6]) // 4x4 from array[4][4]

      P = matrix("c,a,b;1/2,0,0");      
      f = {0.5 0.25 0.5};
      print P*f;
       
         {0.75 0.5 0.5}

new feature: x = matrix(..., "abc")
new feature: x = matrix(..., "xyz")
  - returns the string form of a 4x4 matrix, either in abc-column format or xyz-row format
  
new feature: MODELKIT SPACEGROUP <setting> 
 - Jmol will automatically adjust unit cell if necessary. 
 - should be used after ZAP or LOAD
 - for example:
 
 		function test(n,i) {
			if (!i) { 
				load @{"=aflowlib/" + n} + " packed";  
				center unitcell;
				print "nSettings=" +  spacegroup("ITA/" + n).n;
				test(n,1); 
			} else {
				draw delete;
				modelkit spacegroup @{"" + n + "."+i} packed;
				draw ID @{"sg"+i} spacegroup all;
				center visible;
				axes 0.1;
				connect auto;
				moveto axis c1;
			}
		}
 	
 		test(23)
 			
 	opens an example AFLOW Encyclopedia of Crystallographic Prototypes, then 
 	switches to a one of the available settings, packing the new unit cell
    and displays all symmetry operations. Finally, does some clean up and 
    goes to the standard ITA "c1" axis view. (looing toward 0 along c axis in the top left corner) 

new feature: MODELKIT SPACEGROUP "n >sub> m"
  - switch from crystallographic group to maximal subgroup
  - uses (unpublished) CLEG notation (more details to follow)
  - chooses first-listed transformation
  - typically a translationengleichen (translation-preserving) transformation
  
  - for example: MODELKIT SPACEGROUP "13 >sub> 10"
  
	function showSubgroup(i1, i2) {
	  if (!i2) {
		print spacegroup(i1,0,"subgroups");
		return;
	  }
	  save orientation o1;
	  zap;
	  modelkit spacegroup @i1;
	  restore orientation o1;
	  center unitcell;
	  draw uc1 unitcell color red;
	  draw sg1 spacegroup all;
	  modelkit add P wyckoff "G";
	  modelkit spacegroup @{"" + i1 + ">sub>" + i2} packed;
	  color property site;
	  draw uc2 unitcell color yellow;
	  draw sg2 spacegroup all;
	  delay 2;
	  for (var i = 0; i < 10; i++) {
		delay 1;
		draw sg1* on;
		draw sg2* off;
		delay 1;
		draw sg1* off;
		draw sg2* on;
	  }
	  draw sg1* on;
	  draw sg2* on;
	}
	
    showSubgroup 107
    showSubgroup 107 42
    
new feature: unitcell NONE 
 - removes unit cell and spacegroup
 - removes unit cell and spacegroup information from model auxiliary info _M
 - allows nonperiodic manipulation of atom positions
  
new feature: SHELX reader returns Q-peaks as "Xx" (unknown atom); was returning "C"

new feature: x = spacegroup("ITA/4:c,a,b")
 - finds the ITA spacegroup setting with this specific transformation.
 - text match so must be exact form:  
 	[rotation;translation], e.g. a,b,c;0,0,0   
    "2/3a+1/3b+1/3c,-1/3a+1/3b+1/3c,-1/3a-2/3b+1/3c"  
	"a+b,-a+b,c;-1/4,-1/4,-1/4"		 

new feature: x = spacegroup(itaNo, itaTo, index1, index2, "subgroups") 
 - returns information on group-subgroup relationships 
 - based on Bilbao Crystallographic Server public data
 - uses set of JSON data files - see 
 - return depends upon values:
 
     spacegroup(4,"subgroups")       // all maximal subgroup data for space group 4
	 spacegroup(4,0,"subgroups")     // an array of known subgroup numbers
     spacegroup(4,5,"subgroups") 	 // list of all 4 >> 5
     spacegroup(4,5,1,"subgroups")   // first-listed 4 >> 5 as a map
     spacegroup(4,0,2,"subgroups")   // second listed subgroup as a map
     spacegroup(4,0,2,1,"subgroups") // second listed subgroup, first transformation
     spacegroup(4,5,1,2,"subgroups") // first listing for 4>>5, second transformation
     spacegroup(4,0,0,0,"subgroups") // an array of arrays of [isub, ntrm, subIndex, type]

  where
   
   *  [ isub, ntrm, subIndex, idet, trType ]
   *  
   *  isub: subgroup ITA number
   *  ntrm: transformation count
   *  subIndex: index of this group-subgroup relationship
   *  idet:  determinant if determinant >= 1; -1/determinant if determinant < 1
   *  trType: 1 translationengelieche, 
   *          3 klassengleiche "ct" loss of centering translation, 
   *          4 klassengleiche "eu" enlarged unit cell

   
JmolVersion="16.2.1" // (legacy) also 16.2.2 (SwingJS)

bug fix: when unit cells are modified, Symmetry should not be assumed to be unchanged.

bug fix: unit cell information should only show space group if symmetry if the unit cell is appropriate

bug fix: with set picking SYMMETRY, double-clicks should not start measurements

bug fix: LOAD SUPERCELL should retain symmetry-relataed cell as "conventional"

new feature: "contrast" color
 -- for LABEL and ECHO, particularly
 -- chooses WHITE or BLACK, depending upon the Jmol window background color
 -- saved in the state as [xfedcba]
 
new feature: set picking SYMMETRY now aliased with set picking SYMOP

new feature: MODELKIT SPACEGROUP "HALL:xx xx xx" will create a space group from a Hall or extended Hall description
 -- future enhancement will allow any HALL description
 -- see  "Space-group notation with an explicit origin", S. R. Hall, Acta Cryst. (1981). A37, 517-525 https://doi.org/10.1107/S0567739481001228
         http://macxray.chem.upenn.edu/LATT.pdf thank you, Patrick Carroll
		 http://cci.lbl.gov/sginfo/hall_symbols.html
		 http://cci.lbl.gov/cctbx/explore_symmetry.html
 
new feature: MODELKIT SPACEGROUP ... UNITCELL [a b c alpha beta gamma] PACKED
 -- after ZAP, creates a new space group with the given unit cell
 -- optionally packing it, if not after ZAP
 -- if the unit cell is incompatible with the space group, a similar compatible cell is used
 
 
version: Version 16.2 represents a major advance in capability for Jmol, particularly in the 
         area of space groups and symmetry in relation to 16.1.1, released 2023.01.24. 
         The following is the listing of 90 new features since then, culled from this file and sorted. 
         More detail on these can be found below.

new feature: CONFIGURATION -n
new feature: CONFIGURATION "A"
new feature: "contrast" color
new feature: crystal structure set picking dragMolecule with ALT implemented 
new feature: DRAW "<hover>xxx</hover>...."
new feature: DRAW boundbox $[isosurface id]
new feature: DRAW boundbox BEST $[isosurface id]
new feature: DRAW HOVERLABEL "xxx"
new feature: DRAW SPACEGROUP @a n
new feature: DRAW SPACEGROUP @n
new feature: DRAW SPACEGROUP ALL 
new feature: DRAW SYMOP [3,4,5] @1
new feature: ECHO/DRAW with ID starting with "_!_" 
new feature: Jmol application -A --scriptarguments flag
new feature: LOAD "$?" load structure from NCI/CADD with prompt
new feature: LOAD "*?" load PDB ID from EBI with prompt
new feature: LOAD ":?" load structure from pubChem with prompt
new feature: LOAD "=?" load PDB ID from RCSB with prompt
new feature: LOAD "==?" load chemical component from RCSB with prompt
new feature: LOAD .... fill "rhombohedral"
new feature: LOAD .... fill "trigonal"
new feature: LOAD =aflowlib/155.2
new feature: LOAD...FILTER "lowPrecision" 
new feature: LOAD...FILTER "PRECISION=n" where n is up to 16 digits
new feature: LOAD - allow CIFReader to ignore COD 2107628 unmodulated operations in presence of modulated
new feature: LOAD - AMS reader
new feature: LOAD - BilbaoReader allows LOAD ... spacegroup ":n" to force origin, where n is 1 or 2
new feature: LOAD - Binary CIF file structure reading. The BinaryCIF file format
new feature: LOAD - CIFReader "ignoreGeomBond" (was SwingJS only)
new feature: LOAD - CIFReader FILTER option NOWYCKOFF
new feature: LOAD - CIFReader reads atom_site_wyckoff_label
new feature: LOAD - CrystalMaker CMDF (binary) file reader
new feature: LOAD - Jmol will accept CIF files with duplicate atom_site_label entries
new feature: MACRO AFLOW adds SHOWSG(n,i,addSymmetry)
new feature: MEASURE .... "default"
new feature: MEASURE SELECT ALL
new feature: MEASURE SELECT...
new feature: MEASURE SELECTED
new feature: MEASURE SELECTED ...
new feature: MINIMIZE GROUP {atoms} 
new feature: MINIMIZE ONLY {atoms} 
new feature: MINIMIZE SELECT {atoms} 
new feature: MODELKIT ADD <elem> WYCKOFF <Aa-z>
new feature: MODELKIT MINIMIZE
new feature: MODELKIT MOVETO @atoms @points
new feature: MODELKIT SET KEY ON/OFF
new feature: MODELKIT SPACEGROUP "HALL:xxxxx" will create a space group from a Hall or extended Hall description
new feature: MODELKIT SPACEGROUP "x,y,z;x,-y,z;..."
new feature: MODELKIT SPACEGROUP ... UNITCELL ...
new feature: MODELKIT VIBRATION WYCKOFF; VIBRATION ON
new feature: POLYHEDRA OFFSET {x, y, z} WIGNERSEITZ
new feature: POLYHEDRA OFFSET 1.0 BRILLOUIN n   where n > 1
new feature: POLYHEDRON LIST
new feature: popup menu adds "atom picking..." Drag Atom and Drag Molecule
new feature: RESTORE UNITCELL name
new feature: SAVE UNITCELL name
new feature: SELECT CONFIG=0
new feature: SET minimizationReportSteps
new feature: SET picking DRAGMOLECULE for crystal structures
new feature: SET picking SYMMETRY now aliased with set picking SYMOP
new feature: SET symmetryHM TRUE
new feature: SMILES/ALLCOMPONENTS flag for generation of SMILES having multiple components
new feature: threaded symmetry-aware UFF minimization of crystal structures.
new feature: UFF minimization with application of symmetry for 
new feature: UNITCELL [a,b,c,alpha,beta,gamma]
new feature: UNITCELL RHOMBOHEDRAL and UNITCELL TRIGONAL (or HEXAGONAL - same)
new feature: ZAP;MODELKIT SPACEGROUP ... UNITCELL [a b c alpha beta gamma] PACKED
new feature: x = (array of SMILES strings).find("SMARTS" or "SMILES", pattern)
new feature: x = _args() and _args(n)
new feature: x = _arguments and _argumentCount added to SET CALLBACK "jmolscript:..."
new feature: x = {*}.find("spacegroup", "parent") 
new feature: x = {atomset}.atoms and {atomset}.label("%[atoms]")
new feature: x = 3x3matrix%1
new feature: x = 3x3matrix%2
new feature: x = atomset.search(pat)
new feature: x = compare(A, B, map) and compare(A, B, map, "stddev")
new feature: x = function special variables _caller, _callers, _name
new feature: x = pattern(<smarts string>) 
new feature: x = search(target, pattern)
new feature: x = spacegroup("ITA/155.1") 
new feature: x = spacegroup("ITA/ALL") 
new feature: x = symop("count")
new feature: x = symop(matrix,option)
new feature: x = symop("wyckoff")
new feature: x = symop("wyckoff", "c")
new feature: x = symop("wyckoff","C")
new feature: x = symop("wyckoff","G")
new feature: x = symop("wyckoff","S")
new feature: x = @@3.symop("wyckoff",option)
new feature: x = {atom}.wyckoff, label %[wyckoff], color PROPERTY WYCKOFF 
new feature: x = string.pop()
new feature: x = string.push("xx")

This extends the initial set of 85 new crystallographic features introduced in version 15.2:
   
new feature: CALCULATE POINTGROUP {atoms}
new feature: CALCULATE SPACEGROUP 
new feature: CALCULATE SPACEGROUP {atoms}
new feature: CENTER UNITCELL 
new feature: DRAW HKL {1 1 1 x.x} 
new feature: DRAW HKL {1 1 1} OFFSET x.x
new feature: DRAW INTERCEPT UNITCELL xxx LATTICE {na nb nc}... HKL ....
new feature: DRAW intersection [unitcell or boundbox description] [line or plane description]
new feature: DRAW intersection [unitcell or boundbox description] LINE @1 @2 
new feature: DRAW intersection [unitcell or boundbox description] ON [line or plane description]
new feature: DRAW POINTGROUP {atoms} CENTER xx
new feature: DRAW UNITCELL xxx LATTICE {na nb nc}
new feature: GETPROPERTY unitCellInfo
new feature: ISOSURFACE SLAB designations "a=" "b=" "c=" "-a=" "-b=" "-c=" "ab" "bc" "ac" "-ab" "-bc" "-ac"
new feature: LOAD .... SPACEGROUP "Hall:P 2y"
new feature: LOAD [some crystal structure] filter "POLYMERX"
new feature: LOAD [some crystal structure] filter "SLABXY"
new feature: LOAD spacegroup 213 unitcell [5 5 5 90 90 90]
new feature: LOAD xxxx.mol FILTER "no3D" 
new feature: LOAD xxxx.mol FILTER "noHydrogen" (Or just "NOH")
new feature: MINIMIZE now works (minimally) with a crystal structure. 
new feature: MODELKIT ON/OFF
new feature: MODELKIT ADD "C" point [PACKED]
new feature: MODELKIT ADD "Cl" {1/2 1/3 1/3}
new feature: MODELKIT ADD "Cl" {1/2 1/3 1/3} PACKED
new feature: MODELKIT ADD @1 
new feature: MODELKIT ADD @1 "Cl" {1/2 1/3 1/3}
new feature: MODELKIT ADD @1 "Cl" {1/2 1/3 1/3} PACKED
new feature: MODELKIT ADD @1 "N"
new feature: MODELKIT ADD @1 "N" PACKED
new feature: MODELKIT ADD @1 PACKED
new feature: MODELKIT ADD @2 "C" [PACKED]
new feature: MODELKIT ADD @2 [PACKED]
new feature: MODELKIT ADD {xxx} PACKED
new feature: MODELKIT ADD C [array of points] 
new feature: MODELKIT ADD/DELETE/MOVETO 
new feature: MODELKIT CONNECT @1 @2 [0,1,2,3,4,5,p,m] (default 1)
new feature: MODELKIT DELETE {atoms}
new feature: MODELKIT FIXED NONE
new feature: MODELKIT FIXED PLANE plane
new feature: MODELKIT FIXED VECTOR point1 point2
new feature: MODELKIT MOVETO @1 {1/2 0 0}
new feature: MODELKIT MUTATE
new feature: MODELKIT PACKED
new feature: MODELKIT ROTATE axis1 axis2 {atoms} degrees
new feature: MODELKIT SET autobond true
new feature: MODELKIT SET hidden true
new feature: MODELKIT SPACEGROUP
new feature: MODELKIT SPACEGROUP "P1"
new feature: MODELKIT SPACEGROUP 123
new feature: MODELKIT SPACEGROUP 123 packed
new feature: MODELKIT SPACEGROUP ... UNITCELL [a b c alpha beta gamma] PACKED
new feature: MODELKIT SPACEGROUP "ITA/itno.setting" (e.g. "ITA/155.2")
new feature: MODELKIT SPACEGROUP "HALL:xx xx xx" 
new feature: MODELKIT UNDO/REDO
new feature: MODELKIT UNITCELL [unitcell description]
new feature: ModelKitCallback 
new feature: MOVETO AXES [-][ab, bc, ca, ba, cb, ac][1, 2, 3, 4]
new feature: plane designations "ab" "ab1" "ac "ac1" "bc" bc1" short for {0 0 1/1 0} {0 0 1/1 c} etc. 
new feature: set picking dragAtom TRUE now recognizes symmetry for crystal structures
new feature: UNITCELL FILL {na nb nc} 
new feature: UNITCELL OFFSET @1; UNITCELL OFFSET {atoms}
new feature: UNITCELL SUPERCELL {na nb nc} 
new feature: UNITCELL SURFACE {h k l} [height | scale%] [offset or offset%] [TOP]
new feature: x = @@1.symop(2, "invariant")
new feature: x = @1.pointgroup("spacegroup")
new feature: x = @1.symop("invariant")
new feature: x = [{point},{point},...].find("equivalent", flags) {
new feature: x = {*}.find("spacegroup") -- discovers the space group for a model 
new feature: x = {*}.find("spacegroup","x,y,-z")
new feature: x = {*}.inchi("fixedh?")
new feature: x = {*}.inchi("standard")
new feature: x = {1/2 1/2 1/2}.symop("invariant")
new feature: x = {1/2 1/2 1/2}.symop(2, "invariant")
new feature: x = {atoms}.pointGroup()
new feature: x = hkl(1 0 0 0.3) to produce plane offset by 0.3 Angstroms from the origin.
new feature: x = load(filename, asbinary, async) or load(filename, nbytesMax, async) or load(filename, "JSON", async)
new feature: x = search(atomset)
new feature: x = spacegroup("123") or spacegroup(123)
new feature: x = spacegroup("x,y,z&-x,y,z") or spacegroup("&x,y,z;-x,y,z") or spacegroup("x,y,z;-x,y,z&")
new feature: x = spacegroup("x,y,z;-x,y,z")
new feature: x = spacegroup("x,y,z;-x,y,z", [a, b, c, alpha, beta, gamma])
new feature: x = spacegroup(6, [a, b, c, alpha, beta, gamma])
new feature: x = symop(2, "invariant")
new feature: x = symop(3,@1,"array") adds "xyzNormalized"
new feature: ZOOM UNITCELL 0
new feature: ZOOMTO UNITCELL 0

bug fix: changing unit cell using just UNITCELL rather than MODELKIT UNITCELL improperly retains symmetry
 -- when the unit cell is offset, symmetry should drop to P1
 -- when the unit cell is RESET or otherwise returned to the one associated
    with the space group, symmetry should be returned
    
bug fix: unit cell information displayed should represent the space group accurately
 -- file-based symmetry initially should reflect the opertors from the file
 -- after MODELKIT SPACEGROUP, the information should reflect a specific 
    setting in Jmol and ITA, if found.

new feature: MODELKIT SPACEGROUP ... UNITCELL ...
 -- adds the ability to set the space group and unit cell at the same time
 -- unit cell parameters must be compatible with the space group, or the action is aborted
 -- unit cell can be expressed in one of three formats:
    -- as the array [a b c alpha beta gamma] 
    -- as the array  of cartesian vectors [origin, va, vb, vc}
    -- as the setting transtormation string "a,b,c;0,0,0"  

new feature: set symmetryHM TRUE
 -- for show/calculate/draw POINTGROUP
 -- TRUE switches to Hermann-Mauguin (2m, 2/m2/m2/m) notation
 -- FALSE switches back to the default Schoenflies (C2v, D2h) notation 

example script:

 -- creating a group-subgroup comparison, where the transform between settings is known
 -- based on information at https://www.cryst.ehu.es/cgi-bin/cryst/programs/nph-tranmax?way=up&super=20&sub=4&index=2&client=maxsub&what=&path=&series=&conj=all&type=t
 
	zap
	modelkit spacegroup 20
	draw u20 unitcell color orange mesh nofill "uc-20"
	modelkit add P Wyckoff G
	// switching to sg 4 -- note that the listed transform matrix 
	// is for subgroup to supergroup; we need the opposite here, thus the "!" prefix
	modelkit spacegroup 4 unitcell "!1/2a+1/2b,c,1/2a-1/2b"
	// drawing unit cell and operations
	draw uc4 unitcell diameter 0.01 color orange mesh nofill "uc-4"
	color property site
	draw id "s12" symop @1 @2
	draw id "s43" symop @4 @3
	draw id "s56" symop @5 @6
	draw id "s87" symop @8 @7
	draw id "sg4" spacegroup all
	//write c:\\temp\\iucr\\g20-sg4-w-4-draw.png as PNGJ
	// switching back to sg 20:
	modelkit spacegroup 20 unitcell "1/2a+1/2b,c,1/2a-1/2b"
	print symop("wyckoff")
	print {*}.wyckoff.pivot;
	// switching to sg 4:   
	modelkit spacegroup 4 unitcell "!1/2a+1/2b,c,1/2a-1/2b"
	print symop("wyckoff")
	print {*}.wyckoff.pivot;


JmolVersion="16.1.63" // (legacy) also 16.1.64 (SwingJS)

bug fix: (legacy JavaScript only) secondary structure reading broken in 16.1.59

bug fix (legacy JavaScript only) script fails when referencing undeclared variable

bug fix: PDB file with all UNK residues considered "not PDB" and skips reading sequence number
 -- logic changed to also check for only one residue number
 
new feature: MODELKIT VIBRATION WYCKOFF; VIBRATION ON
 -- atoms "rattle" in their Wyckoff position
 -- just for fun; not a real vibration

new feature: MODELKIT SET KEY ON/OFF
 -- adds an element key in the upper right corner
 -- must be individually added per frame and after file loading
 -- only visible when only a single model is visible
 -- element symbols colors use black/white contrasting with background
 -- recognizes different isotope colors
 -- does not get created appear if atoms of the same element have different colors
 -- automatically updated if MODELKIT ADD/ASSIGN/DELETE are used
 
new feature: ECHO/DRAW with ID starting with "_!_" 
 -- reserved for "single-model-only" echo and draw 
 -- hidden when more than one frame is visible
 -- used by element key so that keys do not overlap
  bug fix: PWMAT reader failing with SUPERCELL option

bug fix: SHOW DATA * fails
bug fix: SHOW DATA TYPES fails

bug fix: saved state for draw [x y %] ignored when read back in.

bug fix: modelkit moveto @8 {2 3 4} not working properly
 -- should behave the way modelkit ADD C {3 3 3} works, 
    which is whether or not there is a cyrstal structure
 -- should adhere to modelkit SET ADDHYDROGEN setting of true or false
  
bug fix: CIF reader should only check repeated atom label within a given blocks
 -- problem was with files that have anisotropic parameters before _atom_site
 -- solution is to only check for duplicates within single loop blocks
 -- test case: LOAD =COD/2004513 centroid; wireframe only ; ellipsoids on
 
bug fix: (Java only) Jmol Script Console <TAB> completion of file names starting with " 
    double quote adding "null" when no match is found; should just terminate with "/"

bug fix: crystallographic set picking draw molecule does not work if a fragment is found
 -- should expand/move selection to the largest molecule with the same set of sites

documentation correction: getproperty "dataInfo" not getProperty "data", and description 
  is incorrect. This should read:
  
  	x=getProperty("dataInfo", "types") or GETPROPERTY DATAINFO TYPES
  
  		returns an array of two strings: ["types",<list>]
  		where <list> is a string that is a comma-separated list of data names

	x=getProperty("dataInfo", "*") or GETPROPERTY DATAINFO *
  
		returns the array of data names
  
	x=getProperty("dataInfo", "property_xxx") // case ignored
	
		return an array that consists of:
		
			[1] the exact-case name of the property
			[2] the array of values
			[3] a bitset indicating the associated atoms
			[4] an integer used internally
			[5] a string that will be non-null if the value is from the loaded file
			
    getProperty("DATAINFO") and GETPROPERTY DATAINFO both default to "TYPES"
    			   
 
bug fix: set echo ID "X" {0 0 0}  does not place the echo at {0 0 0}

bug fix: set echo ID "X" offset {0 0 0} results in a very tiny font with SET FONTSCALING TRUE

bug fix: echo @x with trailing space gives "@x" instead of the value of variable x

bug fix: echo "\\@{...}" loses "\\" when saved in state

bug fix: POLYHEDRA command should allow keywords following center specification: POLYHEDRA @6 COLLAPSED

bug fix: (legacy only) dragging a molecule around to rotate it should continue
         after the mouse leaves the applet space (Fix was in JSmolCore.js, part of JSmol.min.js)

bug fix: print symop("wyckoff") only prints the {x,y,z} general coordinate; should print all

bug fix: print symop("wyckoff", label) should include centering
  -- for example:
  
	 $ modelkit spacegroup 20
	 $ print symop("wyckoff", "a")
		 (x,0,0) (-x,0,1/2)  (x+1/2,1/2,0)  (-x+1/2,1/2,1/2)

feature change: (legacy only) now using jQuery 3.7.1
 -- previous version of jQuery (jQuery 1.11.0) is still there is needed
  
new feature: symop("wyckoff","C")
 -- returns centering as an array, possibly empty
 -- for example:
 
	 $ modelkit spacegroup 20
	 $ print symop("wyckoff", "C")
 	   {0.5, 0.5, 0}
 	
new feature: symop("wyckoff","S")
 -- returns centering as a string
 -- for example:
 
	 $ modelkit spacegroup 20
	 $ print symop("wyckoff", "C")
 	   (1/2,1/2,0)
 	
new feature: symop("wyckoff","G")
 -- returns general position coordinates as a string
 -- for example:
 
	 $ modelkit spacegroup 20
	 $ print symop("wyckoff", "G")
	   (x,y,z) (-x,-y,z+1/2) (-x,y,-z+1/2) (x,-y,-z) (x+1/2,y+1/2,z) (-x+1/2,-y+1/2,z+1/2) (-x+1/2,y+1/2,-z+1/2) (x+1/2,-y+1/2,-z)


JmolVersion="16.1.61" // (legacy) also 16.1.62 (SwingJS)

-- release deleted -- see 16.1.63

JmolVersion="16.1.59" // (legacy) also 16.1.60 (SwingJS)

-- release deleted -- see 16.1.63

JmolVersion="16.1.57" // (legacy) also 16.1.58 (SwingJS)

bug fix: (legacy only) bad release 16.1.55 removed. (accidentally put 16.1.57 in 16.1.55 folder)

new feature: x = symop("count")
 -- returns the number of symmetry operators
 

JmolVersion="16.1.55" // (legacy) also 16.1.56 (SwingJS)

bug fix: (JavaScript, legacy) ellipsoids do not render
 -- 16.1.53 release was flawed
 
bug fix: (JavaScript, legacy) BCIF file format not recognized as binary by JSmol file reader
 -- legacy JSmol only (Jmol-SwingJS reads all files as binary)
 -- solution was to add .bcif to Jmol._binaryTypes string in JSmolCore.js (part of JSmol.min.js) 
 
bug fix: (Legacy JavaScript only) SET LANGUAGE does not work 
 -- jsmol/idioma directory is no longer necessary, but JS native code was still
    pointing to it
 -- JavaScript and Java now both use org/jmol/translation/JmolApplet/*.po

bug fix; FRAME ALIGN {*} first model is incorrectly offset
 
bug fix: Binary CIF Reader not adding secondary structure fields

bug fix: MODELKIT SPACEGROUP xxx does not set atom site correctly. 

bug fix: POLYHEDRON BRILLOUIN not fully functional

new feature: POLYHEDRON LIST
 -- provides information about current polyhedra

new feature: POLYHEDRA OFFSET 1.0 BRILLOUIN n   where n > 1
 -- produces an "exploded view" of 1st-nth BRILLOUIN zones
  
new feature: POLYHEDRA OFFSET {x, y, z} WIGNERSEITZ
 -- creates a Wigner-Seitz unit cell that is centered on the given point
 -- accepts fractional coordinates such as {1/2 1/2 1/2} or {1 1 1/1}
  
new feature: UNITCELL [a,b,c,alpha,beta,gamma]
 -- sets unit cell to the array of parameters, with no offset
 -- same as UNITCELL "a=...,b=...,c=...,alpha=...,beta=...,gamma=...."
 
new feature: SAVE UNITCELL name
 -- name is optional and defaults to ""
 -- saves the current unit cell with the given name
 -- names are preserved across file loading and ZAP
 
new feature: RESTORE UNITCELL name
 -- restores the saved unit cell with the given name
 -- if no name is given, uses last saved name

new feature: crystal structure set picking dragMolecule with ALT implemented 
 -- rotates all equivalent molecules appropriately around their centers
 -- all molecules will be locked if any of their atoms will break symmetry by moving
 -- example (space group #41 Aba2):
 
	  load "https://chemapps.stolaf.edu/jmol/jsmol/data/k04041.cif" {1 1 1}; 
	  set picking dragMolecule
    
    or open 
    
      https://chemapps.stolaf.edu/jmol/jsmol/simple.htm?%20%20load%20%22data/k04041.cif%22%20{1%201%201};%20set%20picking%20dragMolecule
    
    Now drag or alt-drag a molecule. All molecules will move appropriately 
    according to their symmetry. 
    
    Challenge: Can you figure out the symmetry elements for this
    space group just by moving the molecules? If not, try:
    
      draw spacegroup all
      
    and then move them some more. Where are the C2 axes? The glide planes? 
    How are each pair of molecules related by a symmetry operation?
  

JmolVersion="16.1.53" // (legacy) also 16.1.54 (SwingJS)

bug fix: (legacy only) build issue with jsmol.zip prevents JSmol from working

bug fix: jsmol.php fails to relay HashMap.js
  - wrong content header for utf-8 characters; j2smol.php updated
  - removed utf-8 characters in HashMap.js, Hashtable.js, and LinkedHashMap.js
  - removed HashMap dependency in SymmetryOperation added in 16.1.43/44
  - removed LinkedHashMap dependency in BCIFReader

bug fix: CIF reader unnecessarily adding atom label numbers (broken in 16.1.51/52

bug fix: script queue is clearing prematurely; only the first-queued script runs (broken in 16.1.47/48)

bug fix: modulated structure CIF reader never implemented PACKING x.x

bug fix: magCIF files fail to load after CIF precision adjustment

bug fix: load SUPERCELL can double size of supercell

bug fix: load SUPERCELL misassigns atom site, making set picking dragMolecule not work properly

new feature: set picking DRAGMOLECULE for crystal structures
 -- allows dragging ONLY if the selected molecule's symmetry allows all atoms to be translated
 -- includes all equivalent molecules for which symmetry allows this translation 

feature change: {*}.find("spacegroup") should not automatically reduce to the parent unit cell if currently a supercell
 -- change to 15.2.20/14.32.20

new feature: {*}.find("spacegroup", "parent") 
 -- reduces to the parent unit cell if currently a supercell
 -- for example, to show the parent cell of a supercell:
 
      unitcell @{{*}.find("spacegroup", "parent").unitcell}
      
      
JmolVersion="16.1.51" // (legacy) also 16.1.52 (SwingJS)

new feature: Binary CIF file structure reading. The BinaryCIF file format
   https://github.com/molstar/BinaryCIF  "BinaryCIF is a data format that 
   stores text based CIF files using a more efficient binary encoding. 
   It enables both lossless and lossy compression of the original CIF file."
    
   - Prior to this release, BCIF was only supported in Jmol for molecular 
   	 electron density map files. 
   - Shortcut =xxxx.bcif  goes to https://models.rcsb.org/xxxx.bcif
   - VERY large files can be loaded successfully. Recommendation is
     to use SET AUTOBOND FALSE and to load with filter "*.C" for backbone only:

	 t = now()     
     set autobond false;
     load =8glv.bcif filter "*.C";
     spacefill on;
     color chain;
     print now(t)
     
   - times for transfer and display can be less than 1/2 of that for CIF files

feature adjustment: SCALE improved

bug fix: packing range using LOAD ... PACKED 0.3   broken in 16.1.49/50


JmolVersion="16.1.49" // (legacy) also 16.1.50 (SwingJS)

bug fix: DRAW ID "xx" SYMOP... does not recognize ID

bug fix: DRAW ID "xx" SPACEGROUP does not recognize ID

bug fix: load of crystal structure should adjust field of view to full unit cell

bug fix: American Minerologist Society (load =ams/quartz) now https, not http
 - Jmol will automatically convert http to https in old scripts. 
 - older installations will need updating. 
 
bug fix: echo ID xx {x y z} does not default to LEFT, instead a 2-angstrom shift to the right.

bug fix: (16.1.47 only) DRAW SPACEGROUP 150 ALL fails 

bug fix: (JSpecView) error reading files with (c) symbol or other non-UTF-8 special characters.

buf fix: (JavaScript Legacy only) refactoring of Hashtable to use JavaScript Map in legacy transpiler
 - should be considerably faster

bug fix: (JavaScript only) fixes CIF writer with SET DOUBLEPRECISION

bug fix: CIF writer does not respect originating precision of CIF data. 
 - problem 1 was that garbage was being added to CIF fractional coordinate
   output due to digital representations of numbers. 
 - problem 2 was that imprecise description of twelfths in CIF input ("0.3333")
   were not being represented as their fraction. 
 - problem 3 was that due to this misrepresentation, packing could be off, 
   calculation of space group, and determination of Wyckoff positions all 
   could be off. 
     
bug fix: (JmolD only) double precision output truncating for XYZ file 
 - changed from 10.5 to 16.10 format.

bug fix: (JavaScript and JmolD only) double precision output for CIF file truncating.

new feature: print @@3.symop("wyckoff",option)
 - returns a string of wyckoff information depending upon the option
 - uses Bilbao Crystallographic Database WYCKOFF results
    - see https://github.com/BobHanson/Jmol-SwingJS/blob/master/src/org/jmol/symmetry/sg/json
 - option absent, null, "", or "label"
 	- return wyckoff position label calculated for this atom, such as "g"
 	- compare with {atom}.wyckoff, which will calculate the Wyckoff position
 	  only if not found in the CIF file. (Note that AFLOW Encyclopedia files 
 	  for example, LOAD =aflowlib/125.1, do contain _atom_site_Wyckoff_label) 
 - option "coord"
 	- returns the Wyckoff position coordinate string, such as "(0,x,y)"
 	- if centering was needed, that centering is added: "(1/4,0,3/4)+(1/2,0,1/2)"
 - option "coords"
    - returns the list of coordinates for this atom's Wyckoff position label
      including space-separated label, centerings, and positions
    - for example:
    	$ zap
		$ modelkit spacegroup 225
		$ modelkit add Ti wyckoff d
		$ print @@2.symop("wyckoff","coords")
		d +(0,1/2,1/2)+(1/2,0,1/2)+(1/2,1/2,0)  (0,1/4,1/4) (0,3/4,1/4) (1/4,0,1/4) (1/4,0,3/4) (1/4,1/4,0) (3/4,1/4,0)
 - option "*"
    - returns the full set Wyckoff information for this space group
      as set of lines, starting with the centering and then listing the 
      Wyckoff position labels and coordinates in order of precedence (a,b,...)
    - same as just symop("wyckoff").
    
 - for example:
	$ load =aflowlib/225.1 packed filter "precision=3"
	$ print {*}.wyckoff.pivot
	{
	  "a"  :  14
	  "i"  :  72
	}
 	$ print @1.wyckoff
	a

	$ print @7.symop("wyckoff")
	a

	$ print @1.symop("wyckoff","coord") 
	(0,1/4,1/4)

	$ print @7.fxyz

	$ print @60.symop("wyckoff","coord")
	(-y,y,1/2)+(1/2,0,1/2)

	$ print @2.symop("wyckoff","coords")
	d +(0,1/2,1/2)+(1/2,0,1/2)+(1/2,1/2,0)  (0,1/4,1/4) (0,3/4,1/4) (1/4,0,1/4) (1/4,0,3/4) (1/4,1/4,0) (3/4,1/4,0)

	$ print @2.symop("wyckoff","*") // or $ print symop("wyckoff")
	
	+(0,1/2,1/2)+(1/2,0,1/2)+(1/2,1/2,0)
	a (0,0,0)
	b (1/2,1/2,1/2)
	c (1/4,1/4,1/4) (1/4,1/4,3/4)
	d (0,1/4,1/4) (0,3/4,1/4) (1/4,0,1/4) (1/4,0,3/4) (1/4,1/4,0) (3/4,1/4,0)
	e (x,0,0) (-x,0,0) (0,x,0) (0,-x,0) (0,0,x) (0,0,-x)
	f (x,x,x) (-x,-x,x) (-x,x,-x) (x,-x,-x) (x,x,-x) (-x,-x,-x) (x,-x,x) (-x,x,x)
	g (x,1/4,1/4) (-x,3/4,1/4) (1/4,x,1/4) (1/4,-x,3/4) (1/4,1/4,x) (3/4,1/4,-x) (1/4,x,3/4) (3/4,-x,3/4) (x,1/4,3/4) (-x,1/4,1/4) (1/4,1/4,-x) (1/4,3/4,x)
	h (0,y,y) (0,-y,y) (0,y,-y) (0,-y,-y) (y,0,y) (y,0,-y) (-y,0,y) (-y,0,-y) (y,y,0) (-y,y,0) (y,-y,0) (-y,-y,0)
	i (1/2,y,y) (1/2,-y,y) (1/2,y,-y) (1/2,-y,-y) (y,1/2,y) (y,1/2,-y) (-y,1/2,y) (-y,1/2,-y) (y,y,1/2) (-y,y,1/2) (y,-y,1/2) (-y,-y,1/2)
	j (0,y,z) (0,-y,z) (0,y,-z) (0,-y,-z) (z,0,y) (z,0,-y) (-z,0,y) (-z,0,-y) (y,z,0) (-y,z,0) (y,-z,0) (-y,-z,0) (y,0,-z) (-y,0,-z) (y,0,z) (-y,0,z) (0,z,-y) (0,z,y) (0,-z,-y) (0,-z,y) (z,y,0) (z,-y,0) (-z,y,0) (-z,-y,0)
	k (x,x,z) (-x,-x,z) (-x,x,-z) (x,-x,-z) (z,x,x) (z,-x,-x) (-z,-x,x) (-z,x,-x) (x,z,x) (-x,z,-x) (x,-z,-x) (-x,-z,x) (x,x,-z) (-x,-x,-z) (x,-x,z) (-x,x,z) (x,z,-x) (-x,z,x) (-x,-z,-x) (x,-z,x) (z,x,-x) (z,-x,x) (-z,x,x) (-z,-x,-x)
	l (x,y,z) 

new feature: symop("wyckoff")
 - retrieves full list of current space group's Wyckoff positions
 - same as but simpler than {*}.symop("wyckoff")

new feature: symop("wyckoff", "c")
 - just gives the list of coordinates for the "c" Wyckoff position

new feature: LOAD...FILTER "lowPrecision" 
 - precision set to 4 (+/-0.0001) for fractional coordinates  
 - specifies that crystal structure readers should not attempt to raise the 
   precision to single- or double-precision even if the file contains double-precision data
 - also sets PACKED 0.0001 rather than the standard default value of 0.02 
   (which tends to allow too many atoms to be included)
  
new feature: LOAD...FILTER "PRECISION=n" where n is up to 16 digits
 - specifies the precision to use for a given CIF file
 - can also be used to lower the precision 
   For example, AFLOWLIB files tend to have their precision hidden by padding
   with zeros:
   
	   U1 U   4 a 0.00000 0.00000 0.00000 1.00000
	   B1 B  48 i 0.50000 0.66600 0.66600 1.00000
       
   This could cause trouble with some edge cases, so one could use FILTER "PRECISION=3"
   in thise case to explicitly ignore the padding and turn, "0.666" into "0.66666667".
     
Note regarding precision:

      The issue of double or float (aka "single") precision has a long history in Jmol. 
	  Early on, using floats seemed reasonable, as it was the more memory-efficient than 
	  using double. And it seemed unnecessary to do anything more precise. 
	 
	  But it has always been a problem (and boon!) that JavaScript is DOUBLE precision by 
	  design. This resulted in very slight differences between Java and JavaScript in Jmol, 
	  particularly for loading crystal structures, where there is often a very thin line 
	  between being "in" the unit cell and being "out" or being close to a symmetry element
	  or not. Or being the same atom produced by two different symmetry operations or not.
	  The problem was largely solved in 2014 for Jmol 14.3.5 by trimming float and double 
	  precision in both Java and JavaScript down to common level during the reading of 
	  crystal structures. This normalization of coordinates and other key values in file 
	  reading allowed Java and JavaScript to load files identically.
	  
	  Ah, but then in 2022 we started to see crystal structures derived from computation, 
	  where full double precision is expected. The question was how to get JavaScript 
	  working in double precision even if its originating Java was in float precision.
	  This was a significant challenge. The solution was to create the "doublePrecision" 
	  setting in Jmol 14.32.42 (2022.03.24), which specifically allows Jmol legacy 
	  JavaScript to retain its full double precision without doing anything in Java. 
	  Of course, that meant that PNGJ files and other scripts might read a structure 
	  differently in Java than in JavaScript, particularly if there are atoms present 
	  that are very close to a unit cell face when LOAD...PACKED is used. But that was 
	  still a good solution for browser based applications such as the Q-Studio crystal 
	  building web interface we were developing for PWMAT. 
	  
	  The problem has been that of not finding all the places where Jmol was normalizing 
	  the double values of JavaScript with the float values of Java.
	 
	  Thus the above bug fixes. 
	  
	  The current situation is as follows:
	  
		"legacy" JSmol JavaScript will handle double precision properly after
		
			SET doublePrecision TRUE
			
	  	"legacy" Java Jmol cannot process crystal structures in full double precision. 
	  	The default value of doublePrecision for legacy Java Jmol is FALSE, and it cannot
	  	be changed.

		Jmol-SwingJS (Java "JavaD.jar" and JavaScript) is completely double-precision 
		and is unaffected by this setting. Its default is TRUE, and that value cannot
		be changed. 

		So this is all about legacy JavaScript JSmol.
		
		Two file readers, CIF and PMAT, will set doublePrecision automatically. 
		These readers detect the precision of the data from the number of decimal
		places in the fractional coordinates. "0.6667" would indicate four digits
		of precision, for example. If a CIF file has 10 or more decimal digits, 
		doublePrecision will be set TRUE while reading. In addition, if a PWMAT file 
		is read, doublePrecision will always be set TRUE. These are temporary settings, 
		only for file reading. So if this is all you are using it for, you do not need 
		to set doublePrecision TRUE yourself. 
		
		In addition, if you are using legacy JavaScript, you should set this value true
		when you start up Jmol in any of the following situations:
		
		* You are finding the space group for a structure using CALCULATE SPACEGROUP.
		* You are building a crystal structure using the Jmol ModelKit
		* You are setting the space group using MODELKIT SPACEGROUP.
		* You are dragging symmetry-equivalent atoms of a crystal structure using set DRAGATOM.
		* You are labeling atoms or selecting them using Wyckoff positions. 

		All of these crystal structure-related operations are best done with the 
		lowest tolerances possible -- that is, the highest precision. But it is also
		quite possible that you will not notice any particular issue here.
		
		The problem occurs because experimentally based CIF files by nature have low 
		precision -- perhaps only four or five significant digits. For these structures, 
		we do NOT want to have high precision all the time. If we did, the values in the 
		files might not be mathematically close enough to the ideal to make these functions
		work reliably. 
		
		
JmolVersion="16.1.47" // (legacy) also 16.1.48 (SwingJS)

bug fix: MODELKIT SPACEGROUP ... for no-atom structure does not properly set unit cell lengths

bug fix: LOAD ==HEM (PDB ligand) loading broken in 16.1.45 (2023.11.06)

bug fix: LOAD =ams/quartz broken in 16.1.45

bug fix: CIFReader may misread incommensurately modulated files that have multiple structures

bug fix: SCALE maximum length 1/2 what it should be with set antialiasDisplay off

bug fix: fixes DRAW SPACEGROUP ALL for unit glide in #88, missing planes in #156

bug fix: fixes DRAW SPACEGROUP (ALL) diamond glides of +/-3/4 listed as "g" instead of "d"

bug fix: fixes DRAW SPACEGROUP (ALL) diamond glides of +/-3/4 instead of -/+1/4 

new feature: LOAD .... fill unitcell rhombohedral
 - fills a rhombohedral unit cell for a structure that is trigonal in file
 - ignored unless the symmetry is trigonal
 - does NOT transform operators -- for that, follow this with MODELKIT SPACEGROUP "..."

new feature: LOAD .... fill unitcell trigonal
 - fills a trigonal unit cell for a structure that is rhombohedral in file
 - ignored unless the symmetry is trigonal
 - does NOT transform operators -- for that, follow this with MODELKIT SPACEGROUP "..."

new feature: LOAD ... fill unitcell "2a,a-b,..."
 - allows generic fill of specified unit cell
 - can be used with any space group
 - will accept packing lattice such as {2 2 2} just before FILL
 - does not transform operators -- for that, follow this with MODELKIT SPACEGROUP "..."
 - for example: 
 
   load =aflowlib/148.1 fill unitcell "2/3a+1/3b+1/3c,-1/3a+1/3b+1/3c,-1/3a-2/3b+1/3c" 
   modelkit spacegroup "148:r"
   draw spacegroup all
   
new feature: LOAD =aflowlib/155.2
 - loads the second AFLOW prototype in spacegroup 155 at https://www.aflowlib.org/prototype-encyclopedia
 - full listing of thes AFLOW codes codes employed is in
 - https://github.com/BobHanson/Jmol-SwingJS/tree/master/src/org/jmol/symmetry/sg/json/aflow_structures.json
 

JmolVersion="16.1.45" // (legacy) also 16.1.46 (SwingJS)

bug fix: GaussianReader misreading high-level spherical MO data (9G, 11H, 13I)

new feature: x = spacegroup("ITA/ALL") 
 - provides detailed information about general positions, generators, and Wyckoff positions 
   for all space groups and their additional ITA settings (611 in all) as found using  
   https://www.cryst.ehu.es/cgi-bin/cryst/programs/nph-getgen
 - keys include: 
		gen      array of generators
		gp       array of general positions 
		id       HM name such as P23
		jmolId  full ITA name, with setting, such as 8:b1 or 227:2; may be "ita?." 
		set      setting index in this space group: 1, 2, 3, ...
		sg       space group number: 1, 2, 3, ...
		tm       transformation matix descriptor for this setting: "a,b,c" or "a-3/8,b-3/8,c-3/8" 
		u		 unabridged ITA title, such as "P n -3 m  [origin 2]"
		wpos     Wyckoff positions, a map with keys:
		             cent   an array of centerings (if applicable)
					 pos    the Wyckoff position; an array of maps with keys:
					 			 desc	  the ITA description, such as "1" or "m.."
					 			 geom     the type of position, one of "point", "line" or "plane"
					 			 label    the single-character label [a-zA]
					 			 mult     the multiplicity

new feature: x = spacegroup("ITA/155.1") 
 - retrieves the first JSON structure in org/jmol/symmetry/sg/json/ita_155.json
 
new feature: UNITCELL RHOMBOHEDRAL and UNITCELL TRIGONAL (or HEXAGONAL - same)
 - allows switching back and forth between rhombohedral and hexagonal unit cells. 
 - does not change the space group (assumes currently rhombohedral if trigonal or hexangonal is chosen
   and vice versa)
 - does not check to see that this is reasonable
 - applies for rhombohedral:  UNITCELL "2/3a+1/3b+1/3c,-1/3a+1/3b+1/3c,-1/3a-2/3b+1/3c"
 - applies for trigonal:  UNITCELL "a-b,b-c,a+b+c"
 
new feature: MODELKIT ADD <elem> WYCKOFF <Aa-z>
 - adds an atom in a representative position for the given Wyckoff position. 
 - generates all symmetry-equivalent atoms. 
 - for example: modelkit add C wyckoff d
 - the "seed" position is at the relatively arbitrary position of (2.3/5, 2.3/7, 2.3/9). 
 - this point is projected onto the specified Wyckoff position element (point, line, or plane). 
 - after generation, this point can be moved within the confines of the Wyckoff position
   constraint using SET PICKING DRAGATOM 


JmolVersion="16.1.43" // (legacy) also 16.1.44 (SwingJS)

new feature: MACRO AFLOW adds SHOWSG(n,i,addSymmetry)
 - displays example i of every space group (n) -- though not every setting
 - taps https://www.aflowlib.org/prototype-encyclopedia/
 - see AFLOW Encyclopedia of Crystallographic Prototypes, 
   https://www.aflowlib.org/prototype-encyclopedia; 
   M. J. Mehl, D. Hicks, C. Toher, O. Levy, R. M. Hanson, 
   G. L. W. Hart, and S. Curtarolo, 
   The AFLOW Library of Crystallographic Prototypes: Part 1, 
   Comp. Mat. Sci. 136, S1-S828 (2017). 
   (doi=10.1016/j.commatsci.2017.01.017) and related publications
 - n is space group number, from 1 to 230
 - i is index 1-m where m is the number of space groups in the encyclopedia for that number
 - addSymmetry TRUE to add DRAW SPACEGROUP ALL to show operations
  
bug fix: MODELKIT SPACEGROUP <name or number> does not work if there are no atoms
 - now creates a generally satisfactory unit cell when no atoms are present
 - unit cells are not adjusted to have different a,b,c for "unique origin" groups

bug fix: (SwingJS only) SHOW SPACEGROUP loses operator translations in SHOW SPACEGROUP

bug fix: show Symmetry/SpaceGroup/Symop will show g-glide, not d-glide for cubic 3/4,1/4,1/4 glides

bug fix: (undocumented) -matrix (unary minus; 3x3 or 4x4) should transpose, not 
 - careful -- 4x4 transpose is all four rows for columns
     
feature change: DRAW SPACEGROUP simplified (was basically unusable)
 - just shows geometric elements, not targets

feature change: DRAW SYMOP n and DRAW SYMOP "x,-y,z" no longer default to using the first atom. 
 - new default is the origin, {0 0 0} 
 - allows for consistency after MODEL SPACEGROUP xxx, when there are no atoms.

new feature: 3x3matrix%1
 - returns trace 
 
new feature: 3x3matrix%2
 - returns determinant
 
new feature: x = symop(matrix,option)
 - allows introduction of a matrix as a  symmetry operation
 - accepts various options such as "xyz"; default is still matrix
 
new feature: MODELKIT SPACEGROUP "x,y,z;x,-y,z;..."
 - allows creating a space group from a full operation list
 
new feature: DRAW SPACEGROUP ALL 
 - displays all "additional geometric elements" (planes, axes, points)
   resulting from adding translations to the described symmetry operation

new feature: DRAW HOVERLABEL "xxx"
 - allows for a hover label that appears whether or not drawHover is on.
 
new feature: DRAW "<hover>xxx</hover>...."
 - used for saving the hover label in a state
   (or, at least it allows no error in earlier versions; will show up as text)

new feature: CIFReader reads atom_site_wyckoff_label

new feature: CIFReader FILTER option NOWYCKOFF
 - to skip reading atom_site_wyckoff_label (for Jmol development testing purposes, primariy)

new feature: {atom}.wyckoff, label %[wyckoff], color PROPERTY WYCKOFF 

JmolVersion="16.1.41" // (legacy) also 16.1.42 (SwingJS)

new feature: AMS reader
 - adds Atomic charge as partial charge for last model and all vibrations

bug fix: select config='' fails for residue-order alternate locations
 - when all 'A' listed first, then all 'B' for a residue

bug fix: select config=-n fails for residue-order alternate locations 

bug fix: select config=0 fails for residue-order alternate locations

JmolVersion="16.1.39" // (legacy) also 16.1.40 (SwingJS)

new feature: string.push("xx")
  -- appends a string to a string

new feature: string.pop()
  -- pops a character off a string
  
new feature: {atomset}.atoms and {atomset}.label("%[atoms]")
  -- same as {atomset}.label("[%n]%r:%c.%a")
  -- specifically does not include altloc
  -- can be used to identify associated altlocs efficiently
  -- example use:
  
  			history off
			load =5pol
			altlocKeys = {}
			altlocAtoms = {};
			theatoms = {altloc!=''}
			for (var a in theatoms){
				var name = a.atom;
				if (!altlocKeys[name]) {
					altlocKeys[name] = "";
					altlocAtoms[name] = ({});
				}
				altlocKeys[name].push(a.altloc);
				altlocAtoms[name] |= a.atomIndex;
			}
			history on
			
     resulting in the creation of the arrays altlocKeys and altlocAtoms, which
     group alternate location codes and atom sets by atom name:
     
     	{ 
     	  "[8RP]201:A.C1": "D",
     	   ...
     	  "[MET]23:B.SD"  : "CD"
     	}
     	
     	and 
     	
     	{
     	  "[8RP]201:A.C1"  :  ({2093}),
     		...
     	  "[MET]23:B.SD"  :  ({1039 1040})
     	}
     
new feature: AMS reader
 - version extension of ADF reader
 - adds Atomic charge as partial charge for last model and all vibrations

bug fix: patch #40 ADF/AMS output support (Diego Gayaga)
 - support for ADF output files was not working
 - for geometry optimizations, only the initial geometry was grabbed
   without actually being able to visualize the optimized structure. 
   Moreover, vibrational displacements were being applied to this initial structure, 
   which was not consistent. 
 - newer versions of the ADF code are now named Amsterdam Modeling Suite (AMS) 
   instead of ADF; these files were also not properly supported.
 - bonding energy as a model property is also added.

 
JmolVersion="16.1.37" // (legacy) also 16.1.38 (SwingJS)

bug fix: set picking dragAtom does not update measurements

bug fix: MODELKIT MOVETO @1 {1/2 1/3 1/2} does not update measurements

bug fix: UNITCELL SURFACE {h k l height offset} can fail to find 90-deg option

bug fix: DRAW POINTGROUP or CALCULATE POINTGROUP can result in C2h instead of C2v
         because it a check for linearity was not normalizing prior to taking the dot product
         For example, (nonlinear) SO2. 

bug fix: export of X3D creates abnormally large unit cell lines due to error in passing width parameter to __CartesianExporter

bug fix: GaussianReader -- Fixes need to detect pure/Cartesian formalism when basis set is read from chk file. (by marco-foscato)

bug fix: CONNECT AROMATIC AUTO fails to generate double bonds for carbonyl groups

bug fix: CONNECT AROMATIC AUTO fails to create triple bonds

new feature: select CONFIG=0
  - selects for all atoms that have fewer than two alternate locations. 
  - these are the atoms that, using an atom-based (FirstGlance) rather than a residue-based (PDB spec)
    interpretation of "conformation" will be included in every conformation. 
  - equivalent to {config=-1 & config=-2 & ... & config=-N} where N is the number of 
    altloc possibilities for a model, specifically {thismodel && altloc!=''}.altloc.pivot.keys.count
   


JmolVersion="16.1.35" // (legacy) also 16.1.36 (SwingJS)

new feature: DRAW SPACEGROUP @a n
  - draws just the nth non-identity operation for which 
  	the specified atom @a (in the current model only, same as @@a) is invariant
  - note that the identity operation is not included in this set
  - If the the atom is in a general position or n is greater
    than the number invariant operations, nothing is drawn.
  - if n is absent or zero, all invariant operations are drawn.
  - for example:
  
     load =ams/marcasite 1 packed
     draw spacegroup @2
     
       -x,y,z mirror plane
  
     draw spacegroup @3
     
       -x,y,z mirror plane
	   x,-y,-z C2 axis
       -x,-y,-z Ci: 0 0 0

     draw spacegroup @3 2
	   x,-y,-z C2 axis
       

bug fix: uc = unitcell("a=5.469,b=5.469,c=5.469,alpha=120,beta=90,gamma=90") fails
  - (broken in Jmol 16.1.16); 


JmolVersion="16.1.33" // (legacy) also 16.1.34 (SwingJS)

bug fix: LOAD "" not working after drag-drop of structure text into Jmol
bug fix: ROTATE(SELECTED) {atoms} [4x4 matrix] miscalculates translation
  - when in the order [4x4 matrix] {atoms} it is fine, 
    but when it is {atoms} first, then the {atoms} are used only
    as a center, and while the rotation is about {0 0 0}, the translation is 
    not done properly
bug fix: COMPARE ... SMILES  does not accept multiple components
  - when two molecules are selected, only one gets used
  - now applies "/allcomponents" flag
bug fix: (JavaScript only) LOAD APPEND of CIF file containing _atom_type_radius_bond may fail to bond some atoms
bug fix: (JavaScript only) JSCONSOLE and JSCONSOLE CLEAR script commands broken.

new feature: SMILES/ALLCOMPONENTS flag for generation of SMILES having multiple components
  - without this flag, only single-component SMILES are created for salts, for example.
  - additional components are separated by "." and no ring-connectors
  
new feature: CONFIGURATION -n
 - suggestion by Eric Martz
 - specifically a negative number here
 - allows checking specific lettered configurations based on their index in the string of altlocs
 - allows checking specific lettered configurations
 - atom-based configuration setting
 - specifically for biomolecules: 
 --- for n from 1 to the number of alternative locations in a model
 --- sets configuration to
 	   (all atoms with nth altloc)
 	   + (first listed entry for chain, residue, insertion code, and atom name
 	       when altloc for this atom is not found)
 - for non-biomolecules same as for positive value; just includes
 	   (all atoms with no altloc) + (all atoms with nth altloc)
 - note that for biomolecules, positive configuration number
    gives the nth entry in the set of altlocs *for a given residue* 
 - note that selecting a configuration number greater than one and 
   greater than the number of altloc possibilities for a model
   returns no atoms
         	     
new feature: CONFIGURATION "A"
 - suggestion by Eric Martz
 - allows checking specific lettered configurations
 - atom-based configuration setting
 - specifically for biomolecules: 
 --- sets configuration to
 	   (all atoms with specified altloc)
 	   + (first listed entry for chain, residue, insertion code, and atom name
 	       when specified altloc for this atom is not found)
 - for non-biomolecules same as for positive value; just includes
 	   (all atoms with no altloc) + (all atoms with this altloc)
 - specifying "" or " " delivers all case without alternative locations     	     
 
new feature: BilbaoReader allows LOAD ... spacegroup ":n" to force origin, where n is 1 or 2
 - for example, in a case where the text is given as a different origin:

#Exercise 2.1B (ZrSiO4: origin 1)
# Space Group ITA number
141
# Lattice parameters
6.60 6.60 5.88 90 90 90
# Number of independent atoms in the asymmetric unit
3
# [atom type] [number] [WP] [x] [y] [z]
Zr 1 4a   0 0 0
Si 1 4b   0 0 0.5
O  1 16h  0 0.2 0.34


JmolVersion="16.1.31" // (legacy) also 16.1.32 (SwingJS)

bug fix: WRITE CIF does not add occupancy
bug fix: SET PICKING DRAGSELECTED broken
bug fix: MINIMIZE GROUP not working correctly

new feature: Jmol will accept CIF files with duplicate atom_site_label entries
  - it will add numbers if two identical atom_site_label values are found
  - an warning message is reported in the Java console only.
  
new feature: function special variables _caller, _callers, _name
  - _caller is only the direct calling JmolScript function
  - _callers is the stack of all calling JmolScript functions
  
new feature: _args() and _args(n)
  - same as _arguments and _arguments[n], but better for callbacks
  - more efficient access to jmolscript: callack arguments than _arguments
  - does not require translation of all arguments into script variables; only as needed 
  - can be used for functions and scripts as well.
  - consistent with syntax added in 14.32.58 but not yet documented

new feature: allow CIFReader to ignore COD 2107628 unmodulated operations in presence of modulated
  - _space_group_symop_ssg_operation_algebraic in preference to _space_group_symop_operation_xyz
  - can this possibly be a valid CIF option, to have both of these???

new feature: CIFReader "ignoreGeomBond" (was SwingJS only)
 - explicitly ignores all GEOM_BOND records
 

JmolVersion="16.1.29" // (legacy) also 16.1.30 (SwingJS)

new feature: _arguments and _argumentCount added to SET CALLBACK "jmolscript:..."
  - similar to using parameters with scripts, as in SCRIPT "test.spt"(3,5)
  - allows reading of parameters within callbacks within Java. (JavaScript has the parameters already)
  - for example:
  			set loadStructCallback "jmolscript:print 'file is ' + _ARGUMENTS[2]"
     		set dragdropCallback "jmolScript:if (_ARGUMENTS[5].find('config')) dropFileType='pwmat'"

bug fix: CONFIGURATION command with no parameters causes state save to fail
bug fix: CONFIGURATION <n> command does not update shapes with nonzero hermiteLevel 
bug fix: echoCallback should not be able to infinitely call itself.


JmolVersion="16.1.27" // (legacy) also 16.1.28 (SwingJS)

new feature: (array of SMILES strings).find("SMARTS" or "SMILES", pattern)
 - efficiently searches each target SMILES in array for pattern
 - returns array of same length with 1 (found) or 0 (not found) for each target SMILES
 - for example:
 	$ print ["CCCC","C(O)CC","C(N)CC","CC(N)CC"].find("SMARTS","CCO").format("JSON")
	[ 0,1,0,0 ]
 	$ print ["CCCC","C(O)CC","C(N)CC","CC(N)CC"].find("SMILES","CCCN").format("JSON")
	[ 0,0,1,0 ]
	
bug fix: modulated structure Crenel-only (no Lagrange or Fourier) fails to trigger occupational visualization
bug fix: ModelKit MINIMIZE command can use wrong symmetry operators with multiple structures
bug fix: Modelkit MINIMIZE command displays all models instead of just one after minimization
bug fix: Modelkit MINIMIZE fails if multiple models are displayed (should show error that it only works with one model displayed)


JmolVersion="16.1.25" // (legacy) also 16.1.26 (SwingJS)

bug fix: standard minimization does not refresh properly
bug fix: standard minimization does not set atom positions properly after dragMinimize
bug fix: JME 2D-MOL files do not properly indicate they are 2D in _M
bug fix: LOAD <2D mol file> FILTER "2D" may invert stereochemistry (broken in 14.31.53)


JmolVersion="16.1.23" // (legacy) also 16.1.24 (SwingJS)

new feature: threaded symmetry-aware UFF minimization of crystal structures.
  - command: MODELKIT MINIMIZE [optional parameters] same as MINIMIZE command
  - temporarily creates a new model in a hidden frame that expands the model
    to a full 3x3 unit cell
  - efficient minimization of just the asymmetric unit; other atoms are generated
  - adds a 5-angstrom fixed set of atoms around that 
    (adjustable using the RANGE parameter of the MODELKIT MINIMIZE command)
  - runs UFF exclusively
  - threaded, so allows user interaction during minimization
    (which should be minimal, but does allow MINIMIZATION STOP, for example)
  - does not require a fully packed model. For example:
    
       load =ams/quartz 1; modelkit minimize; modelkit packed; connect auto
       
    gives the same structure as: 
  
       load =ams/quartz 1 packed; modelkit minimize
       
    because all optimization of the asymmetric unit alone within 
    the context of a fully elaborated periodic structure. The actual 
    atoms do not need to exist.
    
      
JmolVersion="16.1.21" // (legacy) also 16.1.22 (SwingJS)

bug fix: popup menu File...Load...Open PDB for JavaScript does not work
bug fix: popup menu File...Load...Open MOL for JavaScript does not work
bug fix: compare({...}, {...}) and compare({...},{...},"stddev") broken in Jmol 14.31.55
bug fix: load "?" broken for JavaScript

new feature: compare(A, B, map) and compare(A, B, map, "stddev")
 - A or B can be atom set or array of points
 - map is an integer array indicating the ordering of A that matches B
 - for example, if A is [@1,@2,@3] and B is in order [@2,@3,@1]
   then the map array would be [2 3 1], since B[1](i.e. @2) matches a[2]
   and B[2] matches A[3], and B[3] matches A[1].
 - A may have more elements than B, provided the map has the same elements as B

new feature: load "=?" load PDB ID from RCSB with prompt
new feature: load "==?" load chemical component from RCSB with prompt
new feature: load "*?" load PDB ID from EBI with prompt
new feature: load "$?" load structure from NCI/CADD with prompt
new feature: load ":?" load structure from pubChem with prompt


JmolVersion="16.1.19" // (legacy) also 16.1.20 (SwingJS)

bug fix: JanaReader modulation fix (broken in 16.1.16)
bug fix: MSRdr (modulated structure reader) fix (broken in 16.1.16)
bug fix: @2.identify and ({2}) do not work (for single atom sets; broken in Jmol 12.3.2 Oct 2011!!)
 - fix test:
 $ load $caffeine
 $ label %a
 $ print @2.identify
   C2 #2
 $ print @2.label()
   C2 #2
 $ print @2.label("")
   C2

bug fix: bondsets do not remain bondsets after operations
 - fix test:
 $ load $caffeine
 $ x = connected({_C},{_O})
 $ print x
   [{2 14}]
 $ print x | 3
   [{2 3 14}]
 $ print (x | 3) and ! ({14})
   [{2 3}]

bug fix: color @bondset colors atoms, not bonds
 - fix test:
 $ load $caffeine
 $ x = connected({_C},{_O})
 $ color @x yellow
 
bug fix: bondset.identify and bonset.label() fail
 - fix test:
 $ load $caffeine
 $ x = connected({_C},{_O})
 $ print x[1]
   [{2}] 
 $ print x[1].identify  // number, order, atoms, distance
   3 2 C3 #3 -- O4 #4 1.215961
 $ print x[1].label() // same 
   3 2 C3 #3 -- O4 #4 1.215961
 $ print x[1].label("") // [atom1] distance [atom2] #number 
   [C3 #3] 1.216 [O4 #4] #3 


JmolVersion="16.1.17" // (legacy) also 16.1.18 (SwingJS)

bug fix: set picking assignatom_P  (specifically phosphorus) fails (second try!)
bug fix: MINIMIZE crystal structure better optimization
bug fix: LOAD APPEND VAR does not work
bug fix: LOAD "" should return last actual file loaded, not "string" if LOAD VAR or LOAD INLINE was used

new feature: MODELKIT MINIMIZE
 - for crystal structures in the current model only
 - does not need anything more than the asymmetric unit atoms
 - carries out a minimization on the asymmetric unit within a 27-cell block {444 666 1}
 - applies that minimization to all atoms in the current model
 - temporarily creates a new CIF model, minimizes it, then deletes it
 - can accept a limited number of additional parameters such as SILENT and 
 - Equivalent to
 
	 function minimizeXtal() {
        if (within("unitCell") == 0) return;
		var m = {thisModel};
		var au = {thisModel & !symmetry};
		var x = write("cif");
		var usethread = useMinimizationThread;
		var apnew = appendNew;
		set useMinimizationThread false;
		set appendNew true;
		load append var x {444 666 1};
		frame last;
		minimize;
		set useMinimizationThread @usethread;
		set appendNew @apnew;
		var pts = {thisModel & symop=1555}.xyz.all;
		zap {thisModel};
		frame @m;
		modelkit moveto @au @pts;
	 }
  
new feature: MODELKIT MOVETO @atoms @points
 - bulk conversion of a set of atom positions, applying symmetry
 - similar to MODELKIT MOVETO @atom @xyz, but for a set of atoms
 - atoms may be just the asymmetric unit
 - points is a set of points, same length as atoms
 
JmolVersion="16.1.15" // (legacy) also 16.1.16 (SwingJS)

bug fix: draw SYMMETRY for linear molecules indicates C2 or D2 rather than C_infinity
bug fix: incommensurately modulated CIF files fail with certain Fourier coefficient methods
         (broken when "id" was added to the registry keys for MSCIF file records).
bug fix: unitcell SURFACE fails in some cases

new feature: MINIMIZE SELECT {atoms} 
 - Minimizes a set of atoms within the context of atoms around those atoms.
 - The surrounding atoms will not be moved, but the forces they apply to 
   the selected atoms will be part of the calculation.
 - for example: 
    
	set appendnew false
	load $water
	load append $acetone
	minimize SELECT {water}

    # The water molecule is moved away from
    # the acetone molecule during minimization.
    # The acetone molecule is not moved.

new feature: MINIMIZE GROUP {atoms} 
 - minimizes a group such as CH3 ignoring all other atoms but without modifying the bond to its connecting atom
 - for example: 
    
     load $caffeine
     minimize GROUP {within(smarts, "[C][H]")}
     # the H atoms of the three CH3 groups will move ever so slightly
     # the C atoms will not move
  
new feature: MINIMIZE ONLY {atoms} 
 - Minimizes a set of atoms ignoring all other atoms.
 - Useful if minimizing a small molecule near a surface, for example,
   without having it drift away from the surface due to VDW repulsion.
   
 - If a molecular fragment, UFF force field will be used. 
 - Default option for MINIMIZE {atoms}
 - for example: 
    
     load $caffeine
     minimize ONLY {within(smarts, "C=O")}

     # the C=O groups will be moved around as though
     # they were not connected to the rest of the molecule   

NOTE: the MINIMIZE command has subtly different SELECT options:

  minimize ONLY {water}      // atoms are minimized independently of any other atoms
  minimize GROUP {water}     // same as {water} but connected bonds are not changed
  minimize SELECT {water}    // atoms are minimized, but forces of nearby atoms are included
  minimize {water}           // same as minimize ONLY {water}

new feature: UFF minimization with application of symmetry for 
             crystal structures. 
   - minimizes just the asymmetric unit, concurrently 
     transfering the changes to all equivalent atoms
   - always uses the UFF force field (as adapted for better angle minimization)
   - simply use MINIMIZE by itself
   - for best results, load the structure with a padding of cells around the centeral 
     unit cell, for example:  
     
        load =ams/quartz 1 {444 666 1} 
        minimize
        write quartz-uff.cif
        
     (Note that the written CIF file will just have two atoms, minimized for the whole unit cell.)

new feature: draw SYMOP [3,4,5] @1
 - draws the given array of symops (1-based) for atom 1
 
new feature: DRAW SPACEGROUP @n
  - draws just the operations for which the specified atom 
    (in the current model only) is invariant
  - If the the atom is in a general position, nothing is drawn.
  - for example:
  
     load =ams/marcasite 1 packed
     draw spacegroup @2
     
       -x,y,z mirror plane
  
     draw spacegroup @3
     
       -x,y,z mirror plane
	   x,-y,-z C2 axis
       -x,-y,-z Ci: 0 0 0
       
            
JmolVersion="16.1.13" // (legacy) also 16.1.14 (SwingJS)

bug fix: MINIMIZE {atoms} does not work with crystal structure 
         when atoms are added prior to changing space group using LOAD APPEND with SET APPENDNEW FALSE         
  load =ams/quartz 1 packed;set appendnew false;load append $water;modelkit spacegroup P1
  minimize {water}

new feature: popup menu adds "atom picking..." Drag Atom and Drag Molecule

new feature: Jmol application -A --scriptarguments flag
 - used in conjunction with -s --script 
 - allows adding _arguments array variable to a script file on the command line
 - example:
 
     jmol -s "test.spt" -A "2,3,4"
   
   where test.spt is 
     
     print "" + _arguments[1] + " and " + _arguments [2] + " and " + _arguments[3]

   result is
   
     2 and 3 and 4
          
new feature: draw boundbox $[isosurface id]

new feature: draw boundbox BEST $[isosurface id]

new feature: CIFReader "ignoreGeomBond"
 - explicitly ignores all GEOM_BOND records
 
bug fix: RESET should clear custom boundbox
bug fix: pdbAddHydrogens can create atomNo duplicates. 
bug fix: mmCIF struct_conn with FILTER "addbonds" may miss bonds (6mqj, 7rfw)
bug fix: simple mutation 3-letter code fails, for example: mutate 33 LYS


JmolVersion="16.1.11" // (legacy) also 16.1.12 (SwingJS)

bug fix: incommensurately modulated CIF missing modulations when params split off into separate loops

bug fix: CIF "_space_group_it_number" not recognized

bug fix: WRITE CIF creates invalid CIF files that now cause failed reading
 -- Problem was that Jmol was updated to require CIF standard
    that all _atom_site_label must be unique. (OUCH!)
 -- Corrected only such that CIF files starting with
    "# primitive CIF file created by Jmol" will append a number to each label
    thus allowing reading of these legacy files.
    
bug fix: Jmol does not recognize ASCII CrystalMaker CMF files from EPINET 
 -- due to use of tab character after TITL

new feature: CrystalMaker CMDF (binary) file reader
 -- minimal reader; atoms, unit cell and symmetry only; does not read bonds or rendering
 

JmolVersion="16.1.9" // (legacy) also 16.1.10 (SwingJS)

bug fix: InChI from 2D MOL or SDF not recognizing stereochemistry

bug fix: Incommensurately modulated CIF with two structures 
         with two different modulation dimensions will fail
         (z034DL74QTM.cif)

bug fix: measurements not correctly changing size dynamically with antialiasdisplay
bug fix: measurements not preserving explicitly set units in state
bug fix: measure 2.5 3.5 {_N} {_O} delete deletes all measures
bug fix: measures not retaining specific units

new feature: measure SELECT...
  -- selects the specified measures for actions without creating or removing it
  -- if the described measure does not exist, the command is ignored
  -- for example:
  
  load $caffeine
  measure {_N} {_O} all
  measure SELECT 4.5 {_N} {_O}
  color measures yellow
  measure SELECT 3.5 4.5 {_N} {_O} color green

new feature: measure SELECT ALL
  -- selects all measures

new feature: measure SELECTED
  -- list the currently selected measures
  
new feature: measure SELECTED ...
  -- carry out the change only on the currently selected measures
  -- "default" (quoted) parameter sets the format string and units to default values
  -- for example:
  
  load $caffeine
  measure {_N} {_O} all
  measure SELECT 4.5 {_N} {_O} color orange
  measure SELECT 4.5 {_N} {_O} "pm"
  measure SELECT 4.5 {_N} {_O} color orange "pm"
  
  or

  measure SELECT 4.5 {_N} {_O}
  measure SELECTED color orange
  measure SELECTED delete

new feature: MEASURE .... "default"
  - resets units and label format to null (indicating default units and format)
    

JmolVersion="16.1.9" // (legacy) also 16.1.10 (SwingJS)

bug fix: measurements not preserving explicitly set units in state
 - note that if SET MEASUREMENTUNITS is used after a measurement is made,
   then that measurement's units are explicitly set
bug fix: InChI from 2D MOL or SDF not recognizing stereochemistry

JmolVersion="16.1.7" // (legacy) also 16.1.8 (SwingJS)

bug fix: load "" after load DATA .... fails to load string-based file data

new feature: pat = pattern(<smarts string>) 
 -- compiles a SMARTS pattern for later use.
 -- example: 
     var smarts = pattern('NCN')

new feature: atomset.search(pattern)
 -- carry out a SMARTS search on set of atoms with a precompiled pattern
     var smarts = pattern('NCN')
     load $caffeine
     var atoms = {*}.search(smarts)
     print atoms

new feature: target = search(atomset)
 -- predefines a target for repetitive SMARTS searching
 -- example: 
     load $caffeine
     var target = search({*})
     print target.search("NCN")

new feature: target.search(stringPattern)
 -- search a predefined target with a string pattern
 -- example: 
     load $caffeine
     var target = search({*})
     print target.search("NCN")

new feature: search(target, pattern)
 -- search a predefined target with a string or precompiled pattern 
 -- example: 
     load $caffeine
     var target = search({*})
     print target.search("NCN")
     var smarts = pattern('NCN')
     print search(target, smarts)

JmolVersion="16.1.5" // (legacy) also 16.1.6 (SwingJS)

bug fix: JVXL fails if the first surface voxel is the tenth voxel
 -- in that case, the lead compression character for edge data is "-", leading to "--"
    at the start of the buffer. But for reasons lost to history (sometime before 2012), 
    if the string has two minus signs at the start, those are removed. No idea why!!!

JmolVersion="16.1.3" // (legacy) also 16.1.4 (SwingJS)

bug fix: draw symop
bug fix: symop(13,"angle") and "axisVector" return unexpected results 
 -- Although all is correct, vector may be downward and associated angle may be negative
 -- Switching to convention where vector is upward and all angles are positive
  
JmolVersion="16.1.1" // (legacy) also 16.1.2 (SwingJS)

note: switching to even tertiary version number for double-precision-only Jmol-SwingJS
note: switching to odd tertiary version number for legacy Jmol
note: use of Java JmolD.jar (SwingJS) recommended for general use Java version
note: use of SwingJS-compatible JavaScript works but does not yet utilize extensive packaging 
note: leading to slower JavaScript loading of the SwingJS (GitHub) version of Jmol
note: release will be at SourceForge for both products

new feature: adds JME 2-D Editor Tool (Java only; Tools top menu item)
 -- drag-drop CDX and CDXML files for 2D rendering using legacy JME
 -- convert to/from 3D
 -- automatically cleans ill-positioned fragments and "nicknames", such as Ph, OTs, etc.
 -- cleans fragments using NCI/CADD development server (cirx) with =smiles2D and =smiles3D 
 -- leverages JNIInChI to check structures
 -- allows creation of 2D MOL and 2D CDXML files from any 2D or 3D model
 
 new feature: =smiles2d and =smiles3d
 -- implements NCI/CADD development server
 -- guaranteed 2D and 3D MOL file return
 -- uses 
      =smiles2d as "https://cirx.chemicalcreatures.com/chemical/structure/%FILE/file?format=sdf&get3d=false"
      =smiles3d as "https://cirx.chemicalcreatures.com/chemical/structure/%FILE/file?format=sdf&get3d=true"
 -- allows for future modification of that pathway back to NCI/CADD home
 -- example:
 
   load $$C(C)Cc2c(OC)c(Cl)ccc2            // 2D
   load $$C(C)C1c2c(OC1)c(Cl)ccc2          // 3D ???
   load =smiles2d/C(C)C1c2c(OC1)c(Cl)ccc2  // 2D for sure

bug fix: Sc in SMILES not read
bug fix: SMILES issue with kukule matching with aaaa smarts
bug fix: mdcrd topology file reader not reading bonding information
bug fix: (JavaScript only) mousemove should not trigger canvas.focus(), as that makes Chrome and Edge jump if the window is partially off screen
bug fix: "...smiles...".find("...smiles...") bug in treating aromatic pattern/target
 -- proper behavior is that "c1ccccc1".find("C1=CC=CC=C1") should find nothing,
 -- while  "C1=CC=CC=C1".find("c1ccccc1") should work. The key here is that the 
 -- explicit pattern C1C=CC=CC=C1 is a literal request, which does not match generic structure c1ccccc1.
 -- But "c1ccccc1" should generally find the aromatic character of the structure "C1=CC=CC=C1".
 -- This highlights the issue that SMILES meant to be SMARTS *targets* should neve have aromatic "c". 
 -- This is because that would require a perfectly equivalent aromatic model in order to be found. 
 -- Any slight divergence of model causes the SMARTS search to fail. But if the target is in 
 -- Kekule form, the SMARTS algorithm should be able to match that using whatever algorithm it 
 -- uses for aromaticity. This bug was causing both searches to fail. 
  
JmolVersion="14.32.83" // also 15.2.83
new feature: generalized FILTER "NOH"
 -- for 2D structures (MOL, V3000, CDX, CDXML, JME
 -- loads the structure as is, without adding H or converting to 3D
 -- useful for processes that simply want to create SMILES or InChI

new feature: generalized FILTER "NOMIN"
 -- for 2D structures, loads the structure with added hydrogens but without converting to 3D

new feature: ChemDraw CDXReader
 -- reads CDX files to 2D or 3D
 -- only minimal amount of information necessary for loading
 -- cleans files of unattached "phantom" atoms
 -- recognizes partial bonds and multiple-attachment bonds (e.g. ferrocene)
    converting these to partial bonds
 -- can be used to generate SMILES, InChI, InChIKey, 2D-MOL files
 -- recognizes "either stereochemistry" wavy bond -- translates to InChI ?

new feature: allowing @1.symop(@2,...) rather than @1.symop(@1, @2,...)
 
bug fix: CDXML reader for multiple attachments, other upgrades
bug fix: CDXML reader connectivity for attachments within strings of characters
bug fix: axes do not retain font changes after rotation if both xyz and abc are present
bug fix: addition of H atoms to crystal structures when unit cell is showing 
         should not add H if it is out of unit cell periodic boundaries and no other
         atom is already out of those boundaries.
bug fix: ModelKit not processing  MODELKIT ADD @1 "N" {0 1/4 1/4} properly
bug fix: ModelKit not giving correct hover label after dragging to bond for crystal structure
bug fix: deleting atoms with measurements can cause rendering to fail

bug fix: MMFF minimization using 2D instead of 3D parameters
    
JmolVersion="14.32.82" // also 15.2.82

bug fix: ModelKit menu may not work on second click of an item
bug fix: V3000 MOL reading deleting H atoms inappropriately
bug fix: V3000 MOL should disregard any nonbonded Xx atom (as from a label)
bug fix: SMILES from model that has been converted from 2D may not show stereochemistry
bug fix: JNI-InChI not set up for 2D stereochemistry (wedge/hash).
bug fix: ChemDraw CDXML reader should allow for atom with invalid valence
bug fix: Java application File...New should not pass status listener on as userStatusListener

new feature: In ModelKitMode, hovering over an atom and pressing keys can change element
 -- for single-character symbols, just press the letter --- c o n etc.
 -- for two-character symbols, hold down the shift key for BOTH letters --- NI OS LI etc 
 -- invalid element names are ignored silently
 -- only for non-touchscreen context

new feature: print {1.1}.find("SMILES","MF")
 -- determines the molecular formula based on a SMILES string from the atomset

new feature: print {1.1}.find("SMILES","MF", true)
 -- determines the empirical formula based on a SMILES string from the atomset

new feature: print "CCCC".find("SMILES","MF")
 -- determines molecular formula of a SMILES string

new feature: print "CCCC".find("SMILES","MF", true)
 -- determines the empirical formula of a SMILES string

new feature: LOAD xxxx.mol FILTER "noHydrogen" (Or just "NOH")
 -- loads the model in 2D with no additional hydrogens and no minimization
 -- allows for SMILES and InChI creation directly from the 2D model

new feature: LOAD xxxx.mol FILTER "no3D" 
 -- loads the model in 2D with no conversion to 3D, particularly for V3000 and ChemDraw
 -- no effect for standard 3D models
 
JmolVersion="14.32.81" // also 15.2.81


new feature: LCAOCARTOON create "anti-sp3a"
  -- adds a small anti-sense back-lobe to an sp3 cartoon.
  
new feature: LCAOCARTOON create "-anti-sp3a"
  -- with prefix minus sign reverses the direction of the orbital and adds a small back-lobe

new feature: LCAOCARTOON REVERSE [optional TRUE|FALSE] (default TRUE)
  -- switches the color of two-lobe orbitals such as px and anti-sp3
  -- as for other LCAOCARTOON parameters, REVERSE persists until changes
  -- for example:


     load $1-bromo-2-butene;
     lcaocartoon @1 reverse false color green yellow "-anti-sp3a";
     lcaocartoon @2 reverse true  color green yellow "-anti-sp3a";

  same as
 
     load $1-bromo-2-butene;
     lcaocartoon @1 color green yellow "-anti-sp3a";
     lcaocartoon @2 reverse "-anti-sp3a";
 
  same as
 
     load $1-bromo-2-butene;
     lcaocartoon reverse false color green yellow;
     lcaocartoon @1 create "-anti-sp3a";
     lcaocartoon reverse;
     lcaocartoon @2 create "-anti-sp3a";  
     
  
bug fix: modelkit sets boundbox to default value {-10 -10 -10} to {10 10 10} during adding H atoms
bug fix: minimizer does not fire StructureModifiedCallback; now does, with mode 3/-3 (coord change)
bug fix: PDBWriter does not properly identify CONECT records
bug fix: invertStereo fails for alkenes
bug fix: Pymol reader fails in relation to parent groups
bug fix: WebExport fails
bug fix: V3000 reader misreads continuation lines
bug fix: Automatic 2D->3D conversion for multi-model files fails (should minimize just first model)
bug fix: print x.select("properties where properties[2] == 3") does not work, because "properties" being turned into "property"
bug fix: map.format("JSON") should sort map items


JmolVersion="14.32.80" // also 15.32.80

new feature: write("PNGJ",TRUE)
 -- TRUE indicates we want a byte array, not a map
 -- besides "PNGJ" can be "ZIP", "JMOL" or "ZIPALL"
 -- note that these bytes can be encoded as Base64 using format("base64",write("PNGJ",true))

bug fix: set picking rotateBond does not work in touch-only environment 
bug fix: various modelkit menu issues

 
JmolVersion="14.32.79" // also 15.2.79

bug fix: ModelKit fixes for set picking rotateBond and hover labels when ModelKit is not ON
bug fix: CifReader can skip a line if loop processor is processing non-loop keys starting with "atom_"
bug fix: write("OBJ") does not fail gracefully
bug fix: Frank-click popup menu fails to open

code: simplified pixelGrabber avoids Java issue causing annoying but caught NPE in sun OffscreenImageSource code


JmolVersion="14.32.78" // also 15.2.78

bug fix: 15.2.73/14.32.73 state script fix broke Proteopedia hack
bug fix: in certain cases, labels may not be cleared in state by LABEL ""
bug fix: Topology CIF reader fails to bond asymmetric unit atoms
bug fix: set picking invertstereo doesn't allow inversion at times that it should
bug fix: ModelKit increase/decrease charge broken (15.2.28) 

JmolVersion="14.32.77" // also 15.2.77

bug fix: CifReader should not totally ignore disorder set -n
 -- supports up to 26 (A-Z) new altloc values, one for each symmetry operator
 
bug fix: ISOSURFACE CUTOFF +xxxx does not work for volume data surfaces 

JmolVersion="14.32.76" // also 15.2.76

bug fix: SET PICKING DRAGMINIMIZE  should generally 
         move attached H atoms even if ModelKit is not open as long as there is no unit cell.

bug fix: ModelKit icons missing

JmolVersion="14.32.75" // also 15.2.75

bug fix: WRITE ISOSURFACE incorrect for COLOR DENSITY CUTOFF [min,max]

JmolVersion="14.32.74" // also 15.2.74

bug fix: load("cache://....") does not work for cached files
bug fix: ISOSURFACE TYPE "Xsf" [1, "rho1.xsf", 1, "rho2.xsf"] should apply type to both files
bug fix: WRITE ISOSURFACE does not save cutoff range for color density

new feature: load(filename, asbinary, async) or load(filename, nbytesMax, async) or load(filename, "JSON", async)
 -- 3rd parameter TRUE loads file asynchronously in HTML5


JmolVersion="14.32.73" // also 15.2.73

bug fix: XSF surface files with over about 267 atoms not recognizing presence of surface data

bug fix: scripts that include SCRIPT INLINE commands explicitly made from show("state") 

		script inline "# Jmol state version 14.32.72  2022-08-17 10:30;
		...

	treated as though they themselves are state scripts, causing the bondingVersion to be 
	set to 1 upon exit of the script and resulting in unexpected changes in later calls to CONNECT AUTO. 
 
bug fix: reading file with 0 bytes should indicate EOF (end of file) exception, not wrong format message

new feature: ModelKit SPACEGROUP "123" or ModelKit SPACEGROUP 123
 -- allows setting of the space group after loading 
 -- accepts any name of a space group accepted by the spacegroup() function or a number from 1 to 230
 -- note that some space group names have extensions:  "6:a", "6:b", "6:c". If these are given
    simply as "6" or the number 6, then one of these options will be used.
 -- will not set the space group if the current unit cell is not appropriate for the given space group
 -- can accept semicolon-separated Jones-Faithful operation listing: "x,y,z;-x,-y,-z"
    which can be obtained for any space group by:  
 
    x = spaceGroup(123).spaceGroupInfo.operationsXYZ.join(";") 
 
    or for the current space group by 
    
    x = _M.symmetryOperations.join(";")
    
 -- using operation lists is recommended over using names, as this covers all possible space groups
    and avoids any ambiguity in settings
    
new feature: ModelKit SPACEGROUP "123" packed
 -- also packs the unit cell after assigning the space group 

new feature: ModelKit PACKED
 -- packs the unit cell
 
new feature: ModelKit ADD {xxx} PACKED
 -- packs the unit cell just for the specified subset of atoms
 
new feature: x = spacegroup("123") or spacegroup(123)
 -- returns a map containing keys:
	    HallSymbol
		HermannMauguinSymbol
		crystalClass
		ita
		jmolId
		operationCount
		operationsXYZ		
 -- note that some space group names have extensions:  "6:a", "6:b", "6:c". If these are given
    simply as "6" or the number 6, then one of these options will be delivered.
 -- if a space group name is given that is not recognized, such as "6:d" or "400", "?" will be returned.
 
new feature: x = spacegroup("x,y,z;-x,y,z")
 -- similar to spacegroup("123") but finds the space group with this set of operations
 
new feature: x = spacegroup("x,y,z&-x,y,z") or spacegroup("&x,y,z;-x,y,z") or spacegroup("x,y,z;-x,y,z&")
 -- use of "&" instead of ";" or adding "&" at the beginning or end of the string
 -- gives an array of space group names for space groups that have AT LEAST these operators, maybe more
 -- for example:
   
	$ print spacegroup("-x,-y,-z;-x,y,z;-x,-y,z;x,y,-z;-x,-y,-z;-x,-y,z;-y,-x,z+1/2&").format("JSON")

	[ "131","226" ]

new feature: x = spacegroup(6, [a, b, c, alpha, beta, gamma])
 -- adding an array of unit cell parameters can sometimes help in distinguishing among space group settings, 
    at least for simple cases where the setting is dependent upon the "unique" axis

new feature: x = spacegroup("x,y,z;-x,y,z", [a, b, c, alpha, beta, gamma])
 -- adding an array of unit cell parameters to an operator list will ensure that the returned space group
    is consistent with the given unit cell. For example, 
    
		$ print spaceGroup("&x,y+1/2,z+1/2", [5,5,5,90,90,90]).count
		64

		$ print spaceGroup("&x,y+1/2,z+1/2", [5,5,6,90,90,90]).count
		50    

		$ print spaceGroup("&x,y+1/2,z+1/2", [5,5,6,90,90,120]).count
		0    

    because the second case does not include 14 matching cubic groups, and there are no hexaganol groups with this operation.
    
    
JmolVersion="14.32.72" // P also 15.2.72

bug fix: saving state after connect AUTO to ModelKit-added atoms uses H atom radius instead of final atom radius


JmolVersion="14.32.71" // P also 15.2.71

bug fix: isosurface slab designations "xy" "xz" "yz" "-xy", "-xz" "-yz" etc. are not correct

new feature: isosurface slab designations "a=" "b=" "c=" "-a=" "-b=" "-c=" "ab" "bc" "ac" "-ab" "-bc" "-ac"
 -- like x, y, and z, but for unit cell axes
   for example: 
   		load spacegroup 1 unitcell [3 3 3 60 60 60]
   		isosurface sphere 5.0 slab -a=1
 -- note that negative options and unit cell options are not documented

new feature: color property xxxx [quoted schemeFileNameOrURL]
 -- adds nine more standard color schemes, including five "universally readable" scientific
 	palettes (batlow,cividis,kry,thermal,viridis) as discussed in https://www.nature.com/articles/s41467-020-19160-7
    as well as four more (inferno,magma,plasma,turbo) that are from the R-Project viridis package 
    	https://cran.r-project.org/web/packages/viridis/vignettes/intro-to-viridis.html
    
    for example:
 
 	load *1crn
 	color property atomno "viridis"

 -- scheme palettes are located as *.lut.txt in the src/org/jmol/util/colorschemes/ directory 
 -- column format .lut.txt (three columns of r g b per line, either 0-255 or 0-1, or four columns where first column is the index 1-256)
 -- also reads files using https://... from any online source in binary or ASCII formats:
 		binary [optional 32-bit header ignored][rrrr...(256)][gggg...(256)][bbbb...(256)] 768 or 800 bytes total
    	ASCIIt (either three columns of r g b per line, or four columns index r g b)
    
    for example:
 
 	load *1crn
 	color property atomno "https://github.com/fiji/fiji/blob/master/luts/cool.lut?raw=true"

 -- filenames also work in the color() function:

  print color("viridis").colors
 
  print color("https://github.com/Image-Py/imagepy/blob/master/imagepy/data/luts/Others/morgenstemning.lut?raw=true").colors
  
 -- for more color palette look-up table files, see
      https://github.com/fiji/fiji/tree/master/luts
      https://github.com/Image-Py/imagepy/tree/master/imagepy/data/luts
	  https://sites.imagej.net/NeuroCyto-LUTs/luts
 
 
JmolVersion="14.32.70" // P also 15.2.70

bug fix: reading of gzipped jvxl files from PNGJ fails in JavaScript
 -- when caching and reading a file from a zip collection, as in JSmol, FileManager does not unzip the gzipped stream

JmolVersion="14.32.69" // P also 15.2.69

bug fix: WRITE GIF with text background black creates speckled pattern.
  -- for transparent GIF, use background 0x040404

bug fix: SCALE HIDDEN removes units

new feature: JSmol distribution site/jpge  Jmol Point Group Explorer with quizzing and startup options
  - https://chemapps.stolaf.edu/jmol/jsmol/jpge/explore.htm?QUIZMODE
  - https://chemapps.stolaf.edu/jmol/jsmol/jpge/explore.htm?c60
  - https://chemapps.stolaf.edu/jmol/jsmol/jpge/explore.htm?c60&QUIZMODE

JmolVersion="14.32.70" // P also 15.2.70

bug fix: reading of gzipped jvxl files from PNGJ fails in JavaScript
 - when caching and reading a file from a zip collection, as in JSmol, FileManager does not unzip the gzipped stream

  

JmolVersion="14.32.68" // P also 15.2.68

new feature:  {atoms}.pointGroup()
  - returns point group object for the specified atoms, for example {!_H}
  - no limit for number of atoms

new feature: CALCULATE POINTGROUP {atoms}
  - allows subset of atoms to be checked, for example {!_H}
  - reports the point group object for the specified atoms

new feature: draw POINTGROUP {atoms} CENTER xx
  - allows subset of atoms to be used, for example {!_H}
  
  
feature change: draw/show PointGroup no longer has atom number limitation -- just be advised!

feature change: pointGroupDistanceTolerance and pointGroupLinearTolerance removed from state

bug fix: MPJmolApp (Molecular Playground) broken by earlier refactoring of JmolPanel (broken in Jmol 14.31.0)

JmolVersion="14.32.67" // P also 15.2.67  (re-released)

bug fix: UNITCELL SURFACE {4 1 0 0} specifically fails for x=4; search fo plane/lattice intercept not sufficiently wide
bug fix: unitcell change should be preserved as "reset" value after issuing MOKELKIT SPACEGROUP P1  
bug fix: JME conversion fails for C=C (JME ethylene)

new feature: JSONReader expanded to include JSON from Symmetry @ Otterbein

clarification: Note that the 

  ModelKit SPACEGROUP P1

command "sets" the unit cell to its current value, as modified, for example, by: 

  uc=unitcell("a=5.286,b=4.086,c=4.086,alpha=90,beta=90,gamma=90");
  ModelKit unitcell @uc

That is, anytime after issuing ModelKit SPACEGROUP P1, issuing 

  unitcell RESET

will reset to the unit cell to the value that it was when the spacegroup was set to P1. 


JmolVersion="14.32.66" // P also 15.2.66 

new feature: ORCA reading molecular orbitals; preliminary only, minimally tested


JmolVersion="14.32.65" // P also 15.2.65 

bug fix: atom.site not properly incremented with load and appendnew false
bug fix: PWMAT/CIF writers may not remove all duplicate atoms before saving file
bug fix: scale units for SCALE should indicated in the SCALE command itself
bug fix: measurement units defined in MEASURE command should be preserved in state
bug fix: issuing a set measurementUnits command is supposed to reset labels for measurements involving selected atoms

JmolVersion="14.32.64" // P also 15.2.64 (reissued2)

new feature: ORCA input/output reader

bug fix: MMCIF reader broken by 15.2.59 on 2022.06.01
bug fix: invalid COMPARE with .... atoms {atomset1} and not atomset2 crashes Jmol
bug fix: COLOR ECHO TRANSLUCENT missing space char in state
bug fix: certain SCALE objects appear transparent with antialiasDisplay 
bug fix: scale units should be in a state that includes echo JC.scaleName or the SCALE command (reverted in v..65)
bug fix: set FONTSIZE by itself crashes Jmol
bug fix: draw pointgroup does not draw planes

JmolVersion="14.32.63" // P also 15.2.63

bug fix: draw [0 0] [100 100] broken LONG ago
bug fix: (JavaScript only) script callback during animation removes all delays (cyclohexne ring flip) - broken in Jmol 14.32.15
bug fix: (JavaScript only) ModelKit bond assignment does not refresh automatically, appearing a though nothing happened.

JmolVersion="14.32.62" // P also 15.2.62

new feature: implements ModelKit ROTATE axis1 axis2 {atoms} degrees
 -- proper symmetry handling
 -- will not move fixed atoms
 
bug fix: (JavaScript only) ModelKit atom clicking does not work broken in 14.32.8

JmolVersion="14.32.61" // P also 15.2.61

new feature: (JavaScript only) implements Jmol._lastAppletID
 - indicates that last applet that has taken ownership of the mouse (focus)

bug fix: load PDB, then write CIF fails
bug fix: PWmatReader fix for "global" data blocks
 - see _M.globalPWmatData 
bug fix: crystal+dragAtom error for "implicit" planes

JmolVersion="14.32.60" // P also 15.2.60

bug fix: x == y can fail for integers derived from arrays not a script itself

new feature: Optimade reader 
 - https://github.com/Materials-Consortia/OPTIMADE/blob/master/optimade.rst
 - adds required fields for Jmol: chemical_formula_descriptive,lattice_vectors,dimension_types,cartesian_site_positions,species_at_sites,species,";  
 - example: load Optimade::https://optimade.materialsproject.org/v1/structures?filter=nelements=6&page_limit=1

		load http://optimade.2dmatpedia.org/v1/structures
	
		load https://nomad-lab.eu/prod/rae/optimade/v1/structures?filter=nperiodic_dimensions=1

		load https://crystallography.net/cod/optimade 
 
bug fix: CifReader _shelx_* tags can be skipped, as some are > 1 MB of text

 
JmolVersion="14.32.59" // P also 15.2.59

bug fix: OptimadeReader broken
bug fix: OptimadeReader requires Optimade:: prefix
 - now checking for "optimade" or "api_version" 
bug fix: CifReader should allow ADP definition before atom_site block


JmolVersion="14.32.58" // P also 15.2.58

new feature: PDB and related types FILTER "ALLHET" 
 -- by itself, does nothing
 -- in conjunction with any other atom filter, such as /=2, *.CA, etc., 
    passes any HETATM regardless of that filter

new feature ModelKit ADD C [array of points] 
 -- efficient adding of many points of the same type
 -- for example:
      load =ams/quartz 1 packed
      polyhedra unitcell {_Si}
      pts = {_Si}.polyhedra.all.select("(vertices)").join()
      ModelKit ADD N @pts
      
new feature: global user variables dropFileType and dropFileName
  -- allows detecting filename within a dragDropCallback handler
  -- allows setting the file type from within a dragDropCallback handler
  -- method will get the file name, though not the data. 
  -- user variable dropFileType, initially equal to "" 
     can be changed to the desired file type with, for example, 
     
     		set dragdropCallback "jmolScript:if (_ARGS(5).find('config')) dropFileType='pwmat'"
     
  -- user variable dropFileName will hold the file name so that that can used
     to help determine the type.
  -- the actual file data are NOT available in Java, though they may be in 
     JavaScript, since that this point the file will have been cached in JavaScript.
  -- user variable doDrop, initially set to TRUE can be set to FALSE to tell
     Jmol to not load this file.
  -- note that _ARGS() for this callback include:
     [ "DRAGDROP", mode(0), x, y, fileName ]
     so, in 1-based JmolScript, _ARGS(5) is the fileName; 
     in 0-based JavaScript, it is argument 4 
      
bug fix: NaN should be a decimal and should be testable as such. 
but fix: String "NaN" should be considered equal to NaN for direct comparison. 
bug fix: some cases of modulation in Incommensurate CIF files missed
bug fix: @1.modulation("O",t) should report as 0-1 scale, unrounded not 0-100 rounded
bug fix: symop() function not distinguishing between point group and space group check "x,y,z" and "C2.1"
         causing x = symop("x,y,-z", @3) to fail
bug fix: loading of CIF file with spaces in operations duplicates "x,y,z" 

 
JmolVersion="14.32.57" // P also 15.2.57

new feature: symop(3,@1,"array") adds "xyzNormalized"

bug fix: draw SYMOP 40 @1 @5 and show symop 40 @1 @5 should report actual operation, not space group operation
bug fix: draw SYMOP rotation inversion drawing of intermediate not correct; switched to rotation then inversion
but fix: show symop, show spacegroup can have "null" for operations

JmolVersion="14.32.56" // P also 15.2.56

(into Jmol 14 only from precision branch)

new feature: load spacegroup 213 unitcell [5 5 5 90 90 90]
 -- creates an empty structure with the designated space group and unit cell
 -- user is expected to match the correct type of unit cell to the given space group.

bug fix: incommensurately and subsection modulated CIF can miss some parameters (14.31.61)
bug fix: MMCIF files with single entries rather than loops could fail
bug fix: MMCIF files with DSSR or RNA3D extensions could fail.

bug fix: DRAW SYMOP broken
 
JmolVersion="14.32.55" // P also 15.2.55
(into Jmol 14 only from Jmol-SwingJS precision branch)

feature change: axes POSITION [x y] "xyz" with symmetry
  -- crystal structures only
  -- switches to a second small axis set that is Cartesian
  -- [x y] or [x y%] screen position
  -- uses the specified label for the axes labels
  -- label can be one, two, or three characters, for showing just x, 
     just xy, or xyz, respectively
  -- cleared using AXES POSITION OFF (axes on unit cell only)
  -- replaced with abc using "abc" instead of "xyz" (with no axes on unit cell itself)

new feature: axes POSITION [x y] "xyzabc"
  -- same as "xyz" but still shows unitcell axes
  
new feature: global user variable dragDropFileType
  -- allows setting the file type from within a dragDropCallback handler
  -- method will get the file name, though not the data. 
  -- user variable dragDropFileType, initially set to "" can be set to the desired file type
  -- user variable doDrop, initially set to TRUE can be set to FALSE to ignore the drop

bug fix: deleting atoms from PDB fails
bug fix: ModelKit dragAtom does not update measurements
bug fix: DataManager can crash if atoms are created after making atom property arrays 
bug fix: axes position show allow unit cell axes to be turned off
  -- axes position [60 60] "abc" // just small abc
  -- axes position [60 60] "xyz" // just small xyz
  -- axes position [60 60] "xyzabc" // small xyz and unit cell abc
  -- axes position off // just unitcell  
bug fix: load append PWMAT file into structure (appendNew false) fails because no symmetry operators declared

JmolVersion="14.32.54" // P also 15.2.54

(into Jmol 14 only from precision)
bug fix: COMPARE {atomset} ATOMS {at1} [coord1] {at2} [coord2] .... fails  
bug fix: JavaScript negative int double missing minus sign


JmolVersion="14.32.53" // P also 15.2.53

(into Jmol 14 only from precision)
bug fix: PWmatReader fails to adjust atom properties for skipped atoms
bug fix: PWmatReader fails to retain properties after ModelKit ADD ... 
bug fix: adding an atom removes atom properties
bug fix: filter "*.CA" does not work

JmolVersion="14.32.52" // also 15.2.52p

(into Jmol 14 only from precision)
bug fix: hkl(0 0 0) crashes Jmol (MathExt line 2869)
bug fix: openStringInline may have null htParams (Viewer line 3184)

new feature: WRITE "pwslab" (cmdext line 4154 and others, propman line 1204, PWMATWriter line 57)
 - like WRITE "pwmat" but does not pack {x y 0} layer to {x y 1}


JmolVersion="14.32.51" // also 15.2.51

bug fix: loading string line does not check for filter "filetype=xxx;"
bug fix: LOAD ... FILTER "NOPACK" not working properly (and never did?)
bug fix: unitcell scale {1/2 1 1} fractional should work
bug fix: LOAD ... SUPERCELL should set space group to P1
bug fix: allow set picking dragMolecule with P1 space group

code: JC.globalBooleans consolidated

JmolVersion="14.32.50" // (b)  also 15.2.50

bug fix: ModelKit not initializing to set picking assign_atom_C
bug fix: PWmatReader failing with trailing garbage


new feature: load [some crystal structure] filter "SLABXY"
new feature: load [some crystal structure] filter "POLYMERX"
 -- loads a crystal structure as a slab or polymer
 -- packs only in the periodic directions
 -- compatible only with P1 symmetry
 -- load =ams/quartz 1 packed;load inline @{write("CIFP1")} {3 3 1} filter "SLABXY"

new feature: nonperiodic axes for slabs and polymers now dotted

bug fix: OptimadeReader for slabs and polymers
bug fix: PWMatReader fix for header garbage

code: Symmetry refactoring

JmolVersion="14.32.49" //  also 15.2.49

new feature: ECHO @1 
 - sets the echo at atom 1

new feature: SCALE @1
 - sets the echo at atom 1
 - scale moves with atom and is correct even for set perspectiveDepth TRUE
 
bug fix: SCALE command can crash Jmol - null pointer exception in ECHO
bug fix: background SCALE yellow does not cover full range of scale
bug fix: slow JavaScript LOAD FILTER due to debug comment left in

JmolVersion="14.32.48" //  also 15.2.48

new feature: Optimade reader 
 - https://github.com/Materials-Consortia/OPTIMADE/blob/master/optimade.rst
 - requires qualifier Optimade:: because there is no identifying characteristic of the return
 - example: load Optimade::https://optimade.materialsproject.org/v1/structures?filter=nelements=6&page_limit=1
 
new feature: zoom(to) UNITCELL
 -- all options available as for atoms
 
new feature: center UNITCELL 

bug fix: issues with PWMATWriter unitcell offset
bug fix: allow right-click option for popup_menu binding

bug fix: load "" with qualifier xxx:: does not carry over qualifier


JmolVersion="14.32.47" // (b) also 15.2.47

bug fix: ModelKit add "Si" {0/1 0 0} packed; save state s1
	-does not save site change in state
	
bug fix: removing difference between set fx, fux
	-too confusing
	-no differences for get, only set. 
	-poorly documented

JmolVersion="14.32.46" //  also 15.2.46

bug fix: load PDB filter "BMCHAINS=a" should work -- (lower-case issue)
bug fix: set structureModifiedCallback for attempt to move fixed atom should report "FAILED"
bug fix: {assoc array}.pivot.pivot() not working

new feature: hkl(1 0 0 0.3) to produce plane offset by 0.3 Angstroms from the origin.


JmolVersion="14.32.45" //  also 15.2.45

bug fix: PDBReader fails to treat chain case for filter biomolecule
bug fix: PDBReader can fail when making connections with filter biomolecule
bug fix: attempted LOAD of nonexistant PNGJ file (*.png) can crash Jmol 
bug fix: CIFWriter and PWMATWriter do not round coordinates very close to 1.0000

new feature: SCALE command
 -- a special category of ECHO
 -- also ECHO "%SCALE (units)"
 -- draws a |---| scale in the specified location
 -- adjusts by decades -- 0.01, 0.1, 1, 10, 100, etc.
 -- SCALE ON
    -- turns scale on at bottom left
    -- units dynamic, corresponding to SET measurementUnits
 -- SCALE OFF
    -- turns scale off
 -- SCALE (units)
 -- optional fixed units, where (units) can be one of:
 	 "nanometers" ("nm") 
 	 "picometers" ("pm")
 	 "angstroms" ("a" or "ang")
 	 "bohr" ("atomicunits" or "au") 	 
 -- when perspectiveDepth TRUE, is for center of visible depth based on screen width
 -- like FRANK, persists through file loading and ZAP
 -- additional relevant options same as for SET ECHO command
 -- examples:  
 	SCALE angstroms bottom center 
    
new feature: COLOR SCALE ...
 -- sets the color of the scale
 
new feature: FONT SCALE ...
 -- sets the font of the scale


new default properties: Jmol application (Java and JavaScript) adds two additional preferences:
 -- antialiasDisplay TRUE
 -- measurementUnits "angstroms"
 -- PreferencesDialog will set these as "JmolDefaults"
    
new feature: ECHO "%SCALE (units)" 
 -- same as SCALE (units) ...


JmolVersion="14.32.44" //  also 15.2.44

bug fix: PDB reader with biomolecule filter does not properly select chains
 -- broken in 14.32.25
 -- not relevant to mmCIF or MMTF

bug fix: AMPAC archive ZMatrix reader fix
 -- was not reading ZMatrix, only Cartesian listing
 
bug fix: CONNECT DELETE ... 
 -- initial DELETE syntax should be OK (to be compatible with older Jmol versions)

bug fix: POLYHEDRA COLLAPSED ... 
 -- initial COLLAPSED syntax without FaceOffset should be OK (to be compatible with older Jmol versions)

bug fix: SET ECHO BOTTOM LEFT; ECHO JC.scaleName when perspective depth true
 -- should be for center of visible depth based on screen width
 
bug fix: ModelKit DELETE ... should adjust {thismodel}.site.all
  
buf fix: better check for deleted atoms during atom selection


JmolVersion="14.32.43" //  also 15.2.43 (second upload)

bug fix: duplicate atom number after delete/add

new feature: set echo bottom left; ECHO JC.scaleName
  -- draws a |---| scale in the specified location
  -- uses measurementUnits (angstroms, pm, nm, or au (Bohr))
  -- adjusts by decades -- 0.01, 0.1, 1, 10, 100, etc.
  
new feature: axes POSITION [x y] "xyz"
  -- crystal structures only
  -- adds a second small axis set that is Cartesian
  -- [x y] or [x y%] screen position
  -- still shows unitcell axes
  -- uses the specified label for the axes labels
  -- label can be one, two, or three characters, for showing just x, 
     just xy, or xyz, respectively
  -- cleared using AXES POSITION OFF (axes on unit cell only)
  -- replaced with abc using "abc" instead of "xyz" (with no axes on unit cell itself)

optimization: faster loading of very large (>100K atom) files

JmolVersion="14.32.42" 
  also 15.2.42

new feature: set doublePrecision
  -- for JavaScript specifically, particularly important for crystal structure
  -- allows JavaScript to operate in full double precision mode with no rounding
  -- returns to pre-14.3.5 behavior
  -- disables all float/double reconciliation in Java and JavaScript
  -- CAUTION! May result in state loading problems between Java and JavaScript
  -- CAUTION! May result in problems loading older state scripts
  -- CAUTION! PNGJ images may not load properly
   
new feature: x = {atoms}.within(distance,[points])
  -- returns the subset of {atoms} that are within the specified distance 
     of any point in the array of points.
  -- allows tracking groups of atoms by position after reloading files in a way 
     that might change atom indexes

new feature: x = {atoms}.within(distance,{otheratoms})
  -- returns the subset of {atoms} that are within the specified distance 
     of any atom in {otheratoms}. Atoms in {otheratoms} are excluded.
  -- compare to within(distance, {atoms}), which does not exclude other atoms
     or within(distance, TRUE, {atoms}), which excludes other atoms but does not limit
     return to the {atoms} subset. 
     
  -- for example, easy check for atoms that have the same position using distance = 0.001

bug fix: set appendNew false; load append ... crystal structure ... 
         should transform atoms to cartesian coordinates and set space group to P1
           

JmolVersion="14.32.41" 
  also 15.2.41

bug fix: crystal set picking dragatom fails for some space groups

bug fix: SimpleUnitCell and PWMatReader not copied from Jmol-SwingJS



JmolVersion="14.32.40" 
  also 15.2.40

bug fix: set picking dragatom with crystal structure fails to constrain to line intersecting two planes

bug fix: ModelKit UNITCELL after atom deletion does not move all atoms

bug fix: PWMatReader should propagate site data for property_pwm* throughout sites
         when lattice or supercell is given in LOAD command

bug fix: ModelKit ASSIGN BOND incorrectly reports bond index to callback

JmolVersion="14.32.39" 
  also 15.2.39


cleaner start for ModelKit xtal builder from scratch

load =ams/quartz 1;delete *;
ModelKit add "P" {1/4 1/4 1/4}

load =ams/halite 1;delete *;
ModelKit add "P" {0 1/2 0}



JmolVersion="14.32.38" 
  also 15.2.38

bug fix: CrystalReader should recognize slab for topond output

bug fix: BilbaoReader fix for comments

bug fix: PWMatReader fix for broken positions when have constraints
bug fix: PWMatReader not loading constraints properly
bug fix: Resolver not recognizing PWMatReader options
bug fix: PWMATWriter not removing packing atoms in JavaScript
bug fix: PWMATWriter not rounding positions when very close to twelfths
bug fix: set picking dragatom with crystal not working due to same issue

bug fix: LOAD ... SPACEGROUP "x,y,z;-x,-y,-z"  broken when SET DEBUG TRUE

JmolVersion="14.32.37" removed
JmolVersion="14.32.36" removed


bug fix: PWMatWriter not removing packing atoms in JavaScript
bug fix: PWMatWriter not rounding positions when very close to twelfths
bug fix: PWMatReader not loading constraints properly

bug fix: CrystalReader should recognize slab for topond output

JmolVersion="14.32.35" 
  also 15.2.35

bug fix: load "" PACKED broken in 14.32.33

JmolVersion="14.32.34" 
  also 15.2.34

bug fix: PWMatReader constraints default 1 1 1 
bug fix: PWMatReader resolver fix
bug fix: state saving after crystal ModelKit changes
bug fix: load SMILES ... should allow FILTER "..."
bug fix: last model set should be able to be zapped (untested)

new feature: To get around CIR issue with missing imine stereochemistry:
  -- {thismodel}.inchi("SMILES/imine") will convert InChI N to [17C] or [17c] 
     with [5H] to preserve stereochemistry when loading.  
  -- MolReader will convert [17C,17c] to imine N automatically 
     and remove any [5H] 
  -- tested on about 1000 compounds with 55 that were failing InChiI -> SMILES -> InChI round trip
  
new feature: SMILES generator will NOT remove [H] from nitrogens.
 
JmolVersion="14.32.33" 
  also 15.2.33

bug fix: ModelKit crystal constraint user dragAtom might lock atoms -- fixed
bug fix: InChI->SMILES generates ...N(=O)=O rather than ...[N+](=O)[O-] for nitro compounds
bug fix: Jmol not recognizing MENU files for drag-drop, instead treating them as script files, 
         which disables Jmol due to the redefinition of the COLOR command (use of @COLOR = in menu files)
bug fix: PWMatReader flexibility for whitespace before headings         


JmolVersion="14.32.32" 
  also 15.2.32

bug fix: load ... filter "biomolecule" should not be reporting symmetry operators in menu
bug fix: SpaceGroupInfo for filter "biomolecule" should not report CIF2 style translation 

bug fix: "fixed" selection should not require explicit ModelKit HIDDEN 
bug fix: "fixed" selection should not fix atoms due to colinear axes
bug fix: hidden ModelKit should not display CH4 by defuault after ZAP


JmolVersion="14.32.31" 
  also 15.2.31

bug fix: dragAtom screen coordinate transform not transformed correctly into 3D positions

bug fix: select within(BOUNDBOX, atoms) can skip edge or corner atoms that were used to define it
 -- e.g. load =ams/quartz 1 packed; select within(BOUDNBOX, _O)

bug fix: DRAW SPACEGROUP missing last operation

new feature: set picking dragAtom TRUE now recognizes symmetry for crystal structures
 -- drags atoms only if symmetry-allowed  
    (that is, on an axis or plane)
 -- does not move atoms if they are in fixed special positions

new feature: {1/2 1/2 1/2}.symop("invariant")
 -- similar to @@1.symop("invariant") 
 -- returns an array of symop numbers for axes, planes, and centers of inversion
    for which this position is invariant. 

new feature: symop(2, "invariant")
 -- delivers an object that describes the invariant nature of this symmetry operator. 
 -- for a plane, returns {a, b, c, d} for that plane's equation  ax + by + cz + d = 0;
 -- for an axis, returns [point, vector], where point is on the line, and vector is the unit vector for the axis
 -- for a center of inversion or an n-bar axis, returns the center point
 -- for any operation involving a translation, returns "none"
 -- for the identity operation, returns "identity"
 -- see also @@1.symop("invariant"), 
       which delivers an array of symop numbers for axes, planes, and centers of inversion
       for which this atom's position is invariant.

new feature: @@1.symop(2, "invariant")
 -- same as symop(2, "invariant"), except adjusts return to be through the given atom
 -- presumes the atom is in a special position and not fixed
 -- returns the "true" plane or axis or center of inversion, not just the one for the generating operator

new feature: {1/2 1/2 1/2}.symop(2, "invariant")
 -- same as @@1.symop(2, "invariant"), but for a point rather than an atom
 -- adjusts return to be through the given point
 -- presumes the point is in a special position and not fixed
 -- returns the "true" plane or axis or center of inversion, not just the one for the generating operator

 
 
JmolVersion="14.32.30" 
  also 15.2.30

new feature: PWmatReader default to show centered magnetic vectors as SET VECTORSCENTERED; VECTORS 0.2; 

bug fix: CALCULATE SPACEGROUP should not limit atoms to within unitcell, just unitize and remove duplicates

bug fix: ModelKit HIDDEN should implicitly set modelKitMode TRUE

new feature: set picking dragAtom TRUE now recognizes  

new feature: ModelKit ADD @1 
new feature: ModelKit ADD @1 PACKED
 -- complete the set of atoms in a unit cell, possibly changing element

new feature: ModelKit ADD @1 "N"
new feature: ModelKit ADD @1 "N" PACKED
 -- complete the set of atoms in a unit cell, possibly changing element
 -- will not change space group

new feature: ModelKit ADD "Cl" {1/2 1/3 1/3}
new feature: ModelKit ADD "Cl" {1/2 1/3 1/3} PACKED
 -- adds a new atom at the specified position
 -- complete the set of atoms in a unit cell
 -- will not change space group
 
new feature: ModelKit ADD @1 "Cl" {1/2 1/3 1/3}
new feature: ModelKit ADD @1 "Cl" {1/2 1/3 1/3} PACKED
 -- adds a new atom at the specified position and connects it to @1
 -- complete the set of atoms in a unit cell
 -- will not change space group
 
new feature: ModelKit ADD/DELETE/MOVETO 
 -- all operable automatically from the ModelKit menu
 -- enabled by the presence of symmetry
 -- movement is constrained to "invariant" symmetry elements (axes or planes)
 -- use ModelKit SPACEGROUP "P1" to disable all constraints

new feature: select FIXED
 -- selects all atoms that are locked by symmetry
 
new feature: MINIMIZE now works (minimally) with a crystal structure. 
 -- use load ... {444 666 1}; minimize
 -- no change in space group
 -- asymmetric unit will be minimized with propagation to symmetry-related atoms
 -- minimally effective; mostly to demonstrate constrained positions


JmolVersion="14.32.29" 
  also 15.2.29

bug fix: JavaScript for write CIFP1 fails for Math.abs(Integer.MIN_VALUE) < 0 in Java 
bug fix: ModelKit add {*} packed  not packing

new feature: moveto AXES [-][ab, bc, ca, ba, cb, ac][1, 2, 3, 4]
 -- similar to moveto AXES [a, -a, a1, -a1, a2, a3, a4, b, -b, ...]
 -- allows views perpendicular to any unit cell face
 -- XY1 (where X and Y are one of [a,b,c]) presents the XY face in the plane of the screen 
    with the origin on the bottom left, X to the right, and Y pointing up
 -- XY2, XY3, and XY4 rotates the origin clockwise around the four corners: top left, top right, bottom right
 -- default is 1, so ab is the same as ab1
 -- for rectilinear unit cells in particular, this equates:
 	 AXIS bc2 with AXIS a and AXIS a1
 	 AXIS ca2 with AXIS b and AXIS b1
 	 AXIS ab and AXIS ab1 with AXIS c and AXIS c4
 

JmolVersion="14.32.28" 
  also 15.2.28

bug fix: PWMAT reader/writer fixes

new feature: PDB alpha-carbon-only sheet structure enabled

new feature: ".pivot" function no longer needs ".all" for atom properties
 -- print {*}.elemNo.pivot same as print {*}.elemNo.all.pivot
 
new feature: ModelKit ADD @2 [PACKED]
 -- completes the equivalent positions for an atom in a crystal
 -- will add only as many atoms as necessary
 -- updates {thismodel}.site values
 -- optionally packs the unit cell
 
new feature: ModelKit ADD @2 "C" [PACKED]
 -- completes the equivalent positions for an atom in a crystal
 -- will add only as many atoms as necessary
 -- transforms all specified atom sites to this element
 -- updates {thismodel}.atomName values  ("O2" becomes "C2", for instance)
 -- updates {thismodel}.site values
 -- optionally packs the unit cell

new feature: ModelKit ADD "C" point [PACKED]
 -- completes the equivalent positions for an atom in a crystal
 -- will add only as many atoms as necessary
 -- positions based on the symmetry of the specified point
 -- updates {thismodel}.atomName values  ("O2" becomes "C2", for instance)
 -- updates {thismodel}.site values
 -- optionally packs the unit cell
  
new feature: x = data("xxx*")
 -- returns an array of data keys starting with "xxx"
 -- for instance, x = data("property_MYKEYS_*") to retrieve all your custom keys
 -- then y = data(x[1]) would return the data for the first item in the array of keys

JmolVersion="14.32.27" 
  also 15.2.27

new feature: plane designations "ab" "ab1" "ac "ac1" "bc" bc1" short for {0 0 1/1 0} {0 0 1/1 c} etc. 

new feature: ModelKit MOVETO @1 {1/2 0 0}
 -- moves the atom only if its invariant symmetry is unchanged (that is, doesn't create or destroy atoms)

new feature: ModelKit FIXED VECTOR point1 point2
 -- constrains atom dragging to a given vector
 -- atom will still not move if symmetry does not allow it
 -- replaces any fixed plane
 -- cleared by changing the value of set modelKitMode

new feature: ModelKit FIXED PLANE plane
 -- constrains atom dragging to a given plane
 -- atom will still not move if symmetry does not allow it
 -- replaces any fixed vector
 -- cleared by changing the value of set modelKitMode

new feature: ModelKit FIXED NONE
 -- removes constraint

new feature: @1.symop("invariant")
 -- delivers an array of integers, the symmetry operator indexes other than identity 
    (numbers 2-N) for which the specified atom is unchanged in position when operated upon
 -- for example, the position of an atom on a rotation element or on a mirror plane is unchanged 
    upon rotation or reflection, respectively 
 -- used internally to determine when ModelKit MOVETO can allow a change in position

new feature:  @1.pointgroup("spacegroup")
 -- same as pointgroup("spacegroup", @1)
 -- consistent with @1.spacegroup()


JmolVersion="14.32.26" 
  also 15.2.26

bug fix: CIFWriter fails for JavaScript/legacy; uses String.isEmpty() -- not included in legacy transpiler runtime JavaScript
bug fix: CIFWriter for CIFP1 should accept any atoms, unitizing them, and not limit itself to atoms to within(unitcell)

bug fix: 3x3 and 4x4 matrix multiplication of a vector of points not working

new feature: {atoms}.find("equivalent") {
 -- returns all atoms with the same .site value as any of the atoms specified
 -- these atoms may or may not be within the unit cell
 -- returns at least all atoms in {atoms}

new feature: {point}.find("equivalent") {
 -- returns all equivalent positions by applying all symmetry operators to this point
 -- these points will be only WITHIN the unit cell -- fractional coordinates [0,1)
 -- may or may not return {point} itself

new feature: {point}.find("equivalent", "packed") {
 -- returns all equivalent positions by applying all symmetry operators to this point
 -- these points will include points in the packing layer around the cell -- fractional coordinates [0,1]
 -- may or may not return {point} itself
 
 
new feature: UNITCELL OFFSET @1; UNITCELL OFFSET {atoms}
 -- quick offset to a specific atom or center of atoms
 
new feature: LOAD .... SPACEGROUP "Hall:P 2y"
 -- allows prefix "Hall:" to specify Hall notation
 -- allong with SPACEGROOUP 3 or SPACEGROUP "10:b"
 -- allows for experimentation with different space groups
 
new feature: ModelKit ASSIGN SPACEGROUP "P1"
 -- assign P1 to the space group for the selected model atoms (or model, if no atoms are selected) 
 -- can be reset (in most cases) using ModelKit ASSIGN SPACEGROUP

new feature: ModelKit DELTE {atoms}
 -- deletes all symmetry-equivalent atoms (all atoms with the same .site value as any atoms in this set)
 -- use x = {atoms}.find("equivalentAtoms").length to check how many atoms this will be

new feature: {atoms}.distance()
 -- intuitive, useful
 -- same as {atoms}.distance({0 0 0})
 -- note that {atoms}.length reports the number of atoms in the set

new feature: {1 2 3}.distance()
 -- consistent with {atoms}.distance()
 -- same as {1 2 3}.distance({0 0 0})
  
feature change: {1 2 3}.length
 -- was the useless "-8" and nonintuitive
 -- same as {1 2 3}.distance({0 0 0})
 -- intuitive, expected -- like string, array, associative array, byte array, [{...}] (bond set), and ({...}) (atom set).
 -- note that {1 2 3}.type reports "point", which is more intuitive as well
 -- {1 2 3}.size and {1 2 3}.count still report -8
   
JmolVersion="14.32.25" 
  also 15.2.25

bug fix: PDB/mmCIF/MMTF biomolecule filter fails for simple chain selection (7OJP) 

bug fix: MMTF reading of biomolecule filter fails to bond atoms, resulting in no display 

bug fix: axes labels for origin not shown for unitcell

bug fix: additional work on UNITCELL SURFACE

new feature: DRAW UNITCELL xxx LATTICE {na nb nc}
 -- draws a set of lattice points, including lattice centering
 -- mostly for debugging; possibly useful

new feature: DRAW INTERCEPT UNITCELL xxx LATTICE {na nb nc}... HKL ....
 -- draws as set of lattice points that are on a given plane
 -- mostly for debugging; possibly useful
 
bug fix: UNITCELL SURFACE validation on silicon, iron, quartz
 -- all typical Miller planes (1/0/-1, 1/0/-1, 1/0/-1) checked for 
    standard gamma >= 90, proper right-hand-rotation axes
    using FCC, BCC, and primitives
 -- can be followed by:  u = unitCell(); LOAD "" FILL @u; UNITCELL @u

new feature: SAVE STATE 
 -- by itself, loads the UNDO stack and clears the REDO stack
 -- sets undoAuto FALSE, turning off Java Application Console automatic undo/redo
 -- process is: SAVE STATE...UNDO REDO ...SAVE STATE...SAVE STATE...UNDO...UNDO...

JmolVersion="14.32.24" 
  also 15.2.24

bug fix: ChemDraw CDXML reader was not tested in 15.2.23
 -- now loads proper compounds with (common) protecting groups. 
 -- 2D -> 3D enabled; adds "Nickname" nodes (minimized as fluorine)

undocumented feature:  filter "*.ca;/=3";

bug fix: bonds to transparent atoms should be flat ends, not open

new feature: SET UNDOAUTO FALSE|TRUE
 -- default value TRUE, enabling automatic saving of the state only in the Java application
 -- setting false turns off Java application console automatic undo/redo
    and allows user-defined undo/redo states
 -- disabled by SET PRESERVESTATE FALSE

new feature: SET UNDO
 -- saves the current state on the UNDO stack.
 -- clears the REDO stack
 -- sets undoAuto FALSE
 
new feature SET UNDOMAX n 
 -- sets the maximum number of saved states (default 20) with SET defaultAuto FALSE
 -- setting this value to 0 clears both the UNDO and the REDO stacks

new feature UNDO
 -- when undoAuto is true, in the Jmol application console only, carries out an undo action
 -- when undoAuto is false, or not in the Java application, restores the most recent
    state saved using SET UNDO
    
new feature REDO
 -- when undoAuto is true, in the Jmol application console only, carries out a redo action
 -- when undoAuto is false, or not in the Java application, restores the most recent
    state prior to an UNDO operation

new feature: SHOW UNDO
 -- reports if undoAuto is true or false, and if it is false, reports the sizes of the user
    UNDO and REDO stacks.

new feature: ModelKit UNDO/REDO
 -- a separate undo/redo stack specifically for the ModelKit
 -- undoes or redoes a ModelKit action
 -- disabled by SET PRESERVESTATE FALSE


new feature: UNITCELL SURFACE {h k l} [height | scale%] [offset or offset%] [TOP]
 -- operates on current unit cell, so for repeat use, use unitcell reset
 -- allows creating a unit cell based on a Miller plane
 -- perpendicular to plane, with u = b/k - a/h, v = c/l - b/k (generally)
 -- optional height in Angstroms or scaled relative to hkl distance to origin
 -- optional offset in Angstroms or percent of unit cell height 
 -- default offset sets bottom of unit cell at origin
 -- optional TOP parameter measure from the top of the new unit cell
 -- examples:
    
    load =ams/halite 1 packed
    unitcell reset;unitcell surface {1 1 1} 100% // between {0 0 0} and Miller plane
    unitcell reset;unitcell surface {1 1 1} 100% // between {0 0 0} and Miller plane
    unitcell reset;unitcell surface {1 1 1} 100% 50% // centers unit cell on Miller plane
    unitcell reset;unitcell surface {1 1 1} 50% 150% // half-height cell centered on Miller plane 
    unitcell reset;unitcell surface {1 1 1} 100% -100% // top on {0 0 0}
    unitcell reset;unitcell surface {1 1 1} 100% @{hkl(1 1 1).w} // same as 100% -100%
    unitcell reset;unitcell surface {1 1 1} TOP // same as 100% -100%
    unitcell reset;unitcell surface {1 1 1} 10 TOP // same as 50% -100%

JmolVersion="14.32.23" 
  also 15.2.23

bug fix: LOAD filter for rejecting an element, for example, "!_H", not functional


JmolVersion="14.32.22" 
  also 15.2.22

new feature: Jmol*.jar upgraded to Java 8. 
 -- Note, however, that the legacy transpiler for 14.* versions will not handle Java8+ syntaxes. 
 -- so no switch(String) and no catch(Exception | Exception | Eception) and no try(resource) {...}

bug fix: Jmol.jar/JmolData.jar -i silent flag not respected for CIR resolver resolution messages  

bug fix: JmolData.jar missing net.sf.jniinchi classes

bug fix: ModelKit ASSIGN ATOM "Xx" {x y z} adds new atom "H", not "dummy atom" Xx 

bug fix: PDB/mmCIF/mmTF CONECT records between chains in different BIOMT blocks must be removed
 -- sets the distance limit to 5 Angstroms, just to allow for hydrogen bonds

new feature: {associative array}.pivot()
 -- switches keys for values
 -- result is an associative array of lists
 -- allows quick filtering based on values of a simple associative array
 -- for example:
 
    load =2fk3
    print {*}.chain.all.pivot.pivot()

new feature: {associative array}.pivot("count")
 -- switches keys for values and reports count of each list, not the list itself
 -- allows quick filtering based on values of a simple associative array
 -- for example:
 
    load =2fk3
    print {*}.chain.all.pivot.pivot()
      
new feature: {associative array}.select("... WHEREIN VALUE...")
 -- "WHEREIN VALUE" allows section of associative array items by value
 -- especially handy as [array].pivot.pivot()
 -- for example:
 
    load =1d66
    print {*}.chain.pivot.select("* wherein value > 40")

new feature: {associative array}.select("... WHEREIN KEY...")
 -- "WHEREIN KEY" allows section of associative array items by key
 -- especially handy as [array].pivot.pivot()
 -- can be combined with VALUE checke
 -- for example:
 
    load =1d66
    print {*}.chain.pivot.select("(*) wherein key = 'B' or key = 'A' ").sum



JmolVersion="14.32.21" 
  also 15.2.21

bug fix: CENTER {0 0 0} broken in 15.2.20
bug fix: write PNGJ, ZIP, JMOL do not save internal path to files dropped in 
         Jmol/Java or otherwise having explicit type:: prefixes

JmolVersion="14.32.20" 
  also 15.2.20

bug fix: load FILTER "bmchains" not working as advertised.
 -- for PDB, mmCIF, MMTF
 -- removes duplicate chain ids when applying BIOMOLECULE option
 -- bmchains or bmchains=0 will append symmetry operator > 1 to chain id, so {A B A B A B} becomes {A B A2 B2 A3 B3}  
 -- bmchains=1 will increment chain ids past last identified chain, so {A B A B A B} becomes A B C D E F
 -- bmchains=5 will increment chain ids starting 5 letters after last identified chain starting , so {A B A B A B} becomes A B G H I J
 -- bmchains=a will increment chain ids starting with 'a'
 -- overflow of [A-Za-z] will fall back to bmchains=0 option  (load =1AUY filter "biomolecule 1;bmchains=1") 
  
bug fix: atom.fxyz, .uxyz should follow changes in unit cell size involving supercells.

bug fix: CifWriter atom_site_label not unique

new feature: UNITCELL FILL {na nb nc} 
 -- simple integer multiple unitcell option similar to RANGE {555 ijk 1}
    (meaning show block with lines for each contained unit cell)

new feature: UNITCELL SUPERCELL {na nb nc} 
 -- simple integer option similar to RANGE {555 ijk 0}
    (meaning show as one large unit cell)

new feature: {*}.find("spacegroup") -- discovers the space group for a model 
 -- using the current unit cell, finds a compatible spacegroup or returns P1
 -- uses a novel algorithm that efficiently scans all known operators to 
    rapidly iterate to the only compatible spacegroup for a given unit cell
 -- automatically reduces to the parent unit cell if currently a supercell
 -- assumes the specified atoms are within(unitcell) or packed as (cell=555)
 -- returns one of 531 known space group settings as a map including keys:

		HallSymbol
		HermannMauguinSymbol
		basis
		crystalClass
		ita
		jmolId
		operationCount
		operationsXYZ
		supercell
		unitcell

 -- returned basis value is the asymmetric unit atom set for this setting
 -- returned supercell value is a point {na nb nc} indicating the block of 
    unit cells found, or {1 1 1} if no supercell was found. 
    -- use UNITCELL FILL @{x.supercell} to switch to a block of the smaller unitcells
    -- or UNITCELL SUPERCELL @{x.supercell} to return to this supercell
 -- return value unitcell is a parameter set [a b c alpha beta gamma va vb vc] 
    indicating the exact unit cell described by the supercell, if one was found
 -- missing packed atoms or additional extraneous atoms will return P1 
 -- will return P1 if the space group could not be determined.
    
new feature: CALCULATE SPACEGROUP 
 --	report the space group for the current model 

new feature: CALCULATE SPACEGROUP {atoms}
 --	report the space group for the specfied atoms 

new feature: ModelKit ASSIGN SPACEGROUP
 -- find and set the space group for this model 
 -- models without unit cells will be given a nominal P1 space group with simple 10-Angstrom cubic cell 
 
   
 

JmolVersion="14.32.19" 
  also 15.2.19
  
  new feature: JSpecView Java application allows for headless batch script execution
  
    java -jar jspecview.jar -script "load \"C:/temp/10.zip\";write difdup \"testzip.jdx\";" -nodisplay
    java -Djava.awt.headless=true -jar jspecview.jar -script "load \"C:/temp/10.zip\";write difdup \"testzip.jdx\";"

JmolVersion="14.32.18" 
  also 15.2.18

-- Build 14.32.17 removed -- crystal structures broken due to bad build

bug fix: GaussianReader tensor "csa" broken
bug fix: show UnitCell does not reflect UNITCELL command shifting or scaling
bug fix: axes incorrect for scaled unitcell

undocumented: ELLIPSOID SET option
 -- ellipsoid SET "csa" scale 0.5

new feature: write CIF "t.cif"
 -- writes CIF with symmetry
 -- reverts to P1 symmetry if individual atoms have been added 
    or unitcell has been moved to non-integral position or adjusted in size

new feature: write CIFP1 "t.cif"
 -- writes CIF as P1 symmetry, only including the periodic atoms

new feature: getProperty unitCellInfo
 -- for the current unitcell, including any offset
 -- includes properties matCtoF, matFtoC, params, vectors, volume 
	
new feature: select within(unitcell)
 -- uses the current unitcell, selecting atoms with fractional coordinates
    within the range [0, 1)
 -- effectively returns the set of points that are periodic
 
new feature: select within(unitcell, u)
 -- where u is the result of the unitcell() function
    (that is, an array [o a b c] of origin and three vectors)
 -- uses the specified unitcell, selecting atoms with fractional coordinates
    within the range [0, 1)
 
 
JmolVersion="14.32.17" 
  also 15.2.17

bug fix: Show $s2  for isosurface reports first isosurface only
bug fix: _M.unitCellParams does not update after modifying the unit cell
bug fix: GausssianReader Tensor "csa" broken
bug fix: ScriptEditor many issues
bug fix: ... HKL {1 1 1}  works, but HKL 1 1 1 fails, if not last in a command

new feature: getproperty("atomInfo").select("fx,fy,fz")
 -- adds fractional coordinates to atomInfo
 
new feature: draw boundbox @1 @2 @3 @4...
 -- draws a boundbox with edges in the x, y, and z directions through a set of points

new feature: draw best boundbox @1 @2 @3 @4...
 -- draws the best boundbox through a set of points

new feature: draw best plane @1 @2 @3 @4...
 -- draws the best plane through a set of points

new feature: draw best line @1 @2 @3 @4...
 -- draws the best line through a set of points
 
new feature: draw intersection [unitcell or boundbox description] [line or plane description]
 -- intersects all types of boundboxes and unitcells with any type of plane or line
 
new feature: draw intersection [unitcell or boundbox description] ON [line or plane description]
 -- projects a unitcell or boundbox on any plane 

new feature: draw intersection [unitcell or boundbox description] LINE @1 @2 
 -- extends the specified line to intersect a unitcell or boundbox 

new feature: draw diameter -1 ....
  -- for lines or mesh option
  -- draws a simple line with 1-pixel width 
  
new feature: draw diameter -n ....
  -- for lines or mesh option
  -- draws a dotted 1-pixel line with alternating n on, n off pixels
 
new feature: draw HKL {1 1 1 x.x} 
  -- offsets an HKL plane from the origin by x.x Angstroms 

new feature: draw HKL {1 1 1} OFFSET x.x
  -- alternative to HCL {1 1 1 x.x}
  
new feature: select on @{_M.asymmetricUnit}
  -- _M.asymmetricUnit is the atom bitset for the asymmetric unit
  -- empty string if there is no current unit cell
  
new feature: select on @{_M.asymmetricUnit}
  -- _M.asymmetricUnit is the atom bitset for the asymmetric unit
  
  
  
   
JmolVersion="14.32.16" 
  also 15.2.16

new feature: (JavaScript API) Jmol.setCallback(jmolApplet0, "xxx", function() {......})
 -- where "xxx" is one of the allowed callbacks, namely (case insensitive):
    ANIMFRAME, APPLETREADY, ATOMMOVED, AUDIO, CLICK, DRAGDROP, ECHO,
    ERROR, EVAL, HOVER, IMAGE, LOADSTRUCT, MEASURE, MESSAGE, MINIMIZATION,
    ModelKit, PICK, RESIZE, SCRIPT, SELECT, SERVICE, STRUCTUREMODIFIED, SYNC 
 -- allows anonymous function setting for callbacks rather than using JmolScript SET xxxCallback "funcName"
 
new feature: (JavaScript) Info = { .... , errorCallback: function{....},...}

 -- allows setting of functions rather than function names in Info parameters

new feature: Drag-Drop into Java AppConsole assumed to be script and run

new feature: Drag-Drop into JavaScript output console assumed to be script and run

new feature: Drag-Drop into JavaScript input console displayed
     
  

JmolVersion="14.32.16" 
  also 15.2.16

new feature: (JavaScript API) Jmol.setCallback(jmolApplet0, "xxx", function() {......})
 -- where "xxx" is one of the allowed callbacks, namely (case insensitive):
    ANIMFRAME, APPLETREADY, ATOMMOVED, AUDIO, CLICK, DRAGDROP, ECHO,
    ERROR, EVAL, HOVER, IMAGE, LOADSTRUCT, MEASURE, MESSAGE, MINIMIZATION,
    ModelKit, PICK, RESIZE, SCRIPT, SELECT, SERVICE, STRUCTUREMODIFIED, SYNC 
 -- allows anonymous function setting for callbacks rather than using JmolScript SET xxxCallback "funcName"
 
new feature: (JavaScript) Info = { .... , errorCallback: function{....},...}

 -- allows setting of functions rather than function names in Info parameters
     
new feature: (JavaScript) Info = { .... , errorCallback: function{....},...}

 -- allows setting of functions rather than function names in Info parameters

new feature: Drag-Drop into Java AppConsole assumed to be script and run

new feature: Drag-Drop into JavaScript output console assumed to be script and run

new feature: Drag-Drop into JavaScript input console displayed
     
     
JmolVersion="14.32.15" 
  also 15.2.15

new feature: JmolScript: callbacks have access to parameters of JavaScript callbacks
 -- within the callback, _args() provides full list of arguments
 -- _args(1) first argument, etc.
 -- recommendation to NOT use _args()[0] "last" notation here, as future expansion may add parameters  

new feature: FONT DRAW
 -- allows setting the font for (general) DRAW object text
 
new feature: DRAW TITLE "xxx"
 -- adds (optional) TITLE keyword

new feature: DRAW TITLE COLOR red "xxx"
 -- adds title color option
 
new feature: DRAW TITLE FONT sansSerif bold 20 "xxx"
 -- adds title color option
 -- face and or style are optional; size is required
 -- can use this after draw is already created
      draw @1 @3 "test"
      draw font 20

new feature FONT DRAW ....
 -- allows setting the default font for DRAW objects
 
new feature: set labelPointerWidth
 -- sets the width of the line for SET LABELPOINTER ON
 -- default 2

bug fix: label pointers not properly connecting to label for all offsets   
bug fix: JavaScript float processing allowed to read full double precision
bug fix: measurements recently started showing artificial double precision when only single
bug fix: ModelKit ASSIGN ATOM fails when in xtal mode
bug fix: structureModifiedCallback not reporting fully
bug fix: SET FONTSIZE and FONT LABEL x.x  should not reset font face or style
bug fix: spacefill -23% should indicate ONLY
bug fix: JmolScript: callbacks should not be asynchronous

JmolVersion="14.32.14" 
  also 15.2.14
  
new feature: ModelKit UNITCELL [unitcell description]
 -- same as the UNITCELL command, but also adjusts atom 
    coordinates to retain same fractional positions:
      
       var fxyz = {thismodel}.fxyz.all;
       unitcell ....
       {thismodel}.fxyz = fxyz;

new feature: selectCallback parameters added: nSelected, indexFirst, indexLast+1

bug fix: PWMAT reader needs to allow text on first line
bug fix: unitcell() without atoms in a frame should still return frame's unitcell
bug fix: set labeloffset broken in 14.32.12

JmolVersion="14.32.13" 
  also 15.2.13

bug fix: VASP reader for Cartesian coords not converting automatically to fractional
bug fix: JavaScript getPropertyJSON broken for array data
bug fix: Release 14.32.12 faulty -- files removed.	

JmolVersion="14.32.12" 
  also 15.2.12

new feature: (Java only) inchiString.inchi("SMILES") converts InChI to SMILES. 
 -- utilizes JniInchi structure created from an InChI to generate SMILES strings. 
 -- net effect is that InChI strings can be converted to structures via SMILES. 
 -- passes tetrahedral, cumulene, and alkene stereochemistry tests
 -- InChI does not implement atropisomer stereochemistry
 -- InChI created using {*}.inchi("FixedH") will differentiate tautomers
 

new feature: Adds compare({1.1},{2.1},"isomer",TRUE)
 -- TRUE indicates to also do a tautomer check.
 -- compares InChI with InChI FixedH option
 

new feature: selectCallback
 -- Fires after a scheduled script is completed if SELECT has been issued

new feature: SELECT , ...  (first parameter comma)
 -- Fires selectCallback immediately, not after script is completed
 
new feature: write XSF 
 -- writes XCrysDen files http://www.xcrysden.org/doc/XSF.html
 -- selected atoms only
 -- includes ANIMSTEPS for molecules and crystals

new feature: write PWMAT 
 -- a simple pwmat input (atom.config) file format for just lattice and atoms
 -- selected atoms only
 
code: refactored org.jmol.adapter.writers.* from PropertyManager

bug fix: CMLWriter broken; maybe never worked.
bug fix: format() did not allow for decimal places up to 12.
bug fix: POSCAR reader treating "T" constraint as "tritium" 
bug fix: XCrystDen reader not reading animation properly

JmolVersion="14.32.11" 
  
bug fix: dispose of popupmenu fails (15.2.8)
bug fix: JmolStatusListener should allow for user to also add listener

retired code: Jmol applet, netscape jar and package, java.applet.Applet, and javax.swing.JApplet all moved to /unused/

JmolVersion="14.32.10" 
  also 15.2.10
  
bug fix: Amimation start during pause of previous animation will halt wrong animation thread.

JmolVersion="14.32.9" 
  also 15.2.9
 
new feature: load FILTER "bmchains=0" or "bmchains=1" ("bmchains" by itself defaults to 0)
 - for PDB, mmCIF, MMTF
 - removes duplicate chain ids when applying BIOMOLECULE option
 - bmchains=0 will append symmetry operator > 1 to chain id, so {A B A B A B} becomes {A B A2 B2 A3 B3}  
 - bmchains=1 will increment chain ids, so {A B A B A B} becomes A B C D E F
 - expects chains to be of the type {A B C D ...}


JmolVersion="14.32.8" 
  also 15.2.8
 
 bug fix: removing (deprecated, unnecessary) sun.audio.* references 
 bug fix: ModelKit creating allylic N not sp2; mouse action issues;better bond rotation
 code: refactoring ModelKitPopup; adding ModelKit.java

JmolVersion="14.32.7" 
  also 15.2.7
    
bug fix: JavaScript error on file reading can cause infinite loop
bug fix: toJSON for primitive arrays creating string arrays ["1","2"]
bug fix: dynamic PDB menu items not refreshing after file load if menu is not already created
bug fix: MUTATE with pdbAddHydrogens fails and crashes Jmol

new feature: expanded MUTATE options 
 -- examples:
 
	mutate 33 LYS
	mutate ALA34 G
	mutate {ALA.CA}[2] G	
	mutate {1-3} GAL
	mutate {1-3} A	
	mutate {1-3} ~LYS (that is, LEU-TYR-SER)
	mutate {1-3} G_L
	mutate {1-4} "GLY-AlA"
	mutate ALA34 "myAla.pdb" (from a file)
	mutate ALA34 "==SEP"	(from RCSB)
	mutate @3 @res	(using variables)
	

new feature: MUTATE CREATE option 
 -- creates peptides with specified sequence and secondary structure (phi/psi)
 -- examples:
    mutate create aaaaaaa   // defaults to alpha
    mutate create "lys-ala-ser" // uses one-letter and three-letter codes
    mutate create ppppp "3-10" // 16 pre-defined phi/psi sequences:
    
		"alpha"	[ -65, -40 ]
		"3-10"	[ -74, -4 ]
		"pi"	[ -57.1, -69.7 ]
		"alpha-L"	[ 57.1, 4 ]
		"helix-II"	[ -79, 150 ]
		"collagen"	[ -51, 153 ]
		"beta"	[ -140, 130 ]
		"beta-120"	[ -120, 120 ]
		"beta-135"	[ -135, 135 ]
		"extended"	[ 180, 180 ]
		"turn-I"	[ -60, -30, -90, 0 ]
		"turn-II"	[ -60, 120, 80, 0 ]
		"turn-III"	[ -60, -30, -60, -30 ]
		"turn-I'"	[ 60, 30, 90, 0 ]
		"turn-II'"	[ 60, -120, -80, 0 ]
		"turn-III'"	[ 60, 30, 60, 30 ] 
 
new feature: ModelKit MUTATE
 - same as MUTATE, but associated (and documented) with ModelKit

new feature: ModelKit CONNECT @1 @2 [0,1,2,3,4,5,p,m] (default 1)


 ModelKit [ON(nada)/OFF/DISPLAY/HIDE]
    
  ModelKit CENTER point or atoms (point can be fractional by adding "/1" to at least one coord)

  -- action options include alternatives to the given commands (assign is undocumented)
  
  ModelKit ASSIGN ATOM [symbol|pl|mi] point
  ModelKit ASSIGN ATOM @1 [symbol|pl|mi]
  ModelKit ASSIGN ATOM @1 [symbol|pl|mi] point
  ModelKit ASSIGN BOND (integer) [0,1,2,3,4,5,p,m] (default P)
  ModelKit ASSIGN BOND {atom1 atom2} [0,1,2,3,4,5,p,m] (default P)
  ModelKit ASSIGN BOND @1 @2 [0,1,2,3,4,5,p,m] (default P)

  ModelKit CONNECT @1 @2 [0,1,2,3,4,5,p,m] (default 1)

  ModelKit ROTATE ...  (same as ROTATE for example, ROTATE BOND @1 @2 degrees)
  ModelKit ROTATESELECTED (same as ROTATESLECTED)

 view mode     
  ModelKit SYMOP [n]
  ModelKit SYMOP "x,-y,z"
  ModelKit SYMOP [[4x4 matrix]]
  ModelKit OFFSET [{i j k}/NONE]

  -- configuration options include the following; CAPS is default:
       
  ModelKit SET addHydrogens [TRUE|false]
  ModelKit SET autobond [true|FALSE]
  ModelKit SET clickToSetElement [TRUE|false]
  ModelKit SET showSymopInfo [TRUE|false]
  ModelKit SET bondtype [0,1,2,3,4,5,p,m]
  ModelKit SET element [name or symbol]
  ModelKit SET MODE [molecular|view|edit]
  ModelKit SET UNITCELL [EXTEND|PACKED]

 edit mode -- not implemented

  ModelKit SET SYMMETRY [APPLYFULL|APPLYLOCAL|RETAINLOCAL] // not implemented
  ModelKit POINT point or atoms // not implemented
    
  -- configuration options can be given sequentially within one ModelKit command or in individual commands
  -- examples:
  
  ModelKit set mode view symop 5 center @3 
  ModelKit set mode view symop 5 center @3 offset {0 0 0}   // unitized [0,1)    


JmolVersion="14.32.6" 
  also 15.2.6
  
bug fix: (JavaScript only) insignificant script processing error reported in JavaScript console  
bug fix: InChI for deutero compounds not working
bug fix: InChI failure should show "?" not SMILES

JmolVersion="14.32.5" 
  also 15.2.5

bug fix: show INCHI  broken in 14.32.5

new feature: hack added for reading invalid CIF files created by Materials Studio

Apache Log4J vulnerability checked (not applicable)

Confirming that Jmol.jar (any version) is not affected by the CVE-2021-45046: 
	Apache Log4j2 Thread Context Message Pattern and Context Lookup Pattern vulnerable to 
	a denial of service attack as described by Apache, or any other Log4j2 vulnerability. 

Several checks support this finding:

 1) Jmol is compiled using Java 6. Log4j2.x requires at least Java 7.
 2) Jmol itself does not use Log4j. We use a much simpler, extremely streamlined custom class, 
 	org.jmol.util.Logger, with only a very simple interface.
 3) Jmol does incorporate JNI-InChI 1.03_1, which does utilize Log4j. However, JNI-InChI 1.03_1 
 	utilizes Log4j1, not Log4j2. 
 4) Log4j1.x is not impacted by this vulnerability. 
 5) The suggested mitigation -- simply removing org/apache/logging/log4j/core/lookup/JndiLookup.class 
 	from the distributed JAR file (Jmol.jar, JmolData.jar) is unnecessary, as Jmol.jar does not 
 	contain even the org/apache/logging package, much less any class file that starts with "Jndi". 
 6) As part of this version update the ANT task
 	<delete file="${appjars.dir}/org/apache/logging/log4j/core/lookup/JndiLookup.class" /> 
 	has been added to build.xml just in case any future version of any dependency might include that class.


JmolVersion="14.32.4" 
  also 15.2.4

feature change: ModelKit no longer by default does drag-to-bond with default autobonding
  - autobonding leads to results unexpected by the user -- should not be the default setting
  - use ModelKit SET AUTOBOND TRUE to re-enable this feature if desired
  - easy enough to drag to bond atoms without this
  
new feature: ModelKit set autobond true
 -- when dragging to create a new bond to a new atom, automatically check vicinity of the new atom for bonding
 -- default now set to FALSE
 
new feature: ModelKit set hidden true
 -- hides the ModelKit menu but retains the picking and hover highlights
 
new feature: PWmat atom.config reader http://pwmatus.com/manual

bug fix: ModelKit does not preserve setPicking setting in quiet mode
bug fix: ModelKit autobonding is too aggressive; needs to be settable


JmolVersion="14.32.3" 
  also 15.2.3
  
bug fix: (JavaScript only) insignificant script processing error reported in JavaScript console  
bug fix: various ModelKit issues.

JmolVersion="14.32.2" 
  also 15.2.2

bug fix: ModelKit shows wrong hover labels
bug fix: LOAD APPEND after adding atoms via ModelKit does not by default append new
bug fix: state saved after deleting atoms in modelKitMode uses appendNew true, creating several fragment models
bug fix: Java app ModelKit icon does not clear when a structure is loaded

new feature: ModelKitCallback 
 -- String value is "ON" or "OFF"
 -- for example: set ModelKitcallback "jmolScript:print 'modelKitMode=' + modelKitMode"

new feature: ModelKit command
 -- was introduced for 15.0.2 / 14.29.25, but was not documented
 -- allows scripting of ModelKit functions
 -- turning the ModelKit on/off - same as SET modelKitMode:
 
   ModelKit ON
   ModelKit OFF
 
 -- note that the ModelKit does not have to be ON for the following functionality.  
   
 -- note that the ModelKit does not have to be ON for the following functionality.  
   
 -- configuration options include the following, where (xxx) is optional, CAPS is default:

  
   ModelKit addHydrogens [TRUE|false]  
     -- setting this false turns off the automatic addition of hydrogens  
   ModelKit clickToSetElement [TRUE|false] 
     -- setting this removes the ability to change elements other than H by clicking on them
   ModelKit showSymopInfo
     -- setting this false stops the ModelKit from showing space group symmetry information  
     
  -- configuration options can be given sequentially within one ModelKit command or in individual commands
 
   ModelKit addHydrogens FALSE clickToSetElement TRUE;
   
 -- ModelKit actions:

   ModelKit assign atom @3 "C"
     -- changes atom 3 to carbon, with concomitant bond distance change and addition of H
   ModelKit assign atom "C"  {3 3 3}  
     -- adds a carbon at {3 3 3} but does not bond anything to it
   ModelKit assign atom @25 "O" {3 4.2 3}
     -- adds an O atom connected to @25 and at the default distance on the line between @25 and {3 4.2 3}
   ModelKit assign bond @1 @2 <type>
     -- where type can be 0,1,2,3,4,5,p,m
       - p indicates +, increment (cycles 1 2 3 1)
       - m indicates -, decrement (stops at 0)
     -- with associated changes in hydrogen count
   ModelKit connect @25 @26  
     -- connects two atoms, adjusting hydrogen atoms according to standard hybridization
        
 new feature: SHOW ModelKit addhydrogens
 new feature: SHOW ModelKit clickToSetelement
 new feature: SHOW ModelKit showSymOpInfo
 
 new feature: getProperty("ModelKitinfo")
   -- delivers an associative array of information about the ModelKit 
      
      
JmolVersion="14.31.61"
  also 15.1.61

new feature: JSpecView reading Bruker NMR 1D and 2D directories and ZIP files
  - drag any file from a Bruker directory or the directory itself into JSpecView
  
new feature: allow select within(cell,555)

new feature: symop(pointGroupOperation, atom, pointGroupInfoObject) 
 -  where pointGroupOperation is of the form S6 or S6.1 or S6^3 or S6.1^3
    and ^n means nth power
    and .i means ith element of this type
 - return point result of operation of the point group operation on an atom
   - for example: print symop("C2.1", @3)
 - without atom, returns matrix
   - for example: print symop("C2.1")
 - without pointInfoGroupObject defaults to the point group of the current model, pointGroup()
        
new feature: pointgroup() returns pointGroupInfo object same as getProperty("pointgroupinfo")

bug fix: JmolTable.java example does not point to correct site
bug fix: CIFReader some first models 0 atoms

JmolVersion="14.31.60"
  also 15.1.60

fix for CIFReader not reading multi-model CIF files. 

JmolVersion="14.31.59"
  also 15.1.59
  
bug fix: CIFReader should allow unlooped items for all needed tags  
bug fix: JSpecView writer broken in 15.1.50 2021.08.10

JmolVersion="14.31.58"
  also 15.1.58
  
bug fix: adjustments to TopoCifParser pre-release of Topology.dic

JmolVersion="14.31.57"
  also 15.1.57
  
bug fix: magCIF can not handle fractions 2/5, 3/10, etc.

JmolVersion="14.31.56"
  also 15.1.56
  
bug fix: compare({2.1}, {1.1}, "map", "H") broken


JmolVersion="14.31.55"
  also 15.1.55

new feature: COMPARE {2.1} {1.1} BONDS SMILES HYDROGEN
 - adds HYDROGEN check for aligning methyl and methylene groups properly
 
bug fix: (-1.4567).format("%5.2f") missing minus sign  
bug fix: UnitCell transform should be included in COMPARE FRAME
bug fix: CifReader fix for lack of case sensitivity in some GEOM_* records for some COD and CCDC files
bug fix: FilesReader fails with zip file pipe
bug fix: Polyhedra SMILES not working for chirality check -- was never fully tested
bug fix: Resolver can fail for certain CIF files resolved to MOL incorrectly
bug fix: TopoCif update

new feature: COMPARE additions:

    // compare FRAMES
    // compare {model1} {model2} POLYHEDRA
    // compare {model1} {model2} SUBSET {polyhedra} POLYHEDRA    
    // compare {model1} {model2} ATOMS @atom1 @atom2 POLYHEDRA
    // compare FRAMES POLYHEDRA

new feature: compare() additions

        // A, B, int[] map
        // A, B, int[] map, stddev


JmolVersion="14.31.54"
  also 15.1.54
  
bug fix: TopoCifParser bugs

new feature: load "xxx" filter "TOPOL"
 -load _topol_* data
 -no symmetry applied
 -display net 1 by default
 
new feature: load "xxx" {1 1 1} filter "TOPOL"
 -load _topol_* data
 -display the {1 1 1} unit cell, with symmetry (this could be fill or packed, etc.)
 -display net 1 by default
  
new feature: load "xxx" {1 1 1} filter "TOPOLNet=2"  
 -load _topol_* data
 -display net.id==2 by default
 
new feature: load "xxx" {1 1 1} filter "TOPOLNet=Net_2"  
 -load _topol_* data
 -display net.label=='Net_2' by default


JmolVersion="14.31.53"
  also 15.1.53

bug fix: TopoCifParser bugs fixed
bug fix: {metal} included Xx
bug fix: symop() function not relating file-based operators  
bug fix: print symop(3,"xyzOriginal") does not show original (file-bsaed) symmetry operation 
new feature: symop(3, [1 1 0]) adds specified "cif2-style" translation to symmetry operation. 
new feature: symop(@1, @61, "cif2") returns the "cif2" format of this operation. 
    - developed for working with TopologyCIF data
	- <symop> [i j k]
	- For example:

	$ load =ams/quartz 1 packed
	$ print symop(@1,@3,"cif2")
	2 [0 0 0]
	3 [0 0 0]
	
	$ print symop(@1,@13,"cif2")
	2 [1 0 0]
	3 [1 0 0]

new feature: print symop(...."canonical")
new feature: print symop(n, [i j k], ...)
  $ print symop(3, [1 0 1])
  



JmolVersion="14.31.52"
  also 15.1.52

bug fix: JavaScript does not return to correct scrpt level after DELAY 

JmolVersion="14.31.51"
  also 15.1.51 (take 2)

new feature: ISOSURFACE DENSITY option
 - checks for cryo-EM data from EBI/EMDB and, if that exists, uses it; otherwise uses x-ray diffraction data
bug fix: problems with ISOSURFACE in 14.31.50
bug fix: EM isosurface not saved in state.
 
JmolVersion="14.31.50"
  also 15.1.50
  
bug fix: JSpecView upgrade for misc. JDXReader issues  
bug fix: Jmol file dropper not asking to resize (broken in 15.1.46/14.31.46)
bug fix: Jmol not reading EBI cryo-EM files from density server.
bug fix: Jmol not using EBI submap feature of density server for full-structure volumes

new feature: ISOSURFACE *.../full   
  - returns the FULL EBI volume data, not just one localized around a structure  

JmolVersion="14.31.49"
  also 15.1.49

bug fix: JSpecView not using ##FIRSTX for diff-dup x values after first.
bug fix: JSpecView version not showing

new feature: isosurface "*em"
 - same as *emdb, just simpler.

JmolVersion="14.31.48"
  also 15.1.48
  
  bug fix: JavaScript isosurface asynchronous file loader 
           failing to finalize, causing refresh in later-called 
           function to not return.

  bug fix: Filenames and directories with unicode accents not saved in ZIP, PNGJ, JMOL files.

  bug fix: Locally loaded JavaScript files not save in ZIP, PNGJ, JMOL

JmolVersion="14.31.47"
  also 15.1.47

new feature: isosurface "*emdb/nnnn"
 - retrieves the cryo-EM surface EMD-nnnn 
 - uses http://ftp.ebi.ac.uk/pub/databases/emdb/structures/EMD-%file/map/emd_%file.map.gz
   (https did not work in Java due to certificate issues)

new feature: isosurface "*emdb/=xxxx"
 - looks up the EMDB id for the cryo-EM surface associated with pdb id xxxx
 - first uses https://www.ebi.ac.uk/emdb/api/search/fitted_pdbs:%file?fl=emdb_id,map_contour_level_value&wt=csv 
 - then uses http://ftp.ebi.ac.uk/pub/databases/emdb/structures/EMD-%file/map/emd_%file.map.gz

new feature: isosurface "*emdb" (or "*emdb/" or "*emdb/=")
 - uses the current model's PDB ID with *emdb/=xxxx"
    
JmolVersion="14.31.46"
  also 15.1.46
  
bug fix: Drag-drop of PNGJ can fail due to SCRIPT command not accepting "spt::" type identifier
 
JmolVersion="14.31.45"
  also 15.1.45
 
bug fix: ModelKit changes for atomName and element not saved in state (since Jmol 14.28?)

JmolVersion="14.31.44"
  also 15.1.44

bug fix: Incorrect implementation of double value from string in JCAMP-DX format
bug fix: V3000 reader does not recognize 2D mol file setting
bug fix: 2D->3D can invert stereocenters having C-H bond. 

JmolVersion="14.31.43"
  also 15.1.43

new feature: hbondHDistanceMaximum maximum O--H distance in hydrogen bonds 
 - only in the case of actual hydrogen bonds, not pseudo-hydrogen bonds
 - hbondsDistanceMaximum now aliased to hbondNODistanceMaximum for clarity

JmolVersion="14.31.42"
  also 15.1.42
  
bug fix: GaussianReader fix for reading frequencies giving NullPointerException

bug fix: mmCIF reader was requiring optional auth_XXXX fields
  
bug fix: jspecview reading pimentoGCMS2.dx empty $$MODEL= causes NullPointerException

bug fix: better MMFF94 and UFF for 2D -> 3D  
new feature: adds MMFF2D and UFF2D forcefields that involve stronger
             fields for no-hydrogen (UFF2D) and added-hydrogen (MMFF2D) minimization
new feature: adds set testflag2 TRUE to stop FILTER "2D" after first stage, before UFF2D+MMFF2D minimization

JmolVersion="14.31.41"
  also 15.1.41
  
bug fix: (JSmol only - not SwingJS) ModelKit bond assignment fails due to old transpiler bug
 -- was failing to convert char to int and back properly
  
JmolVersion="14.31.40"
  also 15.1.40
  
bug fix: eval("JSON",json) fix to allow [...] or {...}
bug fix: ellipsoid ISO saved in state with wrong size

new feature: set checkCIR
 -- retrieves the NCI/CADD Chemical Identifier Resolver URL
 -- currently contacts chemapps.stolaf.edu/resolver
 -- places return JSON information into _.cirInfo (note that this is the model set auxiliary info, which is cleared with ZAP or LOAD)
	{
	  "host"  :  "cactus.nci.nih.gov"
	  "rfc6570Template"  :  "https://cactus.nci.nih.gov/chemical/structure{/identifier,representation}{?format,get3d}"
	  "source"  :  "https://chemapps.stolaf.edu/resolver/index.php"
	  "sourceVersion"  :  "0.0.1_2021.05.26b"
	  "status"  :  "unavailable"
	  "testURL"  :  "https://cactus.nci.nih.gov/chemical/structure/methane/smiles?src=jmol-chemapps-resolver"
	 }
 -- stores the global read-only variable _cirStatus as "OK" if successful or "unavailable" if not
 -- run automatically ONLY on the first call to NCR with load $....
 
new feature: Jmol's first load '$' or https://cactus.nci.nih/gov call does checkCIR  

new feature: Loading cactus.nic.nih/gov/chemical/structure file will resolve that name

JmolVersion="14.31.39"
  also 15.1.39

bug fix: GAMESS reader broken

JmolVersion="14.31.38"
  also 15.1.38

bug fix: TopoCIF 0.9.2 upgrade for _topol_node and _topol_net 
bug fix: JSpecView SVG export missing in menu and broken


JmolVersion="14.31.37"
  also 15.1.37

bug fix: removing default dependency for XmlUtils and PO

JmolVersion="14.31.36"
  also 15.1.36

bug fix: capture broken in 14.31.34

JmolVersion="14.31.35"
  also 15.1.35

adds GamessReader MOPAC parameters from F90 files provided by Jimmy Stewart for MO reading
 -- note that GAMESS uses only s and p orbitals for the MOPAC option
adds GamessReader MOPAC option 
 -- forces using MOPAC slaters rather than gaussian contraction when g.c. is present
adds MoldenReader [STO] ANGS and MOPAC options (zeta in 1/Angs; apply MOPAC scaling)

JmolVersion="14.31.34"
  also 15.1.34

bug fix: NBO type change not saved in state
bug fix: NBO auxiliary files (output.36, output.46, etc.) not saved in PNGJ,JMOL,ZIP files
  
JmolVersion="14.31.33"
  also 15.1.33
  
new feature: Allow replacement of PNG data in PNGJ
  
  x = load("toHenry2_pngj.png",true)
  y = load("bob.png")
  x._IMAGE_ = y._DATA
  write var x "toHenryFromBob.png" 
   

JmolVersion="14.31.32"
  also 15.1.32

bug fix: isosourface MOLECULAR and SASURFACE should never drop below 1.5/(probe radius)
bug fix: (second release) getProperty("isosurfaceData") broken

JmolVersion="14.31.31"
  also 15.1.31
  
bug fix: isosurface ... NCI ""  broken (in 14.5.2)
bug fix: plane definitions totally messed up in 14.31.26
  
JmolVersion="14.31.30"
  also 15.1.30
  
bug fix: load ? outside of function duplicates next commands
bug fix: (JS) Safari 14 not downloading files using DataURI

JmolVersion="14.31.29"
  also 15.1.29
  
bug fix: FileDropper does not recognize .txt file as possible script
  
JmolVersion="14.31.28"
  also 15.1.28
  

new feature: Jmol SMILES bond atropisomerism ^nm- and ^^nm-
 -- indicates atropisomerism (bond chirality in biaryl systems)
 -- ^ and ^^ for bonds similar to @ and and @@ for atoms
 -- n and m are single-digit bond selectors, generally one of 1, 2, or 3
 -- n = 1/2/3 means "reference atom is first/second/third connection
    to the atom on the left; m = 1/2/3 the same for the atom on the right. 
 -- ^- and ^^- same as ^22- and ^^22-, respectively
 -- example: 
   
   
   load $biphenol
   connect @2 @7 atropisomer
   print {*}.find("SMARTS","c1(O)cccc{c1^^-c2}ccccc2O")
   
   ({1 6})

  Here the "^^-" is short for "^^22- and refers to the two carbons with connected oxygen atoms: 
                                       
new feature:  mol1.find(mol2, "MAP" + flags, format)
 - creates a correlation map of atoms of mol1 to atoms of mol2
 - mol1 and mol2 are atom sets such as {1.1} and {1.2}
 - uses SMILES; Jmol SMILES directive flags such as "hydrogen" or "open" can be added
 - format indicates the format to use for the results
 	- can be "name", "index", "number" or any valid label, such as "%a %i"
 	- defaults to "number"
 - returns a map (associative array) containing keys:
    - smiles: the SMILES string used for the match
    - BS1 : atomset for mol1
    - BS2 : atomset for mol2
    - SMILEStoBS1 : array correlating SMILES atoms to BS1
    - SMILEStoBS2 : array correlating SMILES atoms to BS2
    - BS1toBS2  : array correlating BS1 to BS2 (indexes are for mol1; values are mol2)
	- MAP1to2 : array of [a,b] pairs, where a is format for mol1, b is format for mol2
    - key : format used in mapping
    
 - example:
 
	load files ":caffeine" "$caffeine"
	info =  {1.1}.find({2.1},"map", "name")
	print info.SMILES
	print info.key + ": " + info.MAP1to2.format("JSON")
	
	  O=C1c2c3N(C)C(=O)N1C.[n]2(C)c[n]3
	  
	  name: [ [ "O1","O14" ],[ "O2","O4" ],[ "N3","N5" ],[ "N4","N10" ],[ "N5","N1" ],
	  [ "N6","N8" ],[ "C7","C12" ],[ "C8","C7" ],[ "C9","C13" ],[ "C10","C3" ],
	  [ "C11","C9" ],[ "C12","C6" ],[ "C13","C11" ],[ "C14","C2" ] ]
	
	info =  {1.1}.find({2.1},"map hydrogen", "number")
	print info.SMILES
	print info.key + ": " + info.MAP1to2.format("JSON")
	
	/hydrogen/O=C1c2c3N4[C@@]([H])([H])[H].N51[C@@]([H])([H])[H].C54=O.[n]62[C@]([H])([H])[H].c6([H])[n]3
	
	number: [ [ 1,14 ],[ 2,4 ],[ 3,5 ],[ 4,10 ],[ 5,1 ],[ 6,8 ],[ 7,12 ],
	[ 8,7 ],[ 9,13 ],[ 10,3 ],[ 11,9 ],[ 12,6 ],[ 13,11 ],[ 14,2 ],[ 15,21 ],
	[ 16,18 ],[ 17,20 ],[ 18,19 ],[ 19,22 ],[ 20,23 ],[ 21,24 ],[ 22,15 ],[ 23,17 ],[ 24,16 ] ]	 

bug fix: x.label("%a %D") wrong value for %D

JmolVersion="14.31.27"
  also 15.1.27

bug fix: {*}.bonds.length not working

bug fix: array.find(n) should not do a string seach and return match.
 - return array of array indices, 1-based.
 - example: [11 3 1 2 1].find(1) == [3 5], not [1 3 5]
    
newly documented:

Polyhedra command allows for min and max radius
  -- polyhedra 2.8 3.0 @3 

setting DSSR on the fly:

   model 1 property dssr "1d66.dssr"   // file containing data
   model 1 property dssr @{load("1d66.dssr")} // actual data
   select iloops
   

4-order bond in MOL file using 14 for bond order
 -- Jmol extension for MOL file format to allow 4-bond
 -- example: [Re2Cl8](2-)
 -- see https://en.wikipedia.org/wiki/Quadruple_bond
 
5-order bond in MOL file using 15 for bond order
 -- Jmol extension for MOL file format to allow 5-bond
 -- example: [Mo2Cl8](4-)
 -- see https://en.wikipedia.org/wiki/Quintuple_bond 

6-order bond in MOL file using 16 for bond order
 -- Jmol extension for MOL file format to allow 6-bond
 -- example: Mo2
 -- see https://en.wikipedia.org/wiki/Sextuple_bond 


DRAW polygon @face @points 
 -- draws a filled polygon based on arrays of atom indices
 -- @face is an array of integers, not necessarily wound correctly
 -- @points is an atom bitset or an array of points (optional, defaults to {*}
 -- for example:

 	  load $p4
	  x = {*}.find("*1**1","map");
	  draw ID p4r polygon @{x[1]} color red
	  draw ID p4b polygon @{x[2]} color blue
	  draw ID p4y polygon @{x[3]} color yellow
	  draw ID p4g polygon @{x[4]} color green


DRAW polyhedron @faces @points
 -- draws sets of polygons based on arrays of atom indices
 -- @faces is an array of array of integers, not necessarily wound correctly
 -- @points is an atom bitset or an array of points (optional, defaults to {*}
 -- for example:

  	  load $caffeine
	  draw polyhedron @{{*}.find("*1****1||*1*****1","map")}

 	  load $p4
	  draw ID p polyhedron @{{*}.find("*1**1","map")} color red

POLYHEDRON ID xxx @faces @points
 -- @faces is an array of array of integers, not necessarily wound correctly
 -- @points is an atom bitset or an array of points (optional, defaults to {*}

  	  load $p4
	  polyhedra ID p4 @{{*}.find("*1**1","map")}
  
array.format(headings) Transform an array of arrays into an array of associative arrays based on "column" headings, and vice-versa. For example, if y = [[1,2],[3,4]], then <b>z = y.format(["a","b"])</b> will set z to [ {{ "a": 1,"b": 2 }},{{ "a": 3, "b": 4 }} ]. And, in reverse, <b>z.format(["a","b"])</b> will be back to [[1,2],[3,4]]
array.format("JSON") Formats a serial or associative array as JSON.
array.format("%5.3f\t%5s") Formats an array or array of arrays into a multiline string using sprintf format. 

arrayOfArrays.col(n) selects out the nth column from an array of arrays. 
                     For example, retrieving the third column from CSV data: 
                     col3 = load("data.csv").split("",true).col(3).
  
SHOW CHEMICAL  -- fully described NIH/CADD options

SHOW xxxx /yyyy  Adding "/xxxx" to the command, such as SHOW file/cell will filter 
                 the output only to lines containing the text after the slash character.

Jmol PolySMILES -- described

JmolSQL -- more description; adds WHEREIN; replaces older ** notation

load HISTORY "saved.his"  -- loads command history with script in saved.his
  
frame align [modelNo] [pt]  -- FIXED is assumed; used in state; shifts a model by a specific amount after removing any current frame alignment

x.dot(y) for point.dot(plane)

CIF 2.0 file reader added

set zshadePower 0  -- allows examination of depth buffer and writing to image for external processing
   
Windows BMP image reading -- reads 24-bit (full color) as well as 16-, 8-, 4-, 2-, and 1-bit color palette modes
                          -- 14-byte and 40-byte headers only; does not read compressed modes

Write and data({atomset},type) expanded to: CIF|CML|CFI|MOL|PDB|PQR|SDF|CD (ChemDoodle)|JSON|QCJSON|V2000|V3000|XYZ|XYZRN|XYZVIB

x.find("SMILES","top")  -- creates a topology SMILES, involving just * and connections; does not include stereochemistry;
                        -- allows comparison of connection patterns without respect to any other consideration.
                        -- can be used to check equivalences in inorganic crystal structures.
						-- example: load $caffeine;$ print {*}.find("SMILES","top") =>  *1(*)*(*)*2*3*(*)*1*.*2(*)**3

load "" fill UNITCELL PRIMITIVE     (for files that are conventional)
load "" fill UNITCELL CONVENTIONAL  (for VASP files, which are primitive cells)

polyhedra WIGNER      // Wigner-Seitz cell
polyhedra BRILLOUIN   // 1st Brillouin zone
polyhedra BRILLOUIN 1 // 1st Brillouin zone
polyhedra BRILLOUIN 2 // 2nd Brillouin zone
polyhedra BRILLOUIN -1 // Wigner-Seitz cell
polyhedra scale 3.0 BRILLOUIN 1  // scaled 1st Brillouin zone

POLYHEDRA edgesOnly    -- shows just edges; operates on ALL polyhedra, not just selected; complements edges, noEdges, frontEdges

select within(d, $p1) where $p1 is a polyhedron ID
  -- d = 0 is "on or within the polyhedron"
  -- d < 0 is "-d angstroms within polyhedron"
  -- d > 0 is "within d angstroms of polyhedron"

LOAD will read BZ2-compressed files

WRITE "SDF" implements atom value V  nnn ... information
 -- requires assigning the data property name "atom_values" in the model's molData property
 -- for example:
 
  $ load $2,3-dichlorobutane
  $ molData = {"atom_values":"chirality"}
  $ model properties "molData" molData
  $ write dcb.sdf

 -- note that if the model already has a molData property, then use the following to append to it:
 
  $ molData = (_M.molData ? _M.molData : {})
  $ molData.atom_values = "chirality"
  $ model properties "molData" molData

x = load("filename","JSON") -- loads JSON data into variable
 
{atom}.chirality -- uses Cahn-Ingold-Prelog rules to assign R or S to a carbon center
                 -- ignores sulfur and nitrogen chirality, generally

{atom}.cipRule   -- CIP sequence rule deciding this center; one of 1a, 1b, 2, 3, 4a, 4b, 4c, 5, or blank

load =chebi/nnnnnn -- chEBI 2D molecule load, with minimal 100-step minimization
  
set debugHigh   -- same as set loglevel 6 - debugging only

x.split(true) -- does a white-space token split of the string value of x

CALCULATE CHIRALITY {atom set}  -- optionally limited to the given atom set (or the currently selected atoms by default)

set jmolInJSpecView  -- allows Jmol window to NOT be embedded in JSpecView when JSpecView is opened in Jmol; default TRUE

WRITE ISOSURFACE "t.pmesh"; WRITE ISOSURFACE "t.pmb"
  -- creates ASCII (.pmesh) or binary (.pmb) file (a Jmol-specific file format)
  -- relatively compact format
  -- can speed up loading of meshes and contours
  -- for filled surfaces, use .jvxl instead
  -- read back into Jmol using ISOSURFACE "t.pmesh"/"t.pmb"
  -- note that binary files are NOT RECOMMENDED for JSmol because some platforms cannot read them locally
  -- example:
  
  load $methane
  isosurface plane {0 0 0 1} map vdw contours 20
  write ISOSURFACE contour.pmb
  isosurface contour.pmb
  
set labelfor {atomset} "value"
 -- allows setting of label without changing current selection
 -- uses same syntax as LABEL command after {atomset}
 -- for example:
 
   set labelfor @atoms @myLabel
   set labelfor {atomno <= 3} @{["a","b","c"]}
   set labelfor {_C && chirality != ""} "%[atomname] %[chirality]"

color NUCLEIC  -- for nucleic only (others will be grey) -- based on DSSR nucleic color scheme: G green, C yellow, A red, T blue, U cyan

set cartoonBlocks; set cartoonBlockHeight x.x -- for nucleic only -- uses DSSR data if present (using calculate structure DSSR or load =xxxx/dssr)
 -- displays a DSSR block for each base based on dssr.nts.frame -- x.x is height of box in Angstroms (default 0.5)

color property DSSR type
 -- where type is one of: 
	bulges
	coaxStacks
	hairpins
	hbonds
	helicies
	iloops
	isoCanonPairs
	junctions
	kissingLoops
	multiplets
	nonStack
	nts
	pairs
	ssSegments
	stacks
	stems
 -- color is based on index into the list of the given structures
 -- 0 (not of that structure), 1 (first entry), 2 (second entry), etc.
 -- for example:
    
		    load =4fe5/dssr
		    cartoons only;set cartoonSteps;
		    color property dssr junctions

x = {*}.find(smartsString,"map") -- returns an array of arrays of atom indices (0-based)
 -- indicates exact correlation between atoms in {*} and atoms of smartsString
 -- only unique sets of atoms are found, not every possibility
 -- for example:

	load $caffeine
	s = show("smiles") // N1(C)C(=O)c2c3N(C)C1=O.[n]2(C)c[n]3
	print {*}.find(s,"map").format("JSON")
	[ [ 0,1,12,13,11,6,4,5,2,3,9,10,8,7 ] ]
	
	load :caffeine
	print {*}.find(s,"map").format("JSON")
	[ [ 4,13,8,0,6,7,2,11,9,1,3,12,10,5 ] ]


MACRO bz; createWS("p1")    (still not documented)
  -- creates a Wigner-Seitz cell as polygon id "p1"
  -- requires current unit cell to be primitive to work correctly
  -- polyhedron can be shifted using POLYHEDRA OFFSET
  -- default ID "pbz1_1_" for just CREATEWS()


POLYHEDRA UNITCELL
 -- creates a polyhedron (12-gon in this case) around each of the
    currerntly selected atoms that has that bonding environment
 -- DOES NOT require atoms at these positions - can simply use the 
    unit cell and periodicity to find the relevant atom positions. 
 -- will check bonding as necessary using autobonding parameters 
 -- accepts all standard polyhedra options. For example:
 
    polyhedra 12,16 3.5 UNITCELL
    
array.getProperty("xxxx") -- same as getproperty(array, "xxxx")
  -- drills down into an array of associative arrays to get sublist
  -- can be used with [SELECT ... WHERE]
   
SELECT x  where x is an array of integers or array of array of integers

connect NBO <nbotype>
    - connect atoms in the currently visible model using a resonance structure configuration found in an NBO .46 or .nbo file
	- where <nbotype> is one of alpha|beta|46|46a|46b|nrtstr_n|nrtstra_n|rs_n|rsa_n|rsb_n

label %[nbo];
    - label an atom using a resonance structure configuration found in an NBO .46 or .nbo file
    - requires a previous connect NBO

set nboCharges (default true)
  - determines whether formal charges are also displayed with LABEL %[nbo]

CONNECT for quintuple and sextuple bonds.
  -- connect @1 @2 quintuple
  -- connect @1 @2 sextuple
  -- readily saved in state
  -- saving in MOL file as bond type 15 and 16 

set labelOffset [mode sx sy sz ax ay az]    
   set labelOffset [sx, sy, sz]
   set labelOffset [mode, sx, sy, sz, ax, ay, az]
   
 where
   
   sx,sy,sz are screen coord offsets 
    -- applied after view rotation
    -- sy > 0 LOWERS label
   ax,ay,az are xyz position (in Angstroms; applied before view rotation)
   mode == 0 indicates xyz position is absolute and sx sy sz are Angstroms
   mode == 1 indicates xyz position is relative to atom position and sx sy sz are Angstroms
   mode == 2 indicates xyz is absolute, and sx sy sz positions are screen pixels
   mode == 3 indicates xyz is relative, and sx sy sz positions are screen pixels
   defaults: mode == 1; ax = ay = az = 0

getProperty("cifInfo", "c:/temp/test.cif")
 -- reads CIF file data in structured format
 -- automatically uses CIF 1.0 or CIF 2.0, as needed.
 -- if file name is missing, uses current model file
 

load AUDIO audiofilename
 -- JavaScript can read WAV, MP3, and OGG files
 -- application can read WAV files
 
polyhedra AUTO ...
  -- sets polyhedron radius automatically, using "MAXIMUM GAP" rule
  -- see Zur Abgrenzung der KoordinationssphÃ¤re und Ermittlung der Koordinationszahl in Kristallstrukturen
         G. O. Brunner, D. Schwarzenbach, Zeitschrift fur Kristallographie - Crystalline Materials, 1971, vol 133, issues 1-6 127-133
         http://www.degruyter.com/view/j/zkri.1971.133.issue-1-6/zkri.1971.133.16.127/zkri.1971.133.16.127.xml?rskey=sfBNTx&result=1
 
polyhedron -x.x ....
 -- sets maximum radius for gap calculation to be x.x

print @1.label("%[unitid]")
  -- generates unit IDs for atoms or residues
  -- unit IDs are a proposed general standard for representing atoms and residues in biomolecules
  -- see http://rna.bgsu.edu/main/rna-3d-hub-help/unit-ids
  -- options follow "-":
  
  $ print {atomno=3}.label("%[unitid]")     // includes residue and atom
  |1|A|G|1|OP1|||
	
  $ print {atomno=3}.label("%[unitid-r]")   // residue only
  |1|A|G|1||||
	
  $ print {atomno=3}.label("%[unitid-mr]")  // adds model id
  1EHZ|1|A|G|1||||
	
  $ print {atomno=3}.label("%[unitid-mra]") // full unitID
  1EHZ|1|A|G|1|OP1|||

  $ print {atomno=3}.label("%[unitid-mrat]") // full unitID, right-trimmed
  1EHZ|1|A|G|1|OP1
 
  -- Note that the full 8-line unit ID is produced under all circumstances. 
     This is  important, because string-matching of unit ids will not work 
     without all fields completed. For example:
     
     |1|A|G|1
     
     would match
     
     |1|A|G|11
     
     without the closing "|". Likewise, 
     
     |1|A|G|11
     
     is not a match for the insertion residue
     
     |1|A|G|11|||3|
     
  -- [Editorial note: I agree that it was ill-advised to put the insertion
      code at the end. This makes it impossible to efficiently match 
      residues in full-atom unit IDs.]
      
  -- Note that in an actual atom label, one needs to add "\n" at the end
     and have the label in quotes in order to avoid having "|" mean "new line"
     
    label "%[unitid]\n"   
  
  not just
  
    label %[unitid]
  
  This is a consequence of having defined "|" as new line early on in Jmol
  development. 

select within("1ehz|1|A|G|45||||")
print within("1ehz|1|A|G|45||||")
  -- unit IDs
  -- see http://rna.bgsu.edu/main/rna-3d-hub-help/unit-ids
  -- used for annotations, validations, dssr, and rna-3d processing
  -- pdbid|model|chain|RESNAME|resno|ATOMNAME|altcode|inscode|symmetry
  -- can truncate trailing (but not leading) pipe symbols
    1ehz|1|A|G|15, |1|A|G|15|C2
  -- requires at minimum a model number, chain, and residue number
    |1|A||15
  -- ATOMNAME blank indicates full residue, with altcode indicating "this alt_id or no alt_id" (a configuration)
  -- ATOMNAME nonblank indicates one atom, with altcode indicating "exactly this alt_id" (a location)
  -- can be multiple, white space, comma, "]", "[", and double quote ignored
    1ehz|1|A|G|15||||,1ehz|1|A|U|59||||,1ehz|1|A|C|60|||
    
select shortcuts for nucleic acid structures
  -- for example: select junctions; select kissingloops
  -- activated after load =xxxx/dssr or calculate structure dssr
  -- includes:
    "@bulges within(dssr,'bulges')",
    "@coaxStacks within(dssr,'coaxStacks')",
    "@hairpins within(dssr,'hairpins')",
    "@hbonds within(dssr,'hbonds')",
    "@helices within(dssr,'helices')",
    "@iloops within(dssr,'iloops')",
    "@isoCanonPairs within(dssr,'isoCanonPairs')",
    "@junctions within(dssr,'junctions')",
    "@kissingLoops within(dssr,'kissingLoops')",
    "@multiplets within(dssr,'multiplets')",
    "@nonStack within(dssr,'nonStack')",
    "@nts within(dssr,'nts')",
    "@naChains within(dssr,'naChains')",
    "@pairs within(dssr,'pairs')",
    "@ssSegments within(dssr,'ssSegments')",
    "@stacks within(dssr,'stacks')",
    "@stems within(dssr,'stems')",

 
mapOfMaps.array(k)
 -- generates an array of maps from a map of maps by 
    storing all top-level map keys under key k in lower-level map
 -- reversed by another .array(k) 
 -- causes a script exception if mapOfMaps is not a map of maps

arrayOfMaps.array(k)
 -- generates a map of maps from an array of maps by 
    removing each map's key k and using that as the key for that map value 
 -- reversed by another .array(k) 
 -- causes a script exception if arrayOfMaps is not an array of maps or key k is not present in all maps

Jmol SMILES/SMARTS generic polySMILES polyhedron option @PHn
 -- does a SMILES search for the local coordination environment around a center.
 -- particularly valuable for inorganic compounds and metallic or intermetallic network crystal structures 

write CIF (only minimal)


@1.find("crystalClass", pt)
  -- generates a list of points based on a model's crystal class (point group)
  -- uses @1 just to find the unit cell and space group
  -- optional pt is used as a generator (defaults to @1)
  -- example:
   load =ams/calcite 1
   x = @3.find("crystalClass")
   print pointgroup(x).name
   draw points @x
   polyhedra ID p {0 0 0} to @x


pointgroup("spacegroup", @1)
 -- analyzes the point group (crystal class) of a crystal. 
 -- uses three irrational-coordinate points to generate all possible operators
 -- creates a map with keys (somewhat variable depending upon axes present):
 
	C2
	C3
	Ci
	Cs
	S6
	detail
	distanceTolerance
	linearTolerance
	nAtoms
	nC2
	nC3
	nCi
	nCn
	nCs
	nS6
	nSn
	nTotal
	name
	points
	principalAxis
    
    
      
x = pointgroup([array of points],center)
  -- center is optional, defaulting to average of the points
  -- returns a map:
    pts = [ {-1.0132 0.585 0.0012999999},{1.0132 0.585 0.0012999999},{0.0 -1.17 0.0012999999} ]  
    print pointgroup(pts,{0 0 0})
	{
	  "C2"  :
	  [
	    {0.8660127 -0.50001717 0.0022222984}
	    {-0.8660127 -0.50001717 0.0022222984}
	    {0.0 0.99999756 0.002222217}
	  ]
	  "C3"  :
	  [
	    {0.0019245904 -0.0011111083 -0.99999756}
	  ]
	  "Cs"  :
	  [
	    {0.0019245904 -0.0011111085 -0.99999756}
	    {-0.49998164 -0.866036 0.0}
	    {0.49998164 -0.866036 0.0}
	    {1.0 0.0 0.0}
	  ]
	  "S3"  :
	  [
	    {0.0019245904 -0.0011111083 -0.99999756}
	  ]
	  "center"  :  {0.0 0.0 0.0}
	  "detail"  :  "# 3 atoms;"
	  "distanceTolerance"  :  0.2
	  "linearTolerance"  :  8.0
	  "nAtoms"  :  3
	  "nC2"  :  3
	  "nC3"  :  1
	  "nCi"  :  0
	  "nCn"  :  4
	  "nCs"  :  4
	  "nS3"  :  1
	  "nSn"  :  1
	  "nTotal"  :  12
	  "name"  :  "D3h"
	  "principalAxis"  :  {0.0019245904 -0.0011111083 -0.99999756}
	  "principalPlane"  :  {0.0019245904 -0.0011111085 -0.99999756}
	} 


calculate symmetry  polyhedra {atomset}
  -- selectively calculates polyhedra.
  -- for example: calculate symmetry polyhedra {polyhedra(4)}
  
calculate symmetry  polyhedra id
  -- selectively calculates polyhedra for a given ID.
  -- for example: calculate symmetry polyhedra "poly1"
  

_hoverLabel  
   -- reports general hover label set by hover command
   
_hoverEnabled
  -- reports if hover is enabled or not
  
 /invertStereo/ flag for SMARTS search
  -- allows quick check for enantiomers
  -- example: select search("/invertStereo/C[C@H](Br)CC") will match (R)-2-bromobutane
              even though it is for (S)-2-bromobutane
                 
{*}.find("SMILES/open")
 -- generates OpenSMILES string for selected atoms
 -- applies OpenSMILES aromaticity rules for 5-, 6-, and 7-membered rings
 -- not chemical -- allows exocyclic c=C bonds and [nH] in 6-membered rings 
 -- also adds atom class if property_atomClass is nonzero
 -- for example:
 
	$ load $2-butanol
	$ @2.property_atomclass=2
	$ @3.property_atomclass=3
	$ @5.property_atomclass=5
	$ print {*}.find("smiles/open")
	
		C[C@H:2]([OH:5])[CH2:3]C

set window width height
set window [width height]
set window "xxx.png"

   
point(unitcell, {i, j, k})
  -- returns the Cartesian point corresponding to a specific coordinate in a unit cell system.
  -- unitcell is an array of the form [origin, va, vb, vc]
  -- {i j k} is a point in the unit cell
  -- for general use -- does not require actual setting of the model's unit cell

UNITCELL TRANSFORM @m4x4
  -- direct 4x4 matrix transformation of a unit cell

unitcell("a=...,b=...,c=...,alpha=...,beta=...,gamma=....")
 - array of center and three vectors
 - example:
 $ print unitcell("a=10,b=10,c=20,alpha=90,beta=90,gamma=129")
{0.0 0.0 0.0}
{10.0 0.0 0.0}
{-6.293203 7.7714605 0.0}
{-8.742278E-7 -1.8328565E-6 20.0}

load ... unitcell "a=...,b=...,c=...,alpha=...,beta=...,gamma=...."

unitcell "a=...,b=...,c=...,alpha=...,beta=...,gamma=...."
  -- only the numbers are read; everything else is ignored, so order is important here
  -- uses the format created by show unitcell/a

unitcell RECIPROCAL 2  
  -- as integer, multiples of pi
  
unitcell reciprocal x.x
  -- allows scaling of reciprocal cell, similar to unitcell("reciprocal", x.x)

expanded unitcell() function
 -- adds additional types: "A", "B", "C", "I", "F"
 -- default is the lattice type of the model's space group
 -- not just cubic; "BCC" is converted to "I"
 -- for example:
 
	 load =ams/silicon 15 packed   // Cmca
	 draw id "uc" diameter 0.1 unitcell mesh nofill color black
	 unitcell @{unitcell("primitive")}
	 color unitcell red
	 unitcell 0.1
	 axes unitcell
	 axes on


calculate hydrogens TRUE
 -- calculates hydrogens and multiple bonding
 -- same as 
 
    calculate hydrogens
    connect aromatic modify
    calculate aromatic
    
 -- similar to, but not identical to set pdbAddHydrogens
 -- allows reasonable addition of multiple bonds to proteins after loading

 


JmolVersion="14.31.26"
  also 15.1.26

new feature: $isosurface.getProperty("values"), $isosurface.getProperty("vertices") corrected for invalid vertices

bug fix: getProperty("isosurfaceData.vertices") returning too many vertices
 - retrieves only the vertices that are on the surface, not excluded vertices
 - retrieves only vertices for selected sets if using SET or SUBSET
 - works best with ISOSURFACE sasurface (much faster than SOLVENT or MOLECULAR)
 - can be used with ISOSURFACE solvent or ISOSURFACE molecular 
   with careful adjustment of solvent probe diameter (1.2 recommended, not 1.4)
   and RESOLUTION 
 - with 1.4, there is a tendency to get interior artifacts
 - note that this function will return "null" if there is no isosurface or if
   no single isosurface is selected (by issuing ISOSURFACE ID xxx ON, for instance)

new feature: getProperty("isosurfaceData.allVertices")
 - returns all vertices, even those excluded as interior artifacts or from unselected sets

load =6nef
isosurface sasurface
x=$isosurface1.getproperty("vertices")
{*}.property_d = {*}.distance.min(x)
color property_d
slab 50; slab on
draw points @x  // to visualize the surface points themselves

bug fix: Cif2Reader should accept UTF-8 signature "BOM" of three bytes 0xEF 0xBB 0xBF (not 0xFEFF)

JmolVersion="14.31.25"
  also 15.1.25

bug fix: isosurface set 1   showing 2nd largest, should show largest
bug fix: save state for isosurface with one set off by one
bug fix: getProperty("isosurfaceData") fails for pocket cavities 

JmolVersion="14.31.24"
  also 15.1.24

note: isosurface #sets is from print getProperty("shapeInfo.Isosurface[1].volume").length
bug fix: isosurface set 0   not working
bug fix: calculate surfacedistance fails -- wrong parameter in Java method call  
bug fix: MoldenReader requires [MO] to be last tag  
bug fix: MoldenReader should not report energy units (not always eV) 
bug fix: DnD script into script console should run that script. 
bug fix: AboutDialog using old splash image
  
JmolVersion="14.31.23"
  also 15.1.23
  
bug fix: STL and hermite display missing last two residues of trace

JmolVersion="14.31.22"
  also 15.1.22
  
new feature: isosurface subset [1 3 5] cavity vdw
 - allows more than one set to be displayed
 
new feature: isosurface cavity 1.2 50 vdw
 - increases maximum envelope radius from 10 to 50 
 - note that large envelope radii can produce artifacts for pocket cavities
 - for example:

  load =1wp1  filter "biomolecule 1"
  isosurface set 1 select {protein} only pocket cavity 3 20
  isosurface slab none slab plane x=0

JmolVersion="14.31.21"
  also 15.1.21

new feature: InChIKey generation:
       load $morphine; print {*}.find("inchi", "key");
   - can be combined with any other valid inchi flag:
       load $morphine;print {*}.find("inchi","srel key");
       
new feature: {*}.inchi(options) same as {*}.find("inchi",options);
	   load $morphine; print {*}.inchi("key");
	         
new feature: InChI or InChIKey from SMILES using .inchi():
   print "CCCC".inchi()  // uses load("$CCCC")
   print "CCCC".inchi("key")

new feature: InChI or InChIKey from NCI or PubChem shortcut using .inchi():
   print "$caffeine".inchi(); 
   print "$CCCC".inchi(); 
   print ":caffeine".inchi("key"); 
   print ":smiles:CCCC".inchi();

new feature: InChI or InChIKey from any MOL file data source using .inchi():
   print load("foo.mol").inchi("key"); 

new feature: InChIKey from InChI:

	$ x = ":morphine".inchi()
	$ print x
	InChI=1S/C17H19NO3/c1-18-7-6-17-10-3-5-13(20)16(17)21-15-12(19)4-2-9(14(15)17)8-11(10)18/h2-5,10-11,13,16,19-20H,6-8H2,1H3/t10-,11+,13-,16-,17-/m0/s1
	$ print x.inchi("key")
	BQJCRHHNABKAKU-KBQPJGBKSA-N


   
bug: "xxx".find("sequence") assumes xxx is a set of one-character residue IDs

new feature: adds "xxx".find("sequence",true)  
 - case-sensitive text search

new feature: adds "xxx".find("sequence",false)  
 - case-insensitive text search

 
JmolVersion="14.31.20"
  also 15.1.20
  
bug fix: GamessReader should read ENERGY, MP2, CSDD, and CSDD(T) energy types (Mark Perri)
 - adds _M.EnergyType
 
bug fix: VaspOutcarReader upgrade for Vasp6

new feature: initialize INCHI
   - for JavaScript specifically, loads the inchi-wasm module asynchronously. 
   - allows the very first call to {*}.find("inchi") to be active.
   - note that a very first call to Jmol.evaluateVar(applet,"{*}.find('inchi')") will still fail.
    
new feature: {*}.find("inchi")
new feature: {*}.find("inchi",flags)
   - generates InChIs from modelset atoms
   - integrates jni-inchi-0.7-jar-with-dependencies.jar
   - uses inchi-wasm for JavaScript (R.Apodaca https://github.com/rapodaca/inchi-wasm)
   - flags include (https://www.inchi-trust.org/technical-faq-2):
        perception flags: DoNotAddH SNon NEWPSOFF
        stereo flags: SRel SRac SUCF
        more flags: NEWPSOFF SUU SLUUD RecMet FixedH KET 15T
        java-only flags: key outputsdf (Java only; still no InChIKey for JavaScript)
   - JavaScript is InChI 1.05; Java is still 1.03
   - note: JavaScript-only directories _WASM and _ES6 should not be processed by Google Closure Compiler   
 
JmolVersion="14.31.19"
  -- was released as an overwrite of 14.31.18 :(
    
JmolVersion="14.31.18"
 also 15.1.18
 
  bug fix: MacSpartan Release 1.0.3 (ancient!) skips orientation and orbitals
  bug fix: SHOW SPACEGROUP fails for nonstandard space group (=ams/quartz)

  
  new feature: Topology CIF (TopoCifParser.java) reading of _topol_xxx records
          topoCIF filter "topos_type=x" where x is v, vw, hb, or some concatentation of those using "+"
          topoCIF filter "topos_ignore" skips reading of _topol records, reading as standard CIF

  undocumented: set hiddenLinesDashed (14.8.0)   
  

JmolVersion="14.31.17"
  also 15.1.17

  bug fix: print 2 > 1.0 gives false. typo introduced 2020.10.02 causes int[>,<,>=,<=] float to fail 
  bug fix: minimizer step reports should be in user units, not native
  bug fix: minimizer initial/final reports should state "/mol" for units

JmolVersion="14.31.16"
  also 15.1.16

  new feature: (undocumented) now("message")   
  new feature: now("message","format")

  bug fix: print load("t.tar") should act as load("t.tar|.") to give directory  
  bug fix: MO linear combination should not show type in info
  bug fix: MO squared should show ^2 in info
  
// there is no 14.31.15

JmolVersion="14.31.14"
  also 15.1.15
  
new feature: TAR file reader with zip-like entry loading
  load "t.tar|guest/77317/output.log"
  
new feature: GenNBOReader supports older NBO 3.0 output.properties rather than missing .46 labels file
new feature: NBO command expanded to allow named orbitals
   NBO "C1-C2"
   NBO TYPE PNBO "C1-C2"
   
JmolVersion="14.31.13"
  also 15.1.14
  
bug fix: MoldenReader fails to read [5F] if that record is after the [MO] block.  
bug fix: GenNBOReader does not accept spherical s, p designations: 151 152 153 (wh6-a.31)

JmolVersion="14.31.12"
 also 15.1.14

bug fix: minimization constraint broken in 14.29.45

JmolVersion="14.31.11"
 also 15.1.13
 
bug fix: adds fix in script compiler for nonbreaking 
         space nbsp; \u00a0 from clipping browser text

JmolVersion="14.31.10"
  also 15.1.12

bug fix: dots -1.0 does not imply ONLY

JmolVersion="14.31.9"
  also 15.1.11

bug fix: set pdbaddhydrogens does not work with PDB files that have some H atoms (but no multiple bonds)
bug fix: MOVETO quaternion   jumps (seconds=0) if crude check for change fails

JmolVersion="14.31.8"
  also 15.1.10

new feature: point(["{1,2,3}","{2,3,4}",....])
bug fix: large integer number != operator failure
bug fix: fuxyz vs. fxyz and uxyz
distribution: JSpecview not built in 14.31.5

JmolVersion="14.31.7"
  also 15.1.9
  
bug fix: PSE file saved to PNGJ may not fully reload (missing surface, for example)
bug fix: atom.occupancy of 0.01 saved as 0.0

JmolVersion="14.31.6"
  also 15.1.8
bug fix: msCIF reader not reading ICDD Fourier modulated file.
  
JmolVersion="14.31.5"

bug fix: https for NMRDB
bug fix: JSpecview applies ##SHIFTREFERENCE as HZ for data in PPM
bug fix: JSpecview must ignore ##SHIFTREFERENCE for JEOL, at least for $$ JEOL NMR v1.10

JmolVersion="14.31.4"

bug fix: print format("%0.-3s", "testing")   "-" does nothing

new feature: isosurface S1 VAL [points or atoms] SELECT....
  - calculates isosurface values for a set of points or atoms
  - values are created during surface constructions, not after
  - for solvent and molecular surfaces, negative value is "inside"; positive is "outside"
  - surfaces that are not calculated will give 0 for all values

new feature: $s1.getProperty("values");
  - retrieves the array of values produced by isosurface s1 VAL 
  - example:
  
		  load $caffeine
		  isosurface s1 value {*} select {!_H} only vdw 50% translucent
		  {*}.property_d  = $s1.getproperty("value")
		  color property_d

bug fix: NWChem reader does not ignore file-save data block properly
bug fix: get property fileInfo initially or after ZAP throws exception
bug fix: isosurface map colorscheme "rwb" fails, whereas color isosurface "rwb" works 

JmolVersion="14.31.3"

bug fix: Jmol app does not allow width smaller than about 350 pixels

JmolVersion="14.31.2"

bug fix: draw pointgroup C2 3   draws all C2 axes, not just the third

JmolVersion="14.31.1"

bug fix: SYNC/sockets should not automatically subscribe to CLICK (which includes drag events)
bug fix: "WRITE IMAGE width height" (with no file name) causes array out of bounds exception
bug fix: SYNC command sending not working with raw JSON or Jmol associative arrays

JmolVersion="14.31.0"

new feature: Switch to Java 7, allowing for string-based switch and Files.readAllBytes().

bug fix: ellipsoids "csa" scale 0.5 on   does not scale
bug fix: implicit refresh required after translateSelected

new feature: Gaussian reader reads NMR shielding tensors as "csa" 
for example:

	load EtOH-nmr.out
	frame 2;
	wireframe only
	ellipsoids set "csa" scale 0.5
	ellipsoids on

new feature: Gaussian reader reads NMR_J_coupling data
new feature: atom properties can be float[][] arrays 
 -- for atom-atom values
new feature: MEASUREMENT property_xxx   
 -- for 2D float[][] properties
new feature: MEASUREMENT VALUE x.x      
 -- sets a fixed value for a standard measurement 
new feature: measurement unit "+xxx" means abs(value)
 -- specifically, "+hz" useful for calculation data
new feature: measurement "+hz" units automatically use property_J values
new feature: MEASUREMENT "<unit>" where <unit> is valid measurement unit
new feature: measure() allows "property_xxx"
new feature: measure() allows "<unit>"
for example:

load EtOH-nmr.out
frame 2;
print @@3.property_J.format("JSON")

 >> [ [ 0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,-5.8511596,132.96,0.0,-2.16701,3.6352599,1.4761999,1.5346,-0.042426,-11.6895 ] ]
 
print measure(@@2, {model=2}, "property_J", "").format("JSON")

 >> [ 124.307,0.0,132.96,119.271,9.69322,0.75008297,4.29308,-6.40836,115.875 ]


measure @@2 @@3 "+hz"  // "+hz" for absolute value and indicates we want to use this property

measure @@2 @@3 property_J "hz"

print measure(@@2, @@3, "property_J", "hz")

 >> property_J 	133.0 	"133.0 hz" 	C2/2 #2 	H3/2 #3

print measure(@@2, @@8, "property_J", "+hz")

 >> property_J 	6.4 	"6.4 hz" 	C2/2 #2 	O8/2 #8
 

new feature: SYNC sockets completely rewritten, allowing for substantially more 
             feedback and simpler JSON-based interface. Many features of the
             Molecular Playground now implemented in Jmol itself. Features include:
              - simplification of sockets, allowing for just one that is use for
                input and outoput
              - default short-message callbacks for all significant callbacks
              - added set XxxxCallback SYNC:ON and SYNC:OFF for subscribing to 
                full callback Object[] data information. 
              - better JSON creation/parsing
              - simpler class structure
              - allows Molecular Playground-like gestures to be socket-defined.
             
             This from org.openscience.jmol.appl.jsonkiosk.JsonNioService:
             
/**
 * A class for interacting with Jmol over local sockets.
 * 
 * See also org.molecularplayground.MPJmolApp.java for how this works.
 * Note that this service does not require MPJmolApp -- it is a package
 * in the standard Jmol app. 
 * 
 * Listens over a port on the local host for instructions on what to display.
 * Instructions come in over the port as JSON strings.
 * 
 * This class uses the Naga asynchronous socket network I/O package (NIO), the
 * JSON.org JSON package and Jmol.
 * 
 * http://code.google.com/p/naga/
 * 
 * Initial versions of this code, including the JSON-base protocol were created
 * by Adam Williams, U-Mass Amherst see http://MolecularPlayground.org and
 * org.openscience.jmol.molecularplayground.MPJmolApp.java
 * 
 * <code>
 * 
 * Sequence of events:
 * 
 * 1) Jmol initiates server listening on a port using the JmolScript 
 *    command with an arbitrary negative port number.
 *    (-30000 used here just for an example):
 * 
 *    sync -30000
 * 
 * This can be done also through the command line using
 * 
 *    jmol -P -30000
 * 
 * or 
 * 
 *    jmol --port -30000
 * 
 * Jmol will respond to System.out:
 * 
 *    JsonNioServerThread-JmolNioServer JsonNioServerSocket on 30000
 *    
 * 
 * 2) Client sends handshake to port 30000. As with all communications to this service, 
 *    there must be no new-line characters (\n) ANYWHERE in the JSON being sent EXCEPT 
 *    for a single message terminator:
 * 
 * 
 *   {"magic": "JmolApp", "role": "out"}\n
 * 
 * where "out" here indicates that this socket is for Jmol (reply) output.
 *   
 * Jmol will reply with the 30-byte response: 
 *   
 *   {"type":"reply","reply":"OK"}\n
 *   
 * (The client may see only 29 bytes, as it may or may not strip the final \n.)
 *
 * Optionally, the client may also indicate a specified port for Jmol input. 
 * But typically this is just the currently active port. 
 *   
 *   {"magic": "JmolApp", "role": "in"}\n 
 *   
 *   Jmol will reply with 
 *   
 *   {"type": "reply", "reply": "OK"}\n;
 *
 *  
 * 3) Client sequentially sends Jmol script commands over the "in" socket:
 * 
 *   {"type": "command", "command": command}
 * 
 * where required command is some JSON-escaped string such as "rotate x 30" or "load $caffeine". 
 * For example:
 * 
 *   {"type": "command", "command": "var atoms = {_C or _H};select atoms"}\n
 *  
 * 
 * For the rest of this discussion, we will use the Jmol command that communicates with another Jmol instance
 * rather than this JSON context:
 * 
 *   SYNC 30000 "var atoms = {_C or _H};select atoms"
 *   
 * in this case.
 * 
 * 
 * 4) Jmol throughout this process is sending replies that come 
 *    from the Jmol Statuslistener class. For example:
 *    
 *  {"type":"reply","reply":"SCRIPT:script 8 started"}
 *  {"type":"reply","reply":"SCRIPT:Script completed"}
 *  {"type":"reply","reply":"SCRIPT:Jmol script terminated"}
 * 
 * Note that your client will be subscribed to many of the Jmol status callbacks 
 * (see org.openscience.jmol.app.jmolpanel.StatusListener), including:
 * 
 *    LOADSTRUCT
 *    ANIMFRAME
 *    SCRIPT
 *    ECHO
 *    PICK
 *    CLICK
 *    RESIZE
 *    ERROR
 *    MINIMIZATION
 *    STRUCTUREMODIFIED
 * 
 * All scripts and callback messages run in order but asynchronously in Jmol. You do not need
 * to wait for one script to be finished before issuing another; there is a queue that handles that.
 * If you want to be sure that a particular script has been run, simply add a MESSAGE command 
 * as its last part:
 *    
 *    sync 30000 "background blue;message The background is blue now"
 *  
 *  and it will appear as a SCRIPT callback:
 *  
 *     {"type":"reply","reply":"SCRIPT:The background is blue now"}
 *  
 *  after which you can handle that event appropriately.
 *  
 *  The SCRIPT callback can be particularly useful to monitor:
 *
 *   sync 30000 "backgrund blue"
 *   
 *  {"type":"reply","reply":"SCRIPT:script compiler ERROR: command expected\n----\n          >>>> backgrund blue <<<<"}
 *
 *  Note that the ERROR callback does not fire for compile errors, 
 *  only for errors found while running a parsed script:
 *  
 *  {"type":"reply","reply":"ERROR:ScriptException"}
 *   
 *  Note that all of these messages are "thumbnails" in the sense that they are just a message string. 
 *  You can subscribe to a full report for any of these callbacks using 'SYNC:ON' for the 
 *  callback function:
 *  
 *     set XxxxxCallback SYNC:ON
 *     
 *  For example, issuing
 *  
 *     sync 30000 "load $caffeine"
 *     
 *  gives the simple reply:
 *  
 *     {"type":"reply","reply":"LOADSTRUCT:https://cactus.nci.nih.gov/chemical/structure/caffeine/file?format=sdf&get3d=true"}
 *
 *  but after
 *  
 *     sync 30000 "set LoadStructCallback 'SYNC:ON'
 *  
 *  we get additional details, an array of data with nine elements:
 *  
 *  {"type":"reply","reply":["LOADSTRUCT",
 *                           "https://cactus.nci.nih.gov/chemical/structure/caffeine/file?format=sdf&get3d=true",
 *                           "file?format=sdf&get3d=true",
 *                           "C8H10N4O2", null, 3, "1.1", "1.1", null]}
 *  
 *  Exact specifications for these callbacks are not well documented. 
 *  See org.jmol.viewer.StatusManager code for details.
 *  
 *  Remove the callback listener using
 *  
 *     set XxxxxCallback SYNC:OFF
 *  
 *  Note that unlike Java, you get only one SYNC callback; this is not an array of listeners.
 *  
 *  
 * 5) Shutdown can be requested by sending
 *   
 *   {"type": "quit"}\n
 *  
 *  or by issuing the command
 *  
 *    sync 30000 "exitjmol"
 *    
 *   
 * Note that the Molecular Playground implemented an extensive set of gesture-handling methods 
 * that are also available via this interface. Many of these methods utilize the JmolViewer.syncScript() 
 * method, which directly manipulates the display as though someone were using a mouse.
 *   
 *   {"type" : "move", "style" : "rotate", "x" : deltaX, "y", deltaY }
 *   {"type" : "move", "style" : "translate", "x" : deltaX, "y", deltaY }
 *   {"type" : "move", "style" : "zoom", "scale" : scale }  (1.0 = 100%)
 *   {"type" : "sync", "sync" : syncText }
 *   {"type" : "touch", 
 *        "eventType" : eventType,
 *        "touchID"   : touchID,
 *        "iData"     : idata,
 *        "time"      : time, "x" : x, "y" : y, "z" : z }
 *    
 *   For details on the "touch" type, see org.jmol.viewer.ActionManagerMT::processEvent
 *   
 *   Note that all of the move and sync commands utilize the Jmol sync functionality originally 
 *   intended for applets. So any valid sync command may be used with the "sync" style. These include 
 *   essentially all the actions that a user can make with a mouse, including the
 *   following, where the notation <....> represents a number of a given type. These
 *   events interrupt any currently running script, just as with typical mouse actions.
 *   
 *   "centerAt <int:x> <int:y> <float:ptx> <float:pty> <float:ptz>"
 *      -- set {ptx,pty,ptz} at screen (x,y)
 *   "rotateMolecule <float:deltaX> <float:deltaY>"
 *   "rotateXYBy <float:deltaX> <float:deltaY>"
 *   "rotateZBy <int:degrees>"
 *   "rotateZBy <int:degrees> <int:x> <int:y>" (with center reset)
 *   "rotateArcBall <int:x> <int:y> <float:factor>"
 *   "spinXYBy <int:x> <int:y> <float:speed>"
 *      -- a "flick" gesture
 *   "translateXYBy <float:deltaX, float:deltaY>"
 *   "zoomBy <int:pixels>"
 *   "zoomByFactor <float:factor>"
 *   "zoomByFactor <float:factor> <int:x> <int:y>" (with center reset)
 * 
 * 
 * </code>
 */

JmolVersion="14.30.3" 

new feature: FAHReader  FAH:: reads FoldingAtHome Top.json and FrameNNN.json files
 -- FAH:: is required for Frame files but not the Top file.
 -- automatic calculation of structure using DSSP
 -- Both files are required; three load options:
    
    LOAD FILES "ViewerTop.json" + "ViewerFrame22.json" // explicit joining to two files
    
    LOAD ViewerTop.json; 
    LOAD XYZ FAH::ViewerFrame22.json   // first the atoms, then the coordinates
    
    LOAD FAH::ViewerFrame22.json        // just the coordinates with associated ViewerTop.json assumed present
    
 -- Subsequent calls to LOAD XYZ will replace coordinates and recalculate DSSP only.
 

JmolVersion="14.30.2"

bug fix: CrystalReader fails to read models in CRYSTAL17 double-walled nanotube file tn0.out

JmolVersion="14.30.1"

new feature: (undocumented) set picking dragMolecule
 -- acts like set picking dragSelected
 -- LEFT-drag to translate; ALT-LEFT-drag to rotate
 -- useful for two more molecules (covalently bonded units)

new feature: set picking dragModel
 -- acts like set picking dragMolecule or dragSelected
 -- LEFT-drag to translate; ALT-LEFT-drag to rotate
 -- useful for two more models not loaded using set appendNew FALSE


JmolVersion="14.30.0"


bug fix: CrystalReader for slab nanotubes.
 - note that we are not processing the nonstandard helical symmetry operations

Note - The move to a new minor version (14.30) is due to changes in the 
 ------ Jmol Java/SwingJS application, not the JavaScript version. In particular,
 ------ changes in the way the org.openscience.jmol.app classes are
 ------ organized required taking this step.

new feature: set minimizationMaxAtoms
  - maximum number of atoms allowed for MMFF minimization
  - defaults to 200

new feature: MEASURE SEARCH "{[H]}CC{[H]}"
  - uses SMARTS searching, selecting only the specified atoms 
    (in this case, all vicinal hydrogen atoms attached to carbon)
  - actually available but undocumented since 2013
  
new feature: SET MEASUREMENTUNITS HZ
  - for example, set measurementUnits HZ; MEASURE SEARCH "{[H]}CC{[H]}"  will display all 1H-1H coupling constants for a model
  - display calculated three-bond (standard vicinal) H-H J coupling constants (SMARTS {[H]}CC{[H]}) calculated
    using Haasnoot-Altona-Karplus substituent electronegativity-adjusted algorithm instead of distances 
  - If there are fewer than three substituents on each central atom, or if
    either central atom is not carbon, defaults to general Karplus equation.
  - see org.jmol.quantum.NMRCalculation.java for algorithm and bibliographic details 
  - expanded from use in solid-state NMR to any model EXCEPT magres files, 
    which instead use HZ in association with solid-state tensors    

new feature: SET MEASUREMENTUNITS NOE_HZ
  - adds NOE calculation for H atoms that are more then three bonds apart
    along with vicinal and geminal
  - not validated; from Janocchio 1.1 (https://sourceforge.net/projects/janocchio/)

new feature: Janocchio application included as a plugin (preliminary)
  - Java only; totally experimental; VERY preliminary
  - org.openscience.jmol.app.janocchio
  - required some refactoring of Jmol app classes
  - commit number 22001!

new feature: LOAD ... CENTROID
  - for molecular crystal structures
  - loads one or more unit cells (as specified by {nx ny nz})
    exploring covalent bonding so that molecules that have their centroid
    (center of geometry) within the specified block of cells are built.
  - available but undocumented since 2011
  - example: load =cod/1001253 {1 1 1} centroid
    note that {1 1 1} here is unnecessary, as it is the default
        
bug fix: "DOMReader" not "DOMReadaer" in File Manager
      
JmolVersion="14.29.55"

bug fix: show chemical image has no image
bug fix: dotted lines with antialiasing are too thin and half the spacing

JmolVersion="14.29.54"

new feature: ELLIPSOID ID xx axes [...] [...] [...]
new feature: ELLIPSOID ID xx axes [ [...][...][...] ]
new feature: ELLIPSOID ID xx axes [ pt pt pt ]
new feature: ELLIPSOID ID xx axes matrix3f
new feature: ELLIPSOID ID xx scale [ a b c ]
new feature: ELLIPSOID ID xx scale pt

new feature: set macroDirectory [default: https://chemapps.stolaf.edu/jmol/macros]
 - holds macros.json, which points to macro files
 - no longer hard-coded into Jmol
 
new feature: adds MACRO topond
new feature: adds MACRO crystal
new feature: adds MACRO topology	
new feature: adds filter "topos" to load command to allow for hypothetical unit cells with dimension a=1.

bug fix: symop(@1,@2,"matrix") should give an array of matricies, one for each relevant operation
bug fix: print (-0.0001).format("%3.2f") should print 0.00, not -0.00
bug fix: CRYSTAL reader fixes for TOPOND output 
bug fix: MOLDEN fix for allowing beta set to start with (nCoef + 1)

JmolVersion="14.29.53" 

bug fix: PyMOL PSE reader broken for broken PyMOL 2.3.0

JmolVersion="14.29.52" 

bug fix: CASTEP reader broken by Siesta %block check in Resolver


JmolVersion="14.29.51" 

bug fix: (undocumented) measure ID "xx" ... buggy

	-fixes measure vertical center when using ID
    -adds id, hidden, visible to getproperty measurementInfo

JmolVersion="14.29.50" 

bug fix: SiestaReader upgrade
bug fix: load =3dna/val   validation loading does not work

JmolVersion="14.29.49" 

bug fix: isosurface cutoff +0.3   does not work to indicate positive only for difference electron density maps
bug fix: load =3dna/val   validation loading does not work (same reason as 14.29.28)

JmolVersion="14.29.48" 

bug fix: LOAD xxxx:: broken in 14.29.25

JmolVersion="14.29.47" 

bug fix: standard PDB files (no hydrogens and no multiple bonds) should not require /aromaticPlanar/
         in search() selection. 

JmolVersion="14.29.46" 

bug fix: ModelKit menu broken in 14.29.45

JmolVersion="14.29.45" 

bug fix: Java applet fails with class not found / static reference error
bug fix: Spartan reader files missing from applet JAR collection
bug fix: SDF writing should preserve order of user data 

bug fix: symop(@3, @4, "array") should return the full set of all the operators that map atom 3 to atom 4

new feature  intersection(ptLine, vLine, ptCenter, radius)
  -- intersection of a line with a sphere -- return list of 0, 1, or 2 points

new feature: (array-of-hash).pivot(key)
 -- turns an array of hashes into a hash of arrays of hashes
 -- like a pivot table for an array, but based on the value of a hash 
    key within each hash element of the array, not the element itself 
 -- returns a (hash-of-arrays-of-hashes) of the array elements grouped 
    by the stringified values of the specified key.
 -- for example:
 
 	a = [
 	 {label:"C3", id:1},
 	 {label:"C3", id:2}, 
 	 {label:"C2", id:3}
 	 	]
 	 	
 	a.pivot("label") = {
 		"C3":[{label:"C3", id:1}, {label:"C3", id:2}],
 		"C2":[{label:"C2", id:3}]
 	 	}
 	
new feature: (array-of-hash).pivot(key1, key2, ...,sep)
 -- returns a (hash-of-array-of-hash) of the array elements grouped by the values of these keys, 
        combined as a string using the separator given as the last parameter
 -- for example:
 
 $ load =ams/halite 1 packed
 $ invariants = symop(@3,@3,"array")
 $ uniqueOps = invariants.pivot("label", "axispoint", "axisVector", "+")

 This code is cataloging all of operators of space group #255 (F m 3 m) that 
 leave atom 3 unchanged -- invariant. There are 48 such operations, but some of 
 them are about the same axis. The two rotations for a given C3 or C4 are now combined 
 into one element of uniqueOps, since they both have the same label, axispoint, and axisVector, 
 just different rotations.  
  
new feature: SHOW xxxx/!whatever
 -- show lines without whatever using /!

new feature ModelKit command
 -- particularly designed for crystallographic work
 -- turning the ModelKit on/off - same as SET modelKitMode:
 
   ModelKit (ON)
   ModelKit OFF
   
 -- configuration options include the following, where (xxx) is optional, CAPS is default:
  
 ModelKit  addHydrogens [TRUE|false]
 ModelKit  clickToSetElement [TRUE|false]
 ModelKit  showSymopInfo [TRUE|false]
      
 ModelKit  (mode) MOLECULAR
 ModelKit  (mode) view
 ModelKit  (mode)  edit
 ModelKit  
 ModelKit  (unitcell) EXTEND
 ModelKit  (unitcell) packed

 ModelKit  (edit) APPLYFULL
 ModelKit  (edit) applyLocal
 ModelKit  (edit) retainLocal
 ModelKit   ModelKit  
 ModelKit  (view) symop [n]
 ModelKit  (view) symop "x,-y,z"
 ModelKit  (view) symop [[4x4 matrix]]
   
 ModelKit  (view) offset {i j k}
   
 ModelKit  center @n
 ModelKit  center {point} (can be fractional by adding "/1" to at least one coord)
 ModelKit  center {atoms}

 ModelKit  (set) element [name or symbol]
      
   
 -- configuration options can be given sequentially within one ModelKit command or in individual commands
 
 
 -- examples:
 
  ModelKit mode view symop 5 center @3 
  ModelKit mode view symop 5 center @3 offset {0 0 0}   // unitized [0,1)

 -- action options include alternatives the commands in bold (ASSIGN is undocumented):
 
  ModelKit ROTATE ...  (for example, ROTATE BOND @1 @2 degrees)
  ModelKit ROTATESELECTED ...
  ModelKit ASSIGN ATOM @1 [symbol|pl|mi]
  ModelKit ASSIGN BOND @1 [0,1,2,3,4,5,p,m]
  ModelKit ASSIGN CONNECT @1 @2

new feature DRAW SYMOP @2 OFFSET {1 0 0}

 -- allows lattice OFFSET, where {0 0 0} is always into the unitcell [0, 1) 


bug fix: MINIMIZE CONSTRAINT for dihedral does not work.
new feature set mkAddHydrogens    default true; set false to not add H atoms when working with modelKitMode

JmolVersion="14.29.44" 

bug fix: 0 + {3.4, 0, 0} should give 3, not 0
bug fix: 

JmolVersion="14.29.43" 

bug fix: navigate TRACE does not work in JavaScript
bug fix: navigate TRACE followed by "quit" in console will not restart

JmolVersion="14.29.42" 

bug fix: MolReader not assigning _M.dimension to "2D" or "3D", just the overall auxiliaryInfo.dimension

JmolVersion="14.29.41" 

bug fix: CrystalReader does not skip over INFORMATION or WARNING line in CRYSTAL output files

bug fix: symop("x,y,z",{0 0 1}) does not return correct value for unit cells oriented by a b c axes

bug fix: OutputManager and FileManager fix for WRITE PDB "https://..." sending information to a server 

bug fix: JSmolJME.js miscodings cause error message in JSME

bug fix: nmr_predict_HC.htm not correlating signals to structure correctly

bug fix: JSpecView peak tabs for simulation or correlation in JmolJDX not proper width

JmolVersion="14.29.40" 

bug fix: centerAt AVERAGE fix

JmolVersion="14.29.39" 

new feature: capture SCRIPT "some script"
  - captures the given script
new feature: DELAY 1 while capturing inserts a one-second delay into the GIF animation
  - thus, the following is a +/-20-degree looping rock 
    around the Y axis with a 2-second wait at each end:
    
    CAPTURE "t.gif" LOOP SCRIPT "rotate y 20 20;delay 2;rotate y -40 -40;delay 2;rotate y 20 20;"
  
bug fix: JSpecView inline loading fails due to null file name assignment - now "[inline]"
bug fix: JSpecView inline loading does not save data needed for export SOURCE


JmolVersion="14.29.38" 

bug fix: ModelKit needs more slop for touch drag release and clicking

new feature: CRYSTAL TOPOND TRHO and TLAT reader
  -- reads critical point information in Bader analysis

JmolVersion="14.29.37" 

new feature: MO titleformat "...%3.1E"..." allows rounding of energy value
bug fix: (Java only) Jmol console does not accept paste with first character = '\n' 

JmolVersion="14.29.36" 

bug fix: getProperty("filecontents",filename) does not work.

JmolVersion="14.29.35" 

bug fix: Jmol.jar does not contain JSpecView class files

JmolVersion="14.29.34" 

bug fix: processing of MagneticCIF _space_group_magn.transform_BNS_Pp_abc  '-a+b,c,a+b;1/2,1,1/2'
         fails

JmolVersion="14.29.33" 

bug fix: (JavaScript only) in state creation for wireframe and measure 
          for integer Angstrom size, for example WIREFRAME 1.0

JmolVersion="14.29.32" 

bug fix: (JavaScript only) script with raw {...} expression fails to compile

JmolVersion="14.29.31" 

bug fix: (JavaScript only) ModelKit checkboxes broken in atom submenu. (JSmol jsmoljs/JmolMenu.js)

JmolVersion="14.29.30" 

RELEASE NOTE: JmolApplet*.jar Java files are no longer distributed in JSmol.zip. 
              See the main release zip file for these. 

bug fix: H--Y hydrogen bonds miscalculated due to length maximum miscoded in 14.29.27
    // JmolVersion="14.29.30" 01/27/2019 -- fixes bug of 10/29/2018

JmolVersion="14.29.29" 

new feature: print intersection(point vLine center radius) // 11/28/18
 - returns a list of 0 to 2 points representing the intersection of 
 - a line through point with vector vLine and a sphere of radius about center
 - allows for 3D building with constraints of a screen coordinate and a 
   distance from an atom
   
doc fix: intersection(point1 point2 point3) should be intersection(point1 vector1 point2)
 - closest point to point2 on a line through point1 in the direction vector1

bug fix: intersection() function changes value of point2   

bug fix: CrystalReader not reading vibration data for fragment calculation

JmolVersion="14.29.28"

bug fix: ModelKit appending broken in 14.29.25 10/10/18

new feature: assign atom "C" {2 2 2} 
 - adds an unbonded atom at the given position

JmolVersion="14.29.27"

new feature: CrystalReader auxiliary info:
 * 
 *  primitiveToCrystal  M3 transforming primitive lattice to conventional lattice
 *  
 *  mat4PrimitiveToCrystal  M4 for use in transforming symmetry operations
 *  
 *  mat4CrystalToPrimitive  M4 convenience inverse of mat4PrimitiveToCrystal
 *  
 *  fileSymmetryOperations  List<String> symmetry operators (primitive)
 *  
 *  Drawing primitive unitcell operations:
 *  
 *  ops = _M.fileSystemOperations
 *  
 *    DRAW SYMOP @{ops[2]}
 *  
 *  If using the conventional cell, you can use its operators, or you can
 *  limit yourself this primitive subset using:
 *  
 *    mp2c = _M.mat4PrimitiveToCrystal
 *  
 *    mc2p = _M.mat4CrystalToPrimitive
 *  
 *    DRAW SYMOP @{mc2p * ops[2] * mp2c}
 *
bug fix: CrystalReader not showing proper primitive cell with UNITCELL PRIMITIVE
bug fix: missing == for matrix3f and matrix4f
bug fix: draw symop with offset unitcell misses planes
bug fix: calculate hbond too generous for H--Y bond length -- max set at 2.2 Angstroms
bug fix: Jmol application "first frame" toolbar button broken
bug fix: script "inline" broken

JmolVersion="14.29.26"

bug fix: unitcell command with fractional translation fails
bug fix: CRYSTAL slab file can end up with emtpy-atom model

JmolVersion="14.29.25"

bug fix: MCIF (magnetic cif) reader does not handle symmetry operations with n/16.

JmolVersion="14.29.24"

bug fix: set language broken for Jmol application
bug fix: CRYSTAL reader can read one last 0-atom model
bug fix: 3-membered aziridine with non-H substituent should be chiral.
bug fix: isosurface "?" fails in JavaScript

JmolVersion="14.29.23"

bug fix: draw HKL {1 2 2} (undocumented) not working
bug fix: draw PLANE @pickedList  not working
bug fix: draw intercept unitcell PLANE @pickedList not working

JmolVersion="14.29.22"

bug fix: (JSmol only) menu items that are checkboxes do not work
    
https://sourceforge.net/p/jsmol/code/HEAD/tree/trunk/dist/tmp/coremenu.z.js?format=raw
https://sourceforge.net/p/jsmol/code/HEAD/tree/trunk/dist/tmp/corejsvmenu.z.js?format=raw

can be placed in j2s/core as a quick fix    

JmolVersion="14.29.21"

bug fix: set measurement 5 (integer; pixels) produces no line.
bug fix: polyhedra flat restored

JmolVersion="14.29.20"

feature change: removes (older, nonfunctional) NBO plug-in. (See GitHub Jmol-SwingJS)
new feature: allows plugin.properties to contain ";disabled", removing it from the Plug-In menu
new feature: adds ISOSURFACE [f1, filename1, f2, filename2, ...]
 - allows linear combination of isosurfaces
 - all grids must be identical (not checked internally - no error if this is not the case)
 - example is comparing crystal surface struture with and without binding of a surface molecule
 - e.g.   ISOSURFACE [1, "PtO.cube", -1, "Pt.cube", -1, "O.cube"]
 - can map a plane
 - e.g.   ISOSURFACE PLANE x=0.1 map [1, "PtO.cube", -1, "Pt.cube", -1, "O.cube"]
